"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ws_1 = require("./ws");
var argous = __importStar(require("../actions"));
var fieldsRedux_1 = require("../fieldsRedux");
var api_1 = require("../utils/api");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = require("react");
var react_redux_1 = require("react-redux");
var WebSocketComponent = /** @class */ (function (_super) {
    __extends(WebSocketComponent, _super);
    function WebSocketComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.connect = function () {
            ws_1.connectArgousWS();
            var argousWS = ws_1.getArgousWS();
            argousWS.onopen = function (event) {
                ws_1.enviaMensagem({ trn: 1 });
            };
            argousWS.onmessage = function (event) {
                var res = JSON.parse(event.data);
                _this.resolveTrn(res);
            };
        };
        _this.resolveTrn = function (res) {
            switch (res.trn) {
                case 3:
                    _this.resolveProcesso(res);
                    break;
                case 4:
                    _this.resolveNotificacao(res);
                    break;
                case 5:
                    _this.resolveMessage(res);
                    break;
                default:
            }
        };
        _this.resolveProcesso = function (res) {
            var _a = _this.props, setProcesso = _a.setProcesso, processos = _a.processos;
            var novoProcesso = true;
            var pAux = processos.map(function (i) {
                if (i.id === res.id) {
                    novoProcesso = false;
                    return res;
                }
                return i;
            });
            var pLength = pAux.length;
            if (novoProcesso && pLength !== 0) {
                pAux = pAux.concat(res);
            }
            setProcesso(pLength === 0
                ? [res]
                : pAux);
        };
        _this.resolveNotificacao = function (res) {
            try {
                var item = JSON.parse(res.notificacao[4]);
                if (item.link)
                    api_1.sendNotification({ id: res.notificacao[0], mensagem: item.mensagem, title: res.notificacao[3], icon: res.notificacao[1], link: item.link, dsLabel: item.dsLabel });
                else
                    throw new Error();
            }
            catch (error) {
                api_1.sendNotification(res.notificacao[4], res.notificacao[3], res.notificacao[1]);
            }
            finally {
                var setNotificacao = _this.props.setNotificacao;
                setNotificacao(res.notificacao);
            }
        };
        _this.resolveMessage = function (res) {
            var currentProgram = fieldsRedux_1.getCurrentProgram();
            if (res.pgCode === 'ChatContext') {
                _this.resolveChat(res);
                return;
            }
            if (currentProgram && res.pgCode === currentProgram) {
                var onMessage = fieldsRedux_1.getField('WSHandler').onMessage;
                onMessage && onMessage(res);
            }
            else {
                var onMessage = fieldsRedux_1.getField('WSHandler', 'onMessage', res.pgCode);
                onMessage && onMessage(res);
            }
        };
        _this.resolveChat = function (res) {
            var onMessage = fieldsRedux_1.getField('WSHandler', 'onMessage', 'argousSystem');
            onMessage && onMessage(res);
        };
        return _this;
    }
    WebSocketComponent.prototype.componentDidMount = function () {
        var _this = this;
        window.addEventListener('focus', function () {
            if (_this.props.usuarioLogado.nome) {
                _this.connect();
            }
        });
    };
    WebSocketComponent.prototype.componentDidUpdate = function (previousProps, previousState) {
        if (!previousProps.usuarioLogado.nome && this.props.usuarioLogado.nome) {
            this.connect();
        }
        if (previousProps.usuarioLogado.nome && !this.props.usuarioLogado.nome) {
            ws_1.disconnect();
        }
    };
    WebSocketComponent.prototype.componentWillUnmount = function () {
        ws_1.disconnect();
    };
    WebSocketComponent.prototype.render = function () {
        return null;
    };
    return WebSocketComponent;
}(react_1.Component));
WebSocketComponent.propTypes = {
    usuarioLogado: prop_types_1.default.object.isRequired,
    setProcesso: prop_types_1.default.func.isRequired,
    processos: prop_types_1.default.array
};
var mapStateToProps = function (state) {
    return { usuarioLogado: state.argous.usuarioLogado, processos: state.argous.processos };
};
var mapDispatchToProps = function (dispatch) {
    return {
        setNotificacao: function (data) { return dispatch(argous.setNotificacao(data)); },
        setProcesso: function (data) { return dispatch(argous.setProcesso(data)); }
    };
};
var WebSocket = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(WebSocketComponent);
exports.default = WebSocket;
