"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("../../api");
var utils_1 = require("../../utils");
var core_1 = require("@material-ui/core");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var useStyles = core_1.makeStyles(function (theme) { return ({
    orange: {
        color: theme.palette.getContrastText(core_1.colors.deepOrange[500]),
        backgroundColor: core_1.colors.deepOrange[500],
    },
    purple: {
        color: theme.palette.getContrastText(core_1.colors.deepPurple[500]),
        backgroundColor: core_1.colors.deepPurple[500],
    },
    blue: {
        color: theme.palette.getContrastText(core_1.colors.blue[500]),
        backgroundColor: core_1.colors.blue[500],
    },
    red: {
        color: theme.palette.getContrastText(core_1.colors.red[500]),
        backgroundColor: core_1.colors.red[500],
    },
    rosa: {
        color: theme.palette.getContrastText(core_1.colors.pink[500]),
        backgroundColor: core_1.colors.pink[500],
    },
    cinza: {
        color: theme.palette.getContrastText(core_1.colors.grey[500]),
        backgroundColor: core_1.colors.grey[500],
    },
    green: {
        color: theme.palette.getContrastText(core_1.colors.green[500]),
        backgroundColor: core_1.colors.green[500],
    },
    amarelo: {
        color: theme.palette.getContrastText(core_1.colors.yellow[500]),
        backgroundColor: core_1.colors.yellow[500],
    },
    marrom: {
        color: theme.palette.getContrastText(core_1.colors.brown[500]),
        backgroundColor: core_1.colors.brown[500],
    },
    preto: {
        color: theme.palette.getContrastText(core_1.colors.grey['A400']),
        backgroundColor: core_1.colors.grey['A400'],
    },
    img: {
        border: '2px solid #FFF'
    },
}); });
var ArgousAvatar = react_1.default.forwardRef(function (_a, ref) {
    var nome = _a.nome, src = _a.src, className = _a.className, idUsuario = _a.idUsuario, forwardedBlockSearch = _a.forwardedBlockSearch, props = __rest(_a, ["nome", "src", "className", "idUsuario", "forwardedBlockSearch"]);
    var classes = useStyles();
    var cores = [classes.orange, classes.purple, classes.blue, classes.rosa, classes.cinza, classes.red, classes.amarelo, classes.marrom, classes.preto, classes.green];
    var _b = react_1.useState(undefined), userImage = _b[0], setUserImage = _b[1];
    react_1.useEffect(function () {
        setUserImage(localStorage.getItem("imgUsuario-" + idUsuario) || '');
        if (!idUsuario || userImage || localStorage.getItem("imgUsuario-" + idUsuario) || (forwardedBlockSearch === null || forwardedBlockSearch === void 0 ? void 0 : forwardedBlockSearch.return))
            return;
        api_1.fetchToArgous('aguserimage', { idUsuario: idUsuario })
            .then(function (_a) {
            var userImage = _a.userImage;
            if (userImage) {
                setUserImage(userImage);
                localStorage.setItem("imgUsuario-" + idUsuario, userImage);
            }
            else
                localStorage.setItem("imgUsuario-" + idUsuario, '');
        });
    }, [idUsuario]);
    return react_1.default.createElement(core_1.Avatar, __assign({ ref: ref, className: className + " " + (src || userImage ? classes.img : cores[utils_1.getNumeroFromInitials(utils_1.getInitials(nome), cores.length)]) }, props, { src: src || userImage }), utils_1.getInitials(nome));
});
ArgousAvatar.propTypes = {
    nome: prop_types_1.default.string,
    src: prop_types_1.default.string,
    className: prop_types_1.default.string
};
exports.default = ArgousAvatar;
