"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var clsx_1 = __importDefault(require("clsx"));
var react_1 = __importStar(require("react"));
var md_1 = require("react-icons/md");
var useStyles = core_1.makeStyles(function (theme) { return ({
    pagination: {
        display: 'flex',
        flexDirection: 'row-reverse',
        color: theme.palette.text.primary,
        fontSize: theme.typography.pxToRem(14),
        overflow: 'auto',
        '&:last-child': {
            padding: 0,
        },
    },
    toolbar: {
        minHeight: 52,
        paddingRight: 2,
    },
    spacer: {
        flex: '1 1 100%',
    },
    caption: {
        flexShrink: 0,
    },
    selectRoot: {
        marginRight: 32,
        marginLeft: 8,
    },
    select: {
        paddingLeft: 8,
        paddingRight: 24,
        textAlign: 'right',
        textAlignLast: 'right',
    },
    input: {
        color: 'inherit',
        fontSize: 'inherit',
        flexShrink: 0,
    },
    actions: {
        flexShrink: 0,
        marginLeft: 20,
    },
    paginationActions: {
        flexShrink: 0,
        marginLeft: theme.spacing(2.5),
    },
}); });
var handleChangePgAtual = function (value, pages) {
    if (value < 1)
        return 0;
    else if (value > pages)
        return pages - 1;
    return value - 1;
};
var DefaultLabelDisplayedRows = function (_a) {
    var pages = _a.pages, page = _a.page, onChangePage = _a.onChangePage, from = _a.from, to = _a.to, count = _a.count, showCount = _a.showCount;
    return react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(core_1.Box, { padding: '1px 0px', display: 'inline' },
            react_1.default.createElement(core_1.InputBase, { inputProps: { type: 'number', min: 1, max: pages || 1, value: page + 1 }, onChange: function (e) { return onChangePage(e, handleChangePgAtual(e.target.value, pages)); } }), " / " + (pages || 1)),
        showCount && react_1.default.createElement("div", { style: { display: 'inline', marginLeft: '10px', paddingLeft: '10px' } },
            from,
            " a ",
            to,
            " de ",
            count));
};
var TablePaginationActions = react_1.memo(function (_a) {
    var count = _a.count, page = _a.page, rowsPerPage = _a.rowsPerPage, onChangePage = _a.onChangePage;
    var classes = useStyles();
    var theme = core_1.useTheme();
    var handleFirstPageButtonClick = function (e) { return onChangePage(e, 0); };
    var handleBackButtonClick = function (e) { return onChangePage(e, page - 1); };
    var handleNextButtonClick = function (e) { return onChangePage(e, page + 1); };
    var handleLastPageButtonClick = function (e) { return onChangePage(e, Math.max(0, Math.ceil(count / rowsPerPage) - 1)); };
    return (react_1.default.createElement("div", { className: classes.paginationActions },
        react_1.default.createElement(core_1.IconButton, { onClick: handleFirstPageButtonClick, disabled: page === 0 }, theme.direction === 'rtl' ? react_1.default.createElement(md_1.MdLastPage, null) : react_1.default.createElement(md_1.MdFirstPage, null)),
        react_1.default.createElement(core_1.IconButton, { onClick: handleBackButtonClick, disabled: page === 0 }, theme.direction === 'rtl' ? react_1.default.createElement(md_1.MdKeyboardArrowRight, null) : react_1.default.createElement(md_1.MdKeyboardArrowLeft, null)),
        react_1.default.createElement(core_1.IconButton, { onClick: handleNextButtonClick, disabled: page >= Math.ceil(count / rowsPerPage) - 1 }, theme.direction === 'rtl' ? react_1.default.createElement(md_1.MdKeyboardArrowLeft, null) : react_1.default.createElement(md_1.MdKeyboardArrowRight, null)),
        react_1.default.createElement(core_1.IconButton, { onClick: handleLastPageButtonClick, disabled: page >= Math.ceil(count / rowsPerPage) - 1 }, theme.direction === 'rtl' ? react_1.default.createElement(md_1.MdFirstPage, null) : react_1.default.createElement(md_1.MdLastPage, null))));
});
var ArgousComplexPagination = react_1.memo(function (_a) {
    var _b = _a.ActionsComponent, ActionsComponent = _b === void 0 ? TablePaginationActions : _b, 
    // backIconButtonProps,
    // backIconButtonText = 'Página Anterior',
    className = _a.className, count = _a.count, _c = _a.LabelDisplayedRows, LabelDisplayedRows = _c === void 0 ? DefaultLabelDisplayedRows : _c, _d = _a.labelRowsPerPage, labelRowsPerPage = _d === void 0 ? 'Linhas' : _d, 
    // nextIconButtonProps,
    // nextIconButtonText = 'Próxima Página',
    onChangePage = _a.onChangePage, onChangeRowsPerPage = _a.onChangeRowsPerPage, page = _a.page, rowsPerPage = _a.rowsPerPage, _e = _a.rowsPerPageOptions, rowsPerPageOptions = _e === void 0 ? [10, 25, 50, 100] : _e, _f = _a.SelectProps, SelectProps = _f === void 0 ? {} : _f, showCount = _a.showCount;
    var classes = useStyles();
    var MenuItemComponent = SelectProps.native ? 'option' : core_1.MenuItem;
    return (react_1.default.createElement("div", { className: clsx_1.default(classes.pagination, className) },
        react_1.default.createElement(core_1.Toolbar, { className: classes.toolbar },
            react_1.default.createElement("div", { className: classes.spacer }),
            rowsPerPageOptions.length > 1 && (react_1.default.createElement(core_1.Typography, { color: 'inherit', variant: 'body2', className: classes.caption }, labelRowsPerPage)),
            rowsPerPageOptions.length > 1 && (react_1.default.createElement(core_1.Select, __assign({ classes: {
                    select: classes.select,
                    icon: classes.selectIcon,
                }, input: react_1.default.createElement(core_1.InputBase, { className: clsx_1.default(classes.input, classes.selectRoot) }), value: rowsPerPage, onChange: onChangeRowsPerPage }, SelectProps), rowsPerPageOptions.map(function (rowsPerPageOption) { return (react_1.default.createElement(MenuItemComponent, { className: classes.menuItem, key: rowsPerPageOption.value ? rowsPerPageOption.value : rowsPerPageOption, value: rowsPerPageOption.value ? rowsPerPageOption.value : rowsPerPageOption }, rowsPerPageOption.label ? rowsPerPageOption.label : rowsPerPageOption)); }))),
            react_1.default.createElement(core_1.Typography, { color: 'inherit', variant: 'body2', component: 'div', className: classes.caption },
                react_1.default.createElement(LabelDisplayedRows, __assign({}, {
                    pages: Math.ceil(count / parseInt(rowsPerPage, 10)),
                    from: count === 0 ? 0 : page * rowsPerPage + 1,
                    to: count !== -1 ? Math.min(count, (page + 1) * rowsPerPage) : (page + 1) * rowsPerPage,
                    count: count === -1 ? -1 : count,
                    page: page, onChangePage: onChangePage, showCount: showCount
                }))),
            react_1.default.createElement(ActionsComponent, { className: classes.actions, 
                // backIconButtonProps={{
                //   title: backIconButtonText,
                //   ...backIconButtonProps,
                // }}
                count: count, 
                // nextIconButtonProps={{
                //   title: nextIconButtonText,
                //   ...nextIconButtonProps,
                // }}
                onChangePage: onChangePage, page: page, rowsPerPage: rowsPerPage }))));
});
exports.default = ArgousComplexPagination;
