"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomTooltip = void 0;
var ArgousComplexTable_1 = require("../ArgousComplexTable/ArgousComplexTable");
var core_1 = require("@material-ui/core");
var clsx_1 = __importDefault(require("clsx"));
var lodash_1 = require("lodash");
var react_1 = __importStar(require("react"));
var md_1 = require("react-icons/md");
var dist_1 = require("react-trello/dist/");
var useStyles = core_1.makeStyles(function (theme) { return ({
    dragHandle: {
        cursor: 'n-resize'
    },
    hover: {
        '&:hover': {
            backgroundColor: core_1.alpha(theme.palette.secondary.main, theme.palette.action.selectedOpacity * 2)
        }
    },
    open: {
        backgroundColor: core_1.alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity),
        '&:hover': {
            backgroundColor: core_1.alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity * 2),
        }
    },
    semDados: {
        padding: theme.spacing(1),
        paddingLeft: theme.spacing(2),
        fontSize: '1rem',
    },
    group: {
        '&>td': {
            padding: '0px',
            // '&:hover':{
            //   backgroundColor: theme.palette.action.selected
            // }
        }
    },
    loading: {
        textAlign: 'center',
        padding: '7px'
    }
}); });
var ArgousComplexTableBody = react_1.memo(function (_a) {
    var children = _a.children, line = _a.line, lineStyle = _a.lineStyle, handleOpenClose = _a.handleOpenClose, lineClass = _a.lineClass, enableCheck = _a.enableCheck, disableCheckIf = _a.disableCheckIf, columnStyles = _a.columnStyles, head = _a.head, onClick = _a.onClick, onDoubleClick = _a.onDoubleClick, indexToSelect = _a.indexToSelect, open = _a.open, dadosMostrados = _a.dadosMostrados, columnOptions = _a.columnOptions, lineTitle = _a.lineTitle, customKey = _a.customKey, columnProps = _a.columnProps, rowProps = _a.rowProps, enableDrag = _a.enableDrag, onDrop = _a.onDrop;
    var classes = useStyles();
    var _b = react_1.useContext(ArgousComplexTable_1.TableContext), lista = _b.lista, selected = _b.selected, dispatch = _b.dispatch, loading = _b.loading;
    var handleClick = function (name) {
        var selectedIndex = selected.indexOf(name);
        var newSelected = [];
        if (selectedIndex === -1)
            newSelected = newSelected.concat(selected, name);
        else if (selectedIndex === 0)
            newSelected = newSelected.concat(selected.slice(1));
        else if (selectedIndex === selected.length - 1)
            newSelected = newSelected.concat(selected.slice(0, -1));
        else if (selectedIndex > 0)
            newSelected = newSelected.concat(selected.slice(0, selectedIndex), selected.slice(selectedIndex + 1));
        dispatch({ type: 'setSelected', value: newSelected });
    };
    var isSelected = function (name) { return selected.indexOf(name) !== -1; };
    var getCellContent = function (coluna, linha, index, i) {
        if (columnOptions) {
            var item = columnOptions.filter(function (item) { return item.alias === index; });
            if (item.length > 0)
                return item[0].customJsx({ index: i, itemFormatado: line(linha)[index], linhaFormatada: line(linha), linhaOriginal: linha });
        }
        return coluna;
    };
    return (react_1.default.createElement(dist_1.Container, { dragHandleSelector: "." + classes.dragHandle, onDrop: onDrop, render: function (containerRef) {
            var _a;
            return (react_1.default.createElement(core_1.TableBody, { innerRef: containerRef }, loading ? (react_1.default.createElement(core_1.TableRow, null,
                react_1.default.createElement(core_1.TableCell, { className: classes.loading, colSpan: (dadosMostrados === null || dadosMostrados === void 0 ? void 0 : dadosMostrados.length) && ((_a = line(dadosMostrados[0])) === null || _a === void 0 ? void 0 : _a.length) + (enableCheck ? 1 : 0) + (enableDrag ? 1 : 0) },
                    react_1.default.createElement(core_1.CircularProgress, { disableShrink: true })))) : dadosMostrados.length ? dadosMostrados.map(function (linha, i) {
                var isItemSelected = isSelected(linha[indexToSelect]);
                var isItemOpen = i === open;
                var _a = rowProps({ index: i, linhaOriginal: linha, linhaFormatada: line(linha), itensSelecionados: selected }) || {}, title = _a.title, rowProperties = __rest(_a, ["title"]);
                return react_1.default.createElement(dist_1.Draggable, { key: customKey ? lista[i][customKey] : i, render: function (draggableRef) {
                        var _a;
                        var _b;
                        return (
                        //TODO criar proprio draggable pois esse remove classes do filho
                        react_1.default.createElement(react_1.Fragment, null,
                            react_1.default.createElement(exports.CustomTooltip, { title: lineTitle || title },
                                react_1.default.createElement(core_1.TableRow, __assign({ component: dist_1.Draggable }, rowProperties, { className: clsx_1.default((_a = {}, _a[classes.hover] = isItemSelected, _a[classes.open] = isItemOpen && !!children, _a), lineClass(line(linha), linha, i), rowProperties.className), hover: true, role: 'checkbox', tabIndex: -1, selected: isItemSelected, style: lineStyle ? lineStyle(linha, line(linha), i) : undefined, onClick: onClick ? function (e) { return onClick(e, linha, line(linha), i); } : children ? function () { return handleOpenClose(i); } : undefined, onDoubleClick: onDoubleClick ? function (e) { return onDoubleClick(e, linha, line(linha), i); } : undefined, innerRef: draggableRef }),
                                    enableDrag && react_1.default.createElement(core_1.TableCell, { padding: 'checkbox' },
                                        react_1.default.createElement(core_1.Tooltip, { title: 'Arrastar' },
                                            react_1.default.createElement(core_1.IconButton, { size: 'small', className: classes.dragHandle },
                                                react_1.default.createElement(md_1.MdDragHandle, null)))),
                                    enableCheck && react_1.default.createElement(core_1.TableCell, { padding: 'checkbox' },
                                        react_1.default.createElement(core_1.Checkbox, { disabled: disableCheckIf && disableCheckIf(linha, line(linha), i), onClick: function (e) {
                                                e.stopPropagation();
                                                handleClick(linha[indexToSelect]);
                                            }, checked: isItemSelected })),
                                    lodash_1.isArray(line(linha)) && line(linha).map(function (coluna, j) { return (react_1.default.createElement(core_1.TableCell, __assign({ key: j }, columnProps(j, coluna, linha, line(linha)), { style: columnStyles ? columnStyles[j] : undefined }), getCellContent(coluna, dadosMostrados[i], j, i))); }))),
                            children && (react_1.default.createElement(core_1.TableRow, { className: classes.group },
                                react_1.default.createElement(core_1.TableCell, { colSpan: (dadosMostrados === null || dadosMostrados === void 0 ? void 0 : dadosMostrados.length) && ((_b = line(dadosMostrados[0])) === null || _b === void 0 ? void 0 : _b.length) + (enableCheck ? 1 : 0) + (enableDrag ? 1 : 0), style: { padding: open === i ? 8 : 0 }, className: 'argous-complex-table-group-cell' },
                                    react_1.default.createElement(core_1.Collapse, { in: open === i, mountOnEnter: true, unmountOnExit: true }, typeof children === 'function' ? children({ linha: line(linha), linhaOriginal: linha, index: i }) : children))))));
                    } });
            }) : react_1.default.createElement(core_1.TableRow, null,
                react_1.default.createElement(core_1.Typography, { className: classes.semDados, component: 'td', variant: 'h6', colSpan: head.length + (enableCheck ? 1 : 0) }, "Nenhum dado a ser exibido"))));
        } }));
});
exports.default = ArgousComplexTableBody;
var CustomTooltip = function (_a) {
    var title = _a.title, children = _a.children;
    if (title)
        return react_1.default.createElement(core_1.Tooltip, { arrow: true, title: title }, children);
    return children;
};
exports.CustomTooltip = CustomTooltip;
