"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ArgousComplexTable_1 = require("../ArgousComplexTable/ArgousComplexTable");
var core_1 = require("@material-ui/core");
var clsx_1 = __importDefault(require("clsx"));
var lodash_1 = require("lodash");
var react_1 = __importStar(require("react"));
var useStyles = core_1.makeStyles(function (theme) { return ({
    highlight: {
        color: theme.palette.type === 'light' ? theme.palette.secondary.main : theme.palette.text.primary,
        backgroundColor: core_1.alpha(theme.palette.secondary.main, theme.palette.action.selectedOpacity * 2)
    },
    lighthighlight: {
        background: core_1.alpha(theme.palette.secondary.main, theme.palette.action.selectedOpacity)
    },
    visuallyHidden: {
        border: 0,
        clip: 'rect(0 0 0 0)',
        height: 1,
        margin: -1,
        overflow: 'hidden',
        padding: 0,
        position: 'absolute',
        top: 20,
        width: 1,
    }
}); });
var ArgousComplexTableHead = react_1.memo(function (_a) {
    var _b;
    var numSelected = _a.numSelected, rowCount = _a.rowCount, head = _a.head, enableCheck = _a.enableCheck, disableCheckIf = _a.disableCheckIf, line = _a.line, size = _a.size, headerColumnStyles = _a.headerColumnStyles, disableSorting = _a.disableSorting, ordCols = _a.ordCols, cortaDados = _a.cortaDados, enableDrag = _a.enableDrag;
    var classes = useStyles();
    var _c = react_1.useContext(ArgousComplexTable_1.TableContext), selected = _c.selected, order = _c.order, orderBy = _c.orderBy, dispatch = _c.dispatch, lista = _c.lista, indexToSelect = _c.indexToSelect, method = _c.method, externalCtrlPgn = _c.externalCtrlPgn;
    var handleRequestSort = function (property) {
        var isAsc = orderBy === property && order === 'asc';
        dispatch({ type: 'setOrder', value: isAsc ? 'desc' : 'asc' });
        dispatch({ type: 'setOrderBy', value: property });
    };
    var length = react_1.useMemo(function () { return disableCheckIf ? lista.reduce(function (acc, linha, i) { return !disableCheckIf(linha, line(linha), i) ? acc + 1 : acc; }, 0) : size; }, [disableCheckIf, lista, size, line]);
    var handleSelectAllClick = function (event) {
        if (event.target.checked) {
            if (!method && !externalCtrlPgn && (selected.length === 0))
                dispatch({ type: 'setSelected', value: cortaDados(lista).filter(function (linha, i) { return disableCheckIf ? !disableCheckIf(linha, line(linha), i) : true; }).map(function (n) { return n[indexToSelect]; }) });
            else if (selected.length < length)
                dispatch({ type: 'setSelected', value: lista.filter(function (linha, i) { return disableCheckIf ? !disableCheckIf(linha, line(linha), i) : true; }).map(function (n) { return n[indexToSelect]; }) });
            else
                dispatch({ type: 'setSelected', value: [] });
        }
        else
            dispatch({ type: 'setSelected', value: [] });
    };
    return (react_1.default.createElement(core_1.TableHead, null,
        react_1.default.createElement(core_1.TableRow, { className: clsx_1.default((_b = {},
                _b[classes.highlight] = (((numSelected === rowCount) || (numSelected === length) || (numSelected === (lista === null || lista === void 0 ? void 0 : lista.length))) && (rowCount && length)),
                _b[classes.lighthighlight] = ((numSelected > 0) && ((method || externalCtrlPgn) ? (numSelected < (lista === null || lista === void 0 ? void 0 : lista.length)) : (numSelected < rowCount))),
                _b)) },
            enableDrag && react_1.default.createElement(core_1.TableCell, { padding: 'checkbox' }),
            enableCheck && react_1.default.createElement(core_1.TableCell, { padding: 'checkbox' },
                react_1.default.createElement(core_1.Checkbox, { disabled: !length, indeterminate: (method || externalCtrlPgn) ? ((numSelected > 0) && (numSelected < (lista === null || lista === void 0 ? void 0 : lista.length))) : ((numSelected > 0) && (numSelected < length)), checked: (method || externalCtrlPgn) ? ((rowCount > 0) && ((numSelected === rowCount) || (numSelected === (lista === null || lista === void 0 ? void 0 : lista.length)))) : ((rowCount > 0) && length && (numSelected === length)), onChange: handleSelectAllClick })),
            lodash_1.isArray(head) && head.map(function (item, i) { return (react_1.default.createElement(core_1.TableCell, { key: i, style: headerColumnStyles ? headerColumnStyles[i] : undefined }, (disableSorting[i] || (ordCols && !ordCols[i])) ?
                item
                :
                    react_1.default.createElement(core_1.TableSortLabel, { active: orderBy === i, direction: orderBy === i ? order : 'asc', onClick: function () { return handleRequestSort(i); } },
                        item,
                        orderBy === i ? (react_1.default.createElement("span", { className: classes.visuallyHidden }, order === 'desc' ? 'sorted descending' : 'sorted ascending')) : null))); }))));
});
exports.default = ArgousComplexTableHead;
