"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ArgousComplexTable_1 = require("../ArgousComplexTable/ArgousComplexTable");
var core_1 = require("@material-ui/core");
var clsx_1 = __importDefault(require("clsx"));
var lodash_1 = require("lodash");
var react_1 = __importStar(require("react"));
var useStyles = core_1.makeStyles(function (theme) { return ({
    toolbar: {
        minHeight: 0,
        paddingLeft: theme.spacing(2),
        paddingRight: theme.spacing(1),
    },
    highlight: {
        color: theme.palette.type === 'light' ? theme.palette.secondary.main : theme.palette.text.primary,
        backgroundColor: core_1.alpha(theme.palette.secondary.main, theme.palette.action.selectedOpacity * 2)
    },
    title: {
        flex: '1 1 100%',
        lineHeight: '50px'
    }
}); });
var ArgousComplexTableToolBar = react_1.memo(function (_a) {
    var _b;
    var numSelected = _a.numSelected, actions = _a.actions, title = _a.title, disableFilter = _a.disableFilter, filterLabel = _a.filterLabel, lista = _a.lista, indexToSelect = _a.indexToSelect, fixedToolbar = _a.fixedToolbar;
    var classes = useStyles();
    var _c = react_1.useContext(ArgousComplexTable_1.TableContext), selected = _c.selected, dispatch = _c.dispatch;
    var filterTime = react_1.useRef();
    var handleChange = function (e) {
        var value = e.target.value;
        clearTimeout(filterTime.current);
        filterTime.current = setTimeout(function () {
            dispatch({ type: 'setFilter', value: value });
        }, 300);
    };
    return (react_1.default.createElement(core_1.Toolbar, { className: clsx_1.default(classes.toolbar, (_b = {}, _b[classes.highlight] = numSelected > 0, _b)) },
        numSelected > 0 ? (react_1.default.createElement(core_1.Typography, { className: classes.title, color: 'inherit', variant: 'subtitle1', component: 'div' },
            numSelected,
            " ",
            numSelected === 1 ? 'selecionado' : 'selecionados')) : react_1.default.createElement(core_1.Grid, { container: true, spacing: 2, style: { marginRight: 0 } },
            title && react_1.default.createElement(core_1.Grid, { item: true, xs: true, style: { display: 'flex', alignItems: 'center' } },
                react_1.default.createElement(core_1.Typography, { className: classes.title, variant: 'h6', component: 'div' }, title)),
            !disableFilter && react_1.default.createElement(core_1.Grid, { item: true, xs: true },
                react_1.default.createElement(core_1.TextField, { label: filterLabel, fullWidth: true, margin: 'dense', variant: 'outlined', onChange: handleChange }))),
        (fixedToolbar || numSelected > 0) && lodash_1.isArray(actions) && actions.map(function (action, i) { return (react_1.default.createElement(core_1.Tooltip, { key: i, title: action[0] },
            react_1.default.createElement(core_1.IconButton, { onClick: function (e) { return action[2](selected, e, lista.filter(function (linha) { return selected.indexOf(linha[indexToSelect]) > -1; })); } }, action[1]))); })));
});
exports.default = ArgousComplexTableToolBar;
