"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("..");
var ThreadLog_1 = __importDefault(require("../../components/ThreadLog"));
var utils_1 = require("../../utils");
var core_1 = require("@material-ui/core");
var clsx_1 = __importDefault(require("clsx"));
var lodash_1 = require("lodash");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var ai_1 = require("react-icons/ai");
var fa_1 = require("react-icons/fa");
var md_1 = require("react-icons/md");
var useStyles = core_1.makeStyles(function (theme) { return ({
    root: {
        zIndex: 0,
        margin: '-11px',
        marginBottom: 0,
        overflow: 'auto',
        width: 'calc(100% + 22px)',
        paddingRight: theme.spacing(2),
        paddingLeft: theme.spacing(2),
        '&::-webkit-scrollbar': {
            height: 5
        },
        '&::-webkit-scrollbar-track': {
            background: '#0000'
        },
        '&::-webkit-scrollbar-thumb': {
            background: '#0000'
        },
        '&:hover': {
            '&::-webkit-scrollbar-thumb': {
                background: theme.palette.type === 'light' ? 'rgba(0, 0, 0, 0.05)' : 'rgba(255, 255, 255, 0.05)'
            }
        }
    },
    menuButton: {
        marginRight: theme.spacing(2),
    },
    menuSelected: {
        backgroundColor: theme.palette.action.selected
    },
    title: {
        flexGrow: function (_a) {
            var habNavegador = _a.habNavegador;
            return habNavegador ? 0 : 1;
        },
    },
    navigator: {
        flexGrow: 1,
        marginLeft: theme.spacing(2)
    }
}); });
var ToolbarTooltip = core_1.withStyles({
    popper: {
        zIndex: 1300
    }
})(core_1.Tooltip);
var CustomTooltip = function (_a) {
    var disabled = _a.disabled, arrow = _a.arrow, placement = _a.placement, title = _a.title, children = _a.children;
    var _b = react_1.useState(false), open = _b[0], setOpen = _b[1];
    react_1.useEffect(function () { return (disabled && open) && setOpen(false); }, [disabled, open]);
    return (react_1.default.createElement(ToolbarTooltip, __assign({}, { arrow: arrow, placement: placement, title: title }, { onOpen: function () { return (!disabled) && setOpen(true); }, onClose: function () { return setOpen(false); }, open: open }), children));
};
var ButtonLoadingFeedback = function (_a) {
    var _b = _a.size, size = _b === void 0 ? 24 : _b, _c = _a.color, color = _c === void 0 ? 'secondary' : _c;
    return react_1.default.createElement(core_1.CircularProgress, __assign({}, { size: size, color: color }));
};
function BarraFerramentas(_a) {
    var titulo = _a.titulo, _b = _a.abas, abas = _b === void 0 ? [] : _b, _c = _a.ferramentas, ferramentas = _c === void 0 ? [] : _c, _d = _a.habFavorito, habFavorito = _d === void 0 ? true : _d, _e = _a.habCrud, habCrud = _e === void 0 ? false : _e, _f = _a.habNavegador, habNavegador = _f === void 0 ? false : _f, checkIfIsFavorite = _a.checkIfIsFavorite, addFavorite = _a.addFavorite, favoriteAnimationInsert = _a.favoriteAnimationInsert, favoriteAnimationRemove = _a.favoriteAnimationRemove, nmFuncaoVoltar = _a.nmFuncaoVoltar, nmCompartilhar = _a.nmCompartilhar, _g = _a.linkCompartilhamento, linkCompartilhamento = _g === void 0 ? '' : _g, threads = _a.threads, currentProgram = _a.currentProgram, nmSalva = _a.nmSalva, nmExclui = _a.nmExclui, _h = _a.executaFuncao, executaFuncao = _h === void 0 ? function (prm) { return void (prm); } : _h, _j = _a.habWidget, habWidget = _j === void 0 ? false : _j, _k = _a.addWidget, addWidget = _k === void 0 ? function () { return ''; } : _k, _l = _a.snAnotacaoPrograma, snAnotacaoPrograma = _l === void 0 ? false : _l, _m = _a.openAnnotations, openAnnotations = _m === void 0 ? function () { return ''; } : _m, _o = _a.toolbarLoading, toolbarLoading = _o === void 0 ? {} : _o;
    var classes = useStyles({ habNavegador: habNavegador });
    var anchorMenu = react_1.useRef(null);
    var anchorCompartilhar = react_1.useRef(null);
    var _p = react_1.useState(false), open = _p[0], setOpen = _p[1];
    var _q = react_1.useState(undefined), abaAtual = _q[0], setAbaAtual = _q[1];
    var _r = react_1.useState(true), habEditar = _r[0], setHabEditar = _r[1];
    var _s = react_1.useState(false), habSalvar = _s[0], setHabSalvar = _s[1];
    var _t = react_1.useState(false), habExcluir = _t[0], setHabExcluir = _t[1];
    var _u = react_1.useState(false), openCompartilhar = _u[0], setOpenCompartilhar = _u[1];
    var _v = react_1.useState(false), disableTooltip = _v[0], setDisableTooltip = _v[1];
    react_1.useEffect(function () {
        if (anchorMenu.current)
            anchorMenu.current.focus();
    }, [open]);
    var previousAbas = utils_1.usePrevious(abas);
    react_1.useEffect(function () {
        if (lodash_1.isEqual(abas, previousAbas))
            return;
        if (!abas.length)
            setAbaAtual(undefined);
        else
            for (var i = 0; i < (abas === null || abas === void 0 ? void 0 : abas.length); i++) {
                var aba = abas[i];
                if (aba[1] === 'active') {
                    setAbaAtual(aba[0]);
                    break;
                }
            }
    }, [abas, previousAbas]);
    var toggleAbas = function () {
        setOpen(function (prevOpen) { return !prevOpen; });
    };
    var toggleCompartilhar = function (e) {
        e.stopPropagation();
        setOpenCompartilhar(function (o) { return !o; });
        executaFuncao(nmCompartilhar);
    };
    var closeCompartilhar = function (event) {
        var _a;
        if (anchorCompartilhar.current && ((_a = anchorCompartilhar === null || anchorCompartilhar === void 0 ? void 0 : anchorCompartilhar.current) === null || _a === void 0 ? void 0 : _a.contains(event.target)))
            return;
        setOpenCompartilhar(false);
    };
    var selecionaAba = function (index, item, alias) { return function (event) {
        var _a;
        if (anchorMenu.current && ((_a = anchorMenu === null || anchorMenu === void 0 ? void 0 : anchorMenu.current) === null || _a === void 0 ? void 0 : _a.contains(event.target)))
            return;
        if (lodash_1.isString(item))
            setAbaAtual(item);
        if (lodash_1.isNumber(index))
            executaFuncao(alias || "T" + index);
        setOpen(false);
    }; };
    function handleListKeyDown(event) {
        if (event.key === 'Tab') {
            event.preventDefault();
            setOpen(false);
        }
    }
    function handleAnnotationsClick(event) {
        setDisableTooltip(true);
        openAnnotations(event);
        setTimeout(function () { return setDisableTooltip(false); }, 0);
    }
    var getFerramentas = function (item, index) {
        return (react_1.default.createElement(CustomTooltip, { key: index, title: item[1] || '' },
            react_1.default.createElement(core_1.IconButton, { onClick: function () { return lodash_1.isFunction(item[2]) ? item[2]() : executaFuncao(item[2] || 'F' + index); } }, typeof item[0] === 'string' ? (react_1.default.createElement("i", { style: { color: '#999' }, className: item[0] })) : (item[0]))));
    };
    return react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(core_1.Toolbar, { className: classes.root, variant: 'dense' },
            (lodash_1.isArray(abas) && abas.length > 0) && (react_1.default.createElement(core_1.IconButton, { id: 'botaoAbasBarraFerramentas', ref: anchorMenu, onClick: toggleAbas, className: classes.menuButton },
                react_1.default.createElement(md_1.MdFormatListBulleted, null))),
            react_1.default.createElement(core_1.Popper, { open: open, anchorEl: anchorMenu.current, role: undefined, transition: true, keepMounted: true, style: { zIndex: 2, marginLeft: 10 } }, function (_a) {
                var TransitionProps = _a.TransitionProps;
                return (react_1.default.createElement(core_1.Collapse, { in: TransitionProps.in, timeout: 100 },
                    react_1.default.createElement(core_1.Paper, { style: { maxHeight: '80vh', overflowY: 'auto' } },
                        react_1.default.createElement(core_1.ClickAwayListener, { onClickAway: selecionaAba() },
                            react_1.default.createElement(core_1.MenuList, { autoFocusItem: open, onKeyDown: handleListKeyDown }, lodash_1.isArray(abas) && abas.map(function (item, key) {
                                var _a;
                                return (react_1.default.createElement(core_1.MenuItem, { className: clsx_1.default((_a = {}, _a[classes.menuSelected] = abaAtual === item[0], _a)), key: key, onClick: selecionaAba(key, item[0], item[2]) }, item[0]));
                            }))))));
            }),
            react_1.default.createElement(core_1.Typography, { component: 'div', variant: 'h6', className: classes.title }, (abaAtual) ? (react_1.default.createElement(core_1.Typography, { variant: 'subtitle1' },
                abaAtual,
                " ",
                react_1.default.createElement(core_1.Typography, { variant: 'caption' },
                    "( ",
                    titulo,
                    " )"))) : (react_1.default.createElement(core_1.Typography, { variant: 'subtitle1' }, titulo))),
            (habNavegador) && (react_1.default.createElement(core_1.Box, { className: classes.navigator },
                react_1.default.createElement(CustomTooltip, { title: 'Primeiro registro' },
                    react_1.default.createElement(core_1.IconButton, { size: 'small', onClick: function () { return executaFuncao('NF'); } },
                        react_1.default.createElement(md_1.MdFirstPage, null))),
                react_1.default.createElement(CustomTooltip, { title: 'Registro anterior' },
                    react_1.default.createElement(core_1.IconButton, { size: 'small', onClick: function () { return executaFuncao('NP'); } },
                        react_1.default.createElement(md_1.MdKeyboardArrowLeft, null))),
                react_1.default.createElement(CustomTooltip, { title: 'Pr\u00F3ximo registro' },
                    react_1.default.createElement(core_1.IconButton, { size: 'small', onClick: function () { return executaFuncao('NN'); } },
                        react_1.default.createElement(md_1.MdKeyboardArrowRight, null))),
                react_1.default.createElement(CustomTooltip, { title: '\u00DAltimo registro' },
                    react_1.default.createElement(core_1.IconButton, { size: 'small', onClick: function () { return executaFuncao('NL'); } },
                        react_1.default.createElement(md_1.MdLastPage, null))))),
            (lodash_1.isArray(ferramentas)) && ferramentas.map(function (g) { return g.map(function (item, index) { return getFerramentas(item, index); }); }),
            (nmFuncaoVoltar) && (react_1.default.createElement(CustomTooltip, { title: 'Voltar' },
                react_1.default.createElement(core_1.IconButton, { onClick: function () { return executaFuncao(nmFuncaoVoltar); } },
                    react_1.default.createElement(md_1.MdArrowBack, null)))),
            (habCrud) && react_1.default.createElement(react_1.default.Fragment, null, (habEditar) ? (react_1.default.createElement(CustomTooltip, { title: 'Editar' },
                react_1.default.createElement(core_1.IconButton, { onClick: function () {
                        setHabEditar(false);
                        setHabSalvar(true);
                        setHabExcluir(true);
                    } },
                    react_1.default.createElement(md_1.MdEdit, null)))) : (react_1.default.createElement(core_1.ClickAwayListener, { onClickAway: function () {
                    setHabEditar(true);
                    setHabSalvar(false);
                    setHabExcluir(false);
                } },
                react_1.default.createElement(core_1.Box, null,
                    (habSalvar) && (react_1.default.createElement(CustomTooltip, { title: 'Salvar Registro' },
                        react_1.default.createElement(core_1.IconButton, { onClick: function () { return executaFuncao(nmSalva); } },
                            react_1.default.createElement(md_1.MdSave, null)))),
                    (habExcluir) && (react_1.default.createElement(CustomTooltip, { title: 'Excluir Registro' },
                        react_1.default.createElement(core_1.IconButton, { onClick: function () { return executaFuncao(nmExclui); } },
                            react_1.default.createElement(md_1.MdDelete, null)))))))),
            (nmCompartilhar) && (react_1.default.createElement(CustomTooltip, { title: 'Compartilhar' },
                react_1.default.createElement(core_1.IconButton, { ref: anchorCompartilhar, onClick: toggleCompartilhar },
                    react_1.default.createElement(md_1.MdShare, null)))),
            react_1.default.createElement(core_1.Popper, { open: openCompartilhar, anchorEl: anchorCompartilhar.current, role: undefined, transition: true, keepMounted: true, style: { zIndex: 2, marginRight: 10 } }, function (_a) {
                var TransitionProps = _a.TransitionProps;
                return (react_1.default.createElement(core_1.Collapse, { in: TransitionProps.in, timeout: 100 },
                    react_1.default.createElement(core_1.ClickAwayListener, { onClickAway: closeCompartilhar },
                        react_1.default.createElement(__1.Compartilhar, __assign({}, { linkCompartilhamento: linkCompartilhamento })))));
            }),
            (lodash_1.isArray(threads)) && threads.map(function (thread, key) { return react_1.default.createElement(ThreadLog_1.default, __assign({}, { key: key, thread: thread, currentProgram: currentProgram })); }),
            (habWidget) && (react_1.default.createElement(CustomTooltip, { title: 'Adicionar widget' },
                react_1.default.createElement(core_1.IconButton, { onClick: addWidget },
                    react_1.default.createElement(ai_1.AiOutlineAppstoreAdd, null)))),
            (snAnotacaoPrograma) && (react_1.default.createElement(CustomTooltip, { title: 'Anota\u00E7\u00F5es', disabled: disableTooltip },
                react_1.default.createElement(core_1.IconButton, { disabled: toolbarLoading === null || toolbarLoading === void 0 ? void 0 : toolbarLoading.annotations, onClick: handleAnnotationsClick }, (toolbarLoading === null || toolbarLoading === void 0 ? void 0 : toolbarLoading.annotations) ? react_1.default.createElement(ButtonLoadingFeedback, null) : react_1.default.createElement(md_1.MdEditNote, null)))),
            (habFavorito && checkIfIsFavorite) && (react_1.default.createElement(CustomTooltip, { title: 'Favorito' },
                react_1.default.createElement(core_1.IconButton, { onClick: addFavorite },
                    react_1.default.createElement(fa_1.FaStar, { className: "pg-fav-start " + checkIfIsFavorite() }),
                    favoriteAnimationInsert && react_1.default.createElement(fa_1.FaStar, { className: 'pg-fav-start active insertion-star-fav' }),
                    favoriteAnimationRemove && react_1.default.createElement(fa_1.FaStar, { className: 'pg-fav-start active removing-star-fav' }))))),
        react_1.default.createElement(core_1.Divider, { style: { marginBottom: 10 } }));
}
BarraFerramentas.propTypes = {
    titulo: prop_types_1.default.string,
    ferramentas: prop_types_1.default.array,
    abas: prop_types_1.default.array,
    executaFuncao: prop_types_1.default.func,
    nmFuncaoVoltar: prop_types_1.default.string,
    nmCompartilhar: prop_types_1.default.string,
    habFavorito: prop_types_1.default.bool,
    habNavegador: prop_types_1.default.bool,
    habCrud: prop_types_1.default.bool,
    nmSalva: prop_types_1.default.string,
    nmExclui: prop_types_1.default.string,
    addFavorite: prop_types_1.default.func,
    favoriteAnimationInsert: prop_types_1.default.bool,
    favoriteAnimationRemove: prop_types_1.default.bool,
    linkCompartilhamento: prop_types_1.default.string,
    threads: prop_types_1.default.array,
    currentProgram: prop_types_1.default.string,
    habWidget: prop_types_1.default.bool,
    addWidget: prop_types_1.default.func
};
exports.default = BarraFerramentas;
