"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fieldsRedux_1 = require("../../fieldsRedux");
var utils_1 = require("../../utils");
var date_1 = require("../../utils/date");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var react_date_range_1 = require("react-date-range");
/**
 * @deprecated
 */
var Calendar = /** @class */ (function (_super) {
    __extends(Calendar, _super);
    function Calendar() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            open: false,
            month: 0
        };
        _this.openCalendar = function (e) {
            e.stopPropagation();
            _this.setState({ open: true });
            setTimeout(function () { return document.addEventListener('click', _this.handleClickCalendar); }, 0);
        };
        _this.handleClickCalendar = function (e) {
            var eCls = e.target.className;
            var eClsP = e.target.parentNode.className;
            var prev = eCls !== 'rdr-MonthAndYear-button next' && eClsP !== 'rdr-MonthAndYear-button next';
            var next = eCls !== 'rdr-MonthAndYear-button prev' && eClsP !== 'rdr-MonthAndYear-button prev';
            if (next && prev) {
                _this.setState({ open: false });
                document.removeEventListener('click', _this.handleClickCalendar);
            }
            else {
                var month = _this.state.month;
                var newMonth = next
                    ? month + 1
                    : month - 1;
                newMonth = newMonth < 0
                    ? 11
                    : newMonth > 11
                        ? 0
                        : newMonth;
                _this.setState({ month: newMonth });
                _this.setMonthName(null, newMonth);
            }
        };
        _this.checkDefaultValue = function (defaultValue) {
            if (defaultValue && defaultValue.length === 10) {
                if (!defaultValue.indexOf('-')) {
                    var newDefVal = defaultValue.substring(8, 10) + "/" + defaultValue.substring(5, 7) + "/" + defaultValue.substring(0, 4);
                    return newDefVal;
                }
            }
            return defaultValue;
        };
        _this.setMonthState = function (value) {
            var month;
            if (value) {
                if (value.length === 10) {
                    month = value.substring(3, 5);
                }
                else {
                    var field = _this.props.field;
                    console.error("Valor da data inv\u00E1lido no campo " + field + ". Formatos aceitos s\u00E3o 'dd/mm/aaaa' ou 'aaaa-mm-dd'");
                }
            }
            else {
                month = new Date().getMonth();
            }
            _this.setState({ month: month });
        };
        _this.handleSelect = function (date) {
            var onChange = _this.props.onChange;
            var day = date._d.getDate();
            var month = (date._d.getMonth() + 1);
            var year = date._d.getFullYear();
            var formattedDate = utils_1.addExtraZero(day) + "/" + utils_1.addExtraZero(month) + "/" + year;
            if (onChange) {
                onChange(year, month, day);
            }
            _this.props.handleUpdates(formattedDate);
            _this.setState({ open: false });
        };
        _this.setMonthName = function (date, month) {
            if (date) {
                _this.setState({ month: date._d.getMonth() });
            }
            var name = date_1.getMonthName(typeof month !== 'undefined'
                ? month
                : date._d.getMonth());
            var monthDescription = document.getElementsByClassName('rdr-MonthAndYear-month')[0];
            monthDescription.innerHTML = name;
        };
        return _this;
    }
    Calendar.prototype.componentDidMount = function () {
        var _this = this;
        var _a = this.props, field = _a.field, defaultValue = _a.defaultValue;
        var defValHandled = this.checkDefaultValue(defaultValue);
        fieldsRedux_1.initField(field, defValHandled).then(function (value) {
            _this.setMonthState(value);
        });
    };
    Calendar.prototype.componentWillUnmount = function () {
        document.removeEventListener('click', this.handleClickCalendar);
    };
    Calendar.prototype.render = function () {
        var _a = this, openCalendar = _a.openCalendar, handleSelect = _a.handleSelect, setMonthName = _a.setMonthName;
        var open = this.state.open;
        var field = this.props.field;
        var date = fieldsRedux_1.getField(field, 'value');
        return (react_1.default.createElement("div", { className: 'argous-calendar' },
            react_1.default.createElement("span", { onMouseUp: openCalendar }, date ? date : 'dd/mm/aaaa'),
            open && (react_1.default.createElement(react_date_range_1.Calendar, { date: date, onChange: handleSelect, onInit: setMonthName }))));
    };
    return Calendar;
}(react_1.Component));
Calendar.propTypes = {
    field: prop_types_1.default.string.isRequired,
    defaultValue: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string, prop_types_1.default.object, prop_types_1.default.array]),
    ajax: prop_types_1.default.bool,
    action: prop_types_1.default.string,
    dados: prop_types_1.default.object,
    sendUpdates: prop_types_1.default.array,
    receiveUpdates: prop_types_1.default.array,
    onFieldSuccess: prop_types_1.default.func,
    onActionSuccess: prop_types_1.default.func,
    onChange: prop_types_1.default.func,
    onAllUpdated: prop_types_1.default.func,
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool
};
exports.default = fieldsRedux_1.createField(Calendar, { disableInitField: true });
