export interface CarouselProps {
  /**
   * ID
   */
  id: string, 
  /**
   * Left icon
   */
  leftIcon?: SVGElement, 
  /**
   * Right icon
   */
  rightIcon?: SVGElement, 
  /**
   * Number to represent the icon size in pixels
   */
  iconSize?: number, 
  /**
   * Value of scroll sensitivity
   */
  scrollSensitivity?: number, 
  /**
   * Number to represent the item spacing in pixels
   */
  itemSpacing?: number, 
  /**
   * Show buttons
   */
  buttons?: boolean, 
  /**
   * Show indicator
   */
  indicator?: boolean, 
  /**
   * Number to represent the indicator size in pixels
   */
  indicatorSize?: number, 
  /**
   * Number to represent the indicator gap in pixels
   */
  indicatorGap?: number, 
  /**
   * Number to represent the indicator padding in pixels
   */
  indicatorPadding?: number, 
  /**
   * Style to carousel element
   */
  carouselStyle?: object, 
  /**
   * Css class to button element
   */
  buttonClassName?: string, 
  /**
   * Css class to indicator element
   */
  indicatorClassName?: string, 
  /**
   * Css class to current indicator element
   */
  currentIndicatorClassName?: string, 
  /**
   * Function called on click
   */
  onClick?: (event: Event) => void
}


declare function Carousel(props: CarouselProps): JSX.Element

export default Carousel;