"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var clsx_1 = __importDefault(require("clsx"));
var react_1 = __importStar(require("react"));
var io_1 = require("react-icons/io");
var useStyles = core_1.makeStyles(function (theme) { return ({
    container: {
        height: '100%',
        width: '100%'
    },
    carouselContainer: {
        width: '100%',
        height: function (_a) {
            var indicator = _a.indicator, indicatorPadding = _a.indicatorPadding;
            return (indicator) ? "calc(100% - " + indicatorPadding * 2 + "px)" : '100%';
        },
        minWidth: '100%',
        display: 'flex',
        alignItems: 'center'
    },
    carousel: {
        width: '100%',
        height: '100%',
        margin: 'auto',
        display: 'flex',
        alignItems: 'center',
        flexDirection: 'row',
        overflow: 'hidden',
        scrollBehavior: 'smooth',
        '&>*:not(:last-child)': {
            marginRight: function (_a) {
                var itemSpacing = _a.itemSpacing;
                return (itemSpacing || '');
            }
        }
    },
    button: {
        display: 'flex',
        alignItems: 'center',
        cursor: 'pointer',
        border: 0,
        padding: 0,
        backgroundColor: '#0000',
        color: (theme.palette.type === 'light') ? 'rgba(0, 0, 0, .4)' : 'rgba(255, 255, 255, .5)',
        '&:hover': {
            color: (theme.palette.type === 'light') ? 'rgba(0, 0, 0, .6)' : 'rgba(255, 255, 255, .8)'
        },
        '&:disabled': {
            color: (theme.palette.type === 'light') ? 'rgba(0, 0, 0, .23)' : 'rgba(255, 255, 255, .3)',
            backgroundColor: 'transparent',
            cursor: 'default',
            pointerEvents: 'none'
        }
    },
    leftButton: {
        left: 0
    },
    rightButton: {
        right: 0
    },
    indicator: {
        display: 'flex',
        flexWrap: 'wrap',
        alignItems: 'center',
        justifyContent: 'center',
        gap: function (_a) {
            var indicatorGap = _a.indicatorGap;
            return (indicatorGap || '');
        },
        padding: function (_a) {
            var indicatorPadding = _a.indicatorPadding, indicatorSize = _a.indicatorSize, iconSize = _a.iconSize;
            return indicatorPadding - (indicatorSize / 2) + "px " + iconSize + "px";
        },
        '& span': {
            width: function (_a) {
                var indicatorSize = _a.indicatorSize;
                return (indicatorSize || '');
            },
            height: function (_a) {
                var indicatorSize = _a.indicatorSize;
                return (indicatorSize || '');
            },
            borderRadius: '50%',
            backgroundColor: (theme.palette.type === 'light') ? 'rgba(0, 0, 0, .4)' : 'rgba(255, 255, 255, .5)',
            transition: 'background-color 500ms'
        }
    },
    currentIndicator: {
        backgroundColor: (theme.palette.type === 'light') ? '#000 !important' : '#fff !important'
    }
}); });
var CAROUSEL_ID = 'carousel';
var initialState = {
    position: 0,
    indicatorArray: []
};
var Carousel = function (_a) {
    var _b, _c, _d;
    var id = _a.id, _e = _a.leftIcon, LEFT_ICON = _e === void 0 ? io_1.IoIosArrowBack : _e, _f = _a.rightIcon, RIGHT_ICON = _f === void 0 ? io_1.IoIosArrowForward : _f, _g = _a.iconSize, iconSize = _g === void 0 ? 20 : _g, _h = _a.scrollSensitivity, scrollSensitivity = _h === void 0 ? 2 : _h, _j = _a.itemSpacing, itemSpacing = _j === void 0 ? '.5rem' : _j, children = _a.children, _k = _a.buttons, buttons = _k === void 0 ? true : _k, indicator = _a.indicator, _l = _a.indicatorSize, indicatorSize = _l === void 0 ? 6 : _l, _m = _a.indicatorGap, indicatorGap = _m === void 0 ? 10 : _m, _o = _a.indicatorPadding, indicatorPadding = _o === void 0 ? 20 : _o, carouselStyle = _a.carouselStyle, onClick = _a.onClick, buttonClassName = _a.buttonClassName, indicatorClassName = _a.indicatorClassName, currentIndicatorClassName = _a.currentIndicatorClassName;
    var classes = useStyles({ itemSpacing: itemSpacing, indicator: indicator, indicatorSize: indicatorSize, indicatorGap: indicatorGap, indicatorPadding: indicatorPadding, iconSize: iconSize });
    var _p = react_1.useState(initialState), state = _p[0], setState = _p[1];
    var position = state.position, indicatorArray = state.indicatorArray;
    var carousel = react_1.useRef(null);
    var childWidth = (_d = (_c = (_b = carousel.current) === null || _b === void 0 ? void 0 : _b.children) === null || _c === void 0 ? void 0 : _c[0]) === null || _d === void 0 ? void 0 : _d.offsetWidth;
    var disabledButtonsRef = react_1.useRef(false);
    var carouselId = (id) ? id : CAROUSEL_ID;
    var leftButtonId = carouselId + "-left-button";
    var rightButtonId = carouselId + "-right-button";
    var logicSetState = function (_a) {
        var type = _a.type, field = _a.field, value = _a.value;
        return setState(function (states) {
            var _a, _b;
            return (__assign(__assign({}, states), (_a = {}, _a[type] = (type && field) ? __assign(__assign({}, states[type]), (_b = {}, _b[field] = value, _b)) : value, _a)));
        });
    };
    var control = react_1.useCallback(function (e) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j;
        if (disabledButtonsRef.current)
            return;
        var childWidth = (_c = (_b = (_a = carousel.current) === null || _a === void 0 ? void 0 : _a.children) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.offsetWidth;
        var maxWidth = (childWidth * (((_e = (_d = carousel.current) === null || _d === void 0 ? void 0 : _d.children) === null || _e === void 0 ? void 0 : _e.length) - 1));
        var scrollLeft = (_f = carousel.current) === null || _f === void 0 ? void 0 : _f.scrollLeft;
        var leftButtonElement = document.getElementById(leftButtonId);
        var rightButtonElement = document.getElementById(rightButtonId);
        var childrenWidth = ((childWidth + itemSpacing) * ((_h = (_g = carousel.current) === null || _g === void 0 ? void 0 : _g.children) === null || _h === void 0 ? void 0 : _h.length));
        var childrenSmallerThanParent = (childrenWidth < ((_j = carousel.current) === null || _j === void 0 ? void 0 : _j.offsetWidth));
        if (leftButtonElement) {
            if ((scrollLeft === 0) || childrenSmallerThanParent)
                leftButtonElement.disabled = true;
            else if (scrollLeft > 0)
                leftButtonElement.disabled = false;
        }
        if (rightButtonElement) {
            if ((scrollLeft === maxWidth) || childrenSmallerThanParent)
                rightButtonElement.disabled = true;
            else if (scrollLeft < maxWidth)
                rightButtonElement.disabled = false;
        }
        (position === children.length) && logicSetState({ type: 'position', value: (children.length - 1) });
    }, [itemSpacing, leftButtonId, rightButtonId, position, children.length]);
    react_1.useEffect(function () { return control(); }, [control]);
    control();
    var createIndicatorArray = react_1.useCallback(function () {
        var _a, _b;
        var childrenLength = (_b = (_a = carousel.current) === null || _a === void 0 ? void 0 : _a.children) === null || _b === void 0 ? void 0 : _b.length;
        var newIndicatorArray = Array.from(Array(childrenLength).keys());
        logicSetState({ type: 'indicatorArray', value: newIndicatorArray });
    }, []);
    react_1.useEffect(function () { return (indicator) && createIndicatorArray(); }, [indicator, children, createIndicatorArray]);
    var handleCarouselClick = function (e, direction) {
        if (!childWidth || (typeof childWidth !== 'number'))
            return;
        var newPosition = position;
        var scrollWidth = (childWidth * scrollSensitivity);
        var leftButtonElement = document.getElementById(leftButtonId);
        var rightButtonElement = document.getElementById(rightButtonId);
        leftButtonElement.disabled = true;
        rightButtonElement.disabled = true;
        disabledButtonsRef.current = true;
        if (direction === 'right') {
            (carousel.current.scrollLeft += scrollWidth);
            (position < (indicatorArray.length - 1)) && logicSetState({ type: 'position', value: (newPosition += 1) });
        }
        else {
            (carousel.current.scrollLeft -= scrollWidth);
            (position > 0) && logicSetState({ type: 'position', value: (newPosition -= 1) });
        }
        (onClick && (typeof onClick === 'function')) && onClick(e);
        setTimeout(function () {
            leftButtonElement.disabled = false;
            rightButtonElement.disabled = false;
            disabledButtonsRef.current = false;
            control();
        }, ((childWidth <= 500) ? 500 : (childWidth * ((childWidth > 1000) ? 0.6 : 0.9)) || 500));
    };
    return react_1.default.createElement("div", { id: carouselId, className: classes.container },
        react_1.default.createElement("div", { className: classes.carouselContainer },
            (buttons && LEFT_ICON) && (react_1.default.createElement("button", { id: leftButtonId, onClick: function (e) { return handleCarouselClick(e, 'left'); }, className: clsx_1.default(classes.button, classes.leftButton, buttonClassName) },
                react_1.default.createElement(LEFT_ICON, { size: iconSize, className: classes.leftButton }))),
            react_1.default.createElement("div", { ref: carousel, style: __assign({}, carouselStyle), className: classes.carousel }, children),
            (buttons && RIGHT_ICON) && (react_1.default.createElement("button", { id: rightButtonId, onClick: function (e) { return handleCarouselClick(e, 'right'); }, className: clsx_1.default(classes.button, classes.rightButton, buttonClassName) },
                react_1.default.createElement(RIGHT_ICON, { size: iconSize, className: classes.rightButton })))),
        (indicator) && (react_1.default.createElement("div", { className: clsx_1.default(classes.indicator, indicatorClassName) }, indicatorArray.map(function (_, index) {
            var _a;
            return (react_1.default.createElement("span", { key: "indicator-" + index, className: clsx_1.default((_a = {},
                    _a[classes.currentIndicator] = (position === index),
                    _a[currentIndicatorClassName] = (position === index),
                    _a)) }));
        }))));
};
exports.default = Carousel;
