"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.styles = void 0;
var core_1 = require("@material-ui/core");
var transitions_1 = require("@material-ui/core/styles/transitions");
var withStyles_1 = __importDefault(require("@material-ui/core/styles/withStyles"));
var utils_1 = require("@material-ui/core/transitions/utils");
var clsx_1 = __importDefault(require("clsx"));
var prop_types_1 = __importDefault(require("prop-types"));
var React = __importStar(require("react"));
var react_transition_group_1 = require("react-transition-group");
var styles = function (theme) { return ({
    /* Styles applied to the container element. */
    container: {
        position: 'relative',
        overflow: 'hidden',
        height: 0,
        transition: theme.transitions.create('height'),
        '&$horizontal': {
            width: 0,
            height: 'auto',
            transition: theme.transitions.create('width'),
        },
    },
    /* Pseudo-class applied to the root element if `orientation="horizontal"`. */
    horizontal: {},
    /* Styles applied to the container element when the transition has entered. */
    entered: {
        height: 'auto',
        overflow: 'visible',
        '&$horizontal': {
            height: 'initial',
            width: 'auto',
        },
    },
    /* Styles applied to the container element when the transition has exited and `collapsedHeight` != 0px. */
    hidden: {
        visibility: 'hidden',
    },
    /* Styles applied to the outer wrapper element. */
    wrapper: {
        // Hack to get children with a negative margin to not falsify the height computation.
        display: 'flex',
    },
    /* Styles applied to the inner wrapper element. */
    wrapperInner: {
        width: '100%',
        '&$horizontal': {
            // width: 'initial',
            height: '100%',
        },
    },
}); };
exports.styles = styles;
/**
 * The Collapse transition is used by the
 * [Vertical Stepper](/components/steppers/#vertical-stepper) StepContent component.
 * It uses [react-transition-group](https://github.com/reactjs/react-transition-group) internally.
 */
var Collapse = React.forwardRef(function Collapse(props, ref) {
    var children = props.children, classes = props.classes, className = props.className, _a = props.collapsedHeight, collapsedHeight = _a === void 0 ? '0px' : _a, _b = props.collapsedSize, collapsedSizeProp = _b === void 0 ? '0px' : _b, _c = props.component, Component = _c === void 0 ? 'div' : _c, inProp = props.in, onEnter = props.onEnter, onEntered = props.onEntered, onEntering = props.onEntering, onExit = props.onExit, onExiting = props.onExiting, _d = props.orientation, orientation = _d === void 0 ? 'vertical' : _d, _e = props.style, style = _e === void 0 ? {} : _e, _f = props.timeout, timeout = _f === void 0 ? transitions_1.duration.standard : _f, 
    // eslint-disable-next-line react/prop-types
    _g = props.TransitionComponent, 
    // eslint-disable-next-line react/prop-types
    TransitionComponent = _g === void 0 ? react_transition_group_1.Transition : _g, other = __rest(props, ["children", "classes", "className", "collapsedHeight", "collapsedSize", "component", "in", "onEnter", "onEntered", "onEntering", "onExit", "onExiting", "orientation", "style", "timeout", "TransitionComponent"]);
    var theme = core_1.useTheme();
    var timer = React.useRef();
    var wrapperRef = React.useRef(null);
    var autoTransitionDuration = React.useRef();
    var collapsedSizeOrHeight = collapsedHeight === '0px' ? collapsedSizeProp : collapsedHeight;
    var collapsedSize = typeof collapsedSizeOrHeight === 'number'
        ? collapsedSizeOrHeight + "px"
        : collapsedSizeOrHeight;
    var isHorizontal = orientation === 'horizontal';
    var size = isHorizontal ? 'width' : 'height';
    React.useEffect(function () {
        return function () {
            clearTimeout(timer.current);
        };
    }, []);
    var handleEnter = function (node, isAppearing) {
        // Set absolute position to get the size of collapsed content
        wrapperRef.current.style.position = 'absolute';
        node.style[size] = collapsedSize;
        if (onEnter) {
            onEnter(node, isAppearing);
        }
    };
    var handleEntering = function (node, isAppearing) {
        var wrapperSize = wrapperRef.current[isHorizontal ? 'clientWidth' : 'clientHeight'];
        // After the size is read reset the position back to default
        wrapperRef.current.style.position = '';
        var transitionDuration = utils_1.getTransitionProps({ style: style, timeout: timeout }, {
            mode: 'enter',
        }).duration;
        if (timeout === 'auto') {
            var duration2 = theme.transitions.getAutoHeightDuration(wrapperSize);
            node.style.transitionDuration = duration2 + "ms";
            autoTransitionDuration.current = duration2;
        }
        else {
            node.style.transitionDuration
                = typeof transitionDuration === 'string' ? transitionDuration : transitionDuration + "ms";
        }
        node.style[size] = wrapperSize + "px";
        if (onEntering) {
            onEntering(node, isAppearing);
        }
    };
    var handleEntered = function (node, isAppearing) {
        node.style[size] = style[size] || 'auto';
        if (onEntered) {
            onEntered(node, isAppearing);
        }
    };
    var handleExit = function (node) {
        var wrapperSize = wrapperRef.current[isHorizontal ? 'clientWidth' : 'clientHeight'];
        node.style[size] = wrapperSize + "px";
        if (onExit) {
            onExit(node);
        }
    };
    var handleExiting = function (node) {
        var wrapperSize = wrapperRef.current[isHorizontal ? 'clientWidth' : 'clientHeight'];
        var transitionDuration = utils_1.getTransitionProps({ style: style, timeout: timeout }, {
            mode: 'exit',
        }).duration;
        if (timeout === 'auto') {
            // TODO: rename getAutoHeightDuration to something more generic (width support)
            // Actually it just calculates animation duration based on size
            var duration2 = theme.transitions.getAutoHeightDuration(wrapperSize);
            node.style.transitionDuration = duration2 + "ms";
            autoTransitionDuration.current = duration2;
        }
        else {
            node.style.transitionDuration
                = typeof transitionDuration === 'string' ? transitionDuration : transitionDuration + "ms";
        }
        node.style[size] = collapsedSize;
        if (onExiting) {
            onExiting(node);
        }
    };
    var addEndListener = function (_, next) {
        if (timeout === 'auto') {
            timer.current = setTimeout(next, autoTransitionDuration.current || 0);
        }
    };
    return (React.createElement(TransitionComponent, __assign({ in: inProp, onEnter: handleEnter, onEntered: handleEntered, onEntering: handleEntering, onExit: handleExit, onExiting: handleExiting, addEndListener: addEndListener, timeout: timeout === 'auto' ? null : timeout }, other), function (state, childProps) {
        var _a, _b, _c;
        return (React.createElement(Component, __assign({ className: clsx_1.default(classes.container, (_a = {},
                _a[classes.horizontal] = isHorizontal,
                _a[classes.entered] = state === 'entered',
                _a[classes.hidden] = state === 'exited' && !inProp && collapsedSize === '0px',
                _a), className), style: __assign((_b = {}, _b[isHorizontal ? 'minWidth' : 'minHeight'] = collapsedSize, _b), style), ref: ref }, childProps),
            React.createElement("div", { className: classes.wrapper, ref: wrapperRef },
                React.createElement("div", { className: clsx_1.default(classes.wrapperInner, (_c = {},
                        _c[classes.horizontal] = isHorizontal,
                        _c)) }, children))));
    }));
});
Collapse.propTypes = {
    // ----------------------------- Warning --------------------------------
    // | These PropTypes are generated from the TypeScript type definitions |
    // |     To update them edit the d.ts file and run "yarn proptypes"     |
    // ----------------------------------------------------------------------
    /**
     * The content node to be collapsed.
     */
    children: prop_types_1.default.node,
    /**
     * Override or extend the styles applied to the component.
     * See [CSS API](#css) below for more details.
     */
    classes: prop_types_1.default.object,
    /**
     * @ignore
     */
    className: prop_types_1.default.string,
    /**
     * @ignore
     * @deprecated
     * The height of the container when collapsed.
     *
     * This prop will be deprecated and removed in v5, use collapsedSize instead.
     */
    collapsedHeight: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string]),
    /**
     * The width (horizontal) or height (vertical) of the container when collapsed.
     */
    collapsedSize: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string]),
    /**
     * The component used for the root node.
     * Either a string to use a DOM element or a component.
     */
    component: prop_types_1.default.elementType,
    /**
     * If `true`, the component will transition in.
     */
    in: prop_types_1.default.bool,
    /**
     * @ignore
     */
    onEnter: prop_types_1.default.func,
    /**
     * @ignore
     */
    onEntered: prop_types_1.default.func,
    /**
     * @ignore
     */
    onEntering: prop_types_1.default.func,
    /**
     * @ignore
     */
    onExit: prop_types_1.default.func,
    /**
     * @ignore
     */
    onExiting: prop_types_1.default.func,
    /**
     * The collapse transition orientation.
     */
    orientation: prop_types_1.default.oneOf(['horizontal', 'vertical']),
    /**
     * @ignore
     */
    style: prop_types_1.default.object,
    /**
     * The duration for the transition, in milliseconds.
     * You may specify a single timeout for all transitions, or individually with an object.
     *
     * Set to 'auto' to automatically calculate transition time based on height.
     */
    timeout: prop_types_1.default.oneOfType([
        prop_types_1.default.oneOf(['auto']),
        prop_types_1.default.number,
        prop_types_1.default.shape({
            appear: prop_types_1.default.number,
            enter: prop_types_1.default.number,
            exit: prop_types_1.default.number,
        }),
    ]),
};
Collapse.muiSupportAuto = true;
exports.default = withStyles_1.default(exports.styles, { name: 'MuiCollapse' })(Collapse);
