import { DialogProps } from '@material-ui/core';
import React from 'react';
export interface BasicModalProps {
    /**
     * Label no botao de confirmar
     */
    okLabel: React.ReactNode;
    /**
     * Label no botao de cancelar
     */
    cancelLabel: React.ReactNode;
    /**
     * Titulo do modal
     */
    title: React.ReactNode;
    /**
     * Descricao do modal
     */
    description: React.ReactNode;
    /**
     * Props repassados ao componente dialog
     */
    dialogProps: Omit<DialogProps, 'open'>;
    /**
     * @ignore
     */
    proceed: Function;
    /**
     * @ignore
     */
    cancel: Function;
    /**
     * @ignore
     */
    open: boolean;
}
declare const BasicModal: ({ okLabel, cancelLabel, title, description, open, proceed, dialogProps, cancel }: BasicModalProps) => React.JSX.Element;
export default BasicModal;
