"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModalProviderContext = void 0;
var BasicModal_1 = __importDefault(require("./BasicModal"));
var fieldsRedux_1 = require("../../fieldsRedux");
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var use_immer_1 = require("use-immer");
// @ts-ignore
exports.ModalProviderContext = react_1.createContext();
var ModalProvider = function (_a) {
    var children = _a.children, argousSystem = _a.argousSystem;
    var _b = use_immer_1.useImmer([]), modals = _b[0], setCurrentModal = _b[1];
    var close = react_1.useCallback(function (unmountDelay, index) { return function () {
        setTimeout(function () { return setCurrentModal(function (modais) { return void (modais.splice(index, 1)); }); }, unmountDelay);
    }; }, [setCurrentModal]);
    var createModal = react_1.useCallback(function (Component, unmountDelay) {
        if (unmountDelay === void 0) { unmountDelay = 0; }
        return function (props) {
            var promise = new Promise(function (resolve, reject) {
                setCurrentModal(function (modais) { return void (modais.push(react_1.default.createElement(ModalWrapper, __assign({ Component: Component, close: close(unmountDelay, modals.length), resolve: resolve, reject: reject }, props)))); });
            });
            return promise.then(function (result) {
                close(unmountDelay, modals.length);
                return result;
            }, function (result) {
                close(unmountDelay, modals.length);
                return Promise.reject(result);
            });
        };
    }, [close, modals.length, setCurrentModal]);
    var openModal = react_1.useMemo(function () { var _a; return (_a = argousSystem === null || argousSystem === void 0 ? void 0 : argousSystem.openModal) === null || _a === void 0 ? void 0 : _a.value; }, [argousSystem]);
    react_1.useEffect(function () {
        if (!openModal)
            return;
        var reject = openModal.reject, resolve = openModal.resolve, props = __rest(openModal, ["reject", "resolve"]);
        createModal(BasicModal_1.default)(props).then(resolve, reject);
        fieldsRedux_1.setAnotherProgramField('openModal', undefined, 'argousSystem');
        //eslint-disable-next-line
    }, [openModal]);
    var context = react_1.useMemo(function () { return ({ createModal: createModal }); }, [createModal]);
    return (react_1.default.createElement(exports.ModalProviderContext.Provider, { value: context },
        children,
        modals.map(function (Modal) { return Modal; })));
};
var mapStateToProps = function (state) { return ({
    argousSystem: state.argous.fields.argousSystem,
}); };
exports.default = react_redux_1.connect(mapStateToProps)(ModalProvider);
var ModalWrapper = function (_a) {
    var Component = _a.Component, reject = _a.reject, resolve = _a.resolve, close = _a.close, props = __rest(_a, ["Component", "reject", "resolve", "close"]);
    var _b = react_1.useState(true), show = _b[0], setShow = _b[1];
    var cancel = react_1.useCallback(function (reject) { return function (value) {
        setShow(false);
        reject(value);
        close();
    }; }, [close]);
    var proceed = react_1.useCallback(function (resolve) { return function (value) {
        setShow(false);
        resolve(value);
        close();
    }; }, [close]);
    return react_1.default.createElement(Component, __assign({ cancel: cancel(reject), proceed: proceed(resolve), open: show }, props));
};
