export interface BasicComponentProps {
  cancel: (value: unknown) => void,
  proceed: (value: unknown) => void,
  open: boolean
}

export type CreateModalType = <P>(Component: (props: P & BasicComponentProps) => JSX.Element, unmountDelay?: number) => (props?: Omit<P, keyof BasicComponentProps>) => Promise<unknown>

export interface ModalProviderContextProps {
  createModal: CreateModalType
}

export { default } from './ModalProvider';
export * from './ModalProvider';

export { default as BasicModal } from './BasicModal';
export * from './BasicModal';

export { default as WrapperModal } from './WrapperModal';
export * from './WrapperModal';