export function IconsComponent({ type, fileName, mimeType, idDocumento, link, ...props }: React.ImgHTMLAttributes<HTMLImageElement> & Tipos): JSX.Element;
/**
 * @typedef {object} FileIcons - Objeto de icones
 * @property {JSX.Element} ai -Icone de arquivos do Ilustrator
 * @property {JSX.Element} audio -Icone genérico de Audio
 * @property {JSX.Element} avi -Icone de videos AVI
 * @property {JSX.Element} css -Icone de arquivos CSS
 * @property {JSX.Element} csv -Icone de arquivos CSV
 * @property {JSX.Element} dbf -Icone de arquivos DBF
 * @property {JSX.Element} doc -Icone de arquivos Word
 * @property {JSX.Element} dwg -Icone de arquivos DWG
 * @property {JSX.Element} exe -Icone de arquivos EXE
 * @property {JSX.Element} file -Icone de arquivos genéricos
 * @property {JSX.Element} fla -Icone de arquivos FLA
 * @property {JSX.Element} html -Icone de arquivos HTML
 * @property {JSX.Element} image -Icone genérico de Imagens
 * @property {JSX.Element} iso -Icone de imagens ISO
 * @property {JSX.Element} jpg -Icone de imagens JPG
 * @property {JSX.Element} js -Icone de arquivos Javascript
 * @property {JSX.Element} json -Icone de arquivos JSON
 * @property {JSX.Element} mod -Icone de modelos de documentos
 * @property {JSX.Element} mp3 -Icone de músicas MP3
 * @property {JSX.Element} mp4 -Icone de vídeos MP4
 * @property {JSX.Element} pdf -Icone de arquivos PDP
 * @property {JSX.Element} png -Icone de imagens PNG
 * @property {JSX.Element} ppt -Icone de arquivos do Power Point
 * @property {JSX.Element} psd -Icone de arquivos do Photoshop
 * @property {JSX.Element} rtf -Icone de arquivos RTF
 * @property {JSX.Element} search -Icone genérico de Busca
 * @property {JSX.Element} svg -Icone de arquivos SVG
 * @property {JSX.Element} txt -Icone de arquivos de Texto
 * @property {JSX.Element} video -Icone genérico de Vídeo
 * @property {JSX.Element} xls -Icone de arquivos do Excel
 * @property {JSX.Element} xml -Icone de arquivos XML
 * @property {JSX.Element} zip -Icone de arquivos ZIP
 * @property {JSX.Element} zip1 -Icone genérico de arquivos comprimidos
 */
/** @type {FileIcons}  */
export const Icons: FileIcons;
export default Icons;
export type Extencoes = 'ai' | 'audio' | 'avi' | 'css' | 'csv' | 'dbf' | 'doc' | 'dwg' | 'exe' | 'file' | 'fla' | 'html' | 'image' | 'iso' | 'jpg' | 'js' | 'json' | 'mod' | 'mp3' | 'mp4' | 'pdf' | 'png' | 'ppt' | 'psd' | 'rtf' | 'search' | 'svg' | 'txt' | 'video' | 'xls' | 'xml' | 'zip' | 'zip1';
export type Tipos = {
    /**
     * - Tipos de arquivos suportados
     */
    type: Extencoes;
    /**
     * - MimeType do arquivo
     */
    mimeType: string;
    /**
     * - Nome do arquivo
     */
    fileName: string;
};
/**
 * - Objeto de icones
 */
export type FileIcons = {
    /**
     * -Icone de arquivos do Ilustrator
     */
    ai: JSX.Element;
    /**
     * -Icone genérico de Audio
     */
    audio: JSX.Element;
    /**
     * -Icone de videos AVI
     */
    avi: JSX.Element;
    /**
     * -Icone de arquivos CSS
     */
    css: JSX.Element;
    /**
     * -Icone de arquivos CSV
     */
    csv: JSX.Element;
    /**
     * -Icone de arquivos DBF
     */
    dbf: JSX.Element;
    /**
     * -Icone de arquivos Word
     */
    doc: JSX.Element;
    /**
     * -Icone de arquivos DWG
     */
    dwg: JSX.Element;
    /**
     * -Icone de arquivos EXE
     */
    exe: JSX.Element;
    /**
     * -Icone de arquivos genéricos
     */
    file: JSX.Element;
    /**
     * -Icone de arquivos FLA
     */
    fla: JSX.Element;
    /**
     * -Icone de arquivos HTML
     */
    html: JSX.Element;
    /**
     * -Icone genérico de Imagens
     */
    image: JSX.Element;
    /**
     * -Icone de imagens ISO
     */
    iso: JSX.Element;
    /**
     * -Icone de imagens JPG
     */
    jpg: JSX.Element;
    /**
     * -Icone de arquivos Javascript
     */
    js: JSX.Element;
    /**
     * -Icone de arquivos JSON
     */
    json: JSX.Element;
    /**
     * -Icone de modelos de documentos
     */
    mod: JSX.Element;
    /**
     * -Icone de músicas MP3
     */
    mp3: JSX.Element;
    /**
     * -Icone de vídeos MP4
     */
    mp4: JSX.Element;
    /**
     * -Icone de arquivos PDP
     */
    pdf: JSX.Element;
    /**
     * -Icone de imagens PNG
     */
    png: JSX.Element;
    /**
     * -Icone de arquivos do Power Point
     */
    ppt: JSX.Element;
    /**
     * -Icone de arquivos do Photoshop
     */
    psd: JSX.Element;
    /**
     * -Icone de arquivos RTF
     */
    rtf: JSX.Element;
    /**
     * -Icone genérico de Busca
     */
    search: JSX.Element;
    /**
     * -Icone de arquivos SVG
     */
    svg: JSX.Element;
    /**
     * -Icone de arquivos de Texto
     */
    txt: JSX.Element;
    /**
     * -Icone genérico de Vídeo
     */
    video: JSX.Element;
    /**
     * -Icone de arquivos do Excel
     */
    xls: JSX.Element;
    /**
     * -Icone de arquivos XML
     */
    xml: JSX.Element;
    /**
     * -Icone de arquivos ZIP
     */
    zip: JSX.Element;
    /**
     * -Icone genérico de arquivos comprimidos
     */
    zip1: JSX.Element;
};
import React from "react";
