import * as React from 'react';

export interface DropAreaProps extends Omit<React.HTMLProps<HTMLDivElement>, 'onChange'> {
  /**
   * Função chamada ao receber arquivo
   * 
   * @param arquivo - Arquivo
   * 
   * @returns {void} Sem Retorno
   */
  onChange?: (arquivo: File) => void
}

/**
 * Componente para drop de arquivos
 * 
 * Repassa o arquivo dropado diretamente para um file preparer se tiver o mesmo como filho
 */
declare function DropArea(props: DropAreaProps): JSX.Element

export default DropArea;