/**
 * @param {DataTransfer} dataTransfer
 */
export function getDataTransferFiles(dataTransfer: DataTransfer): Promise<any>;
/**
 * This function should be called from both the onDrop event from your drag/drop
 * dropzone as well as from the HTML5 file selector input field onChange event
 * handler.  Pass the event object from the triggered event into this function.
 * Supports mix of files and folders dropped via drag/drop.
 *
 * Returns: an array of File objects, that includes all files within folders
 *   and subfolders of the dropped/selected items.
 *
 * @param {React.DragEvent<HTMLDivElement>} event
 */
export function getDroppedOrSelectedFiles(event: React.DragEvent<HTMLDivElement>): Promise<any>;
