import { ChipProps, TextFieldProps } from '@material-ui/core';
import * as React from 'react';

export interface FilePreparerRef {
  preparaArquivo: (file: File) => Promise<void>,
  loading: boolean
}

export interface FilePreparerProps extends Omit<React.HTMLProps<HTMLDivElement>, 'ref'> {
  onChange?: (res: object) => void,
  TextFieldProps?: TextFieldProps,
  placeholder?: string,
  label?: string,
  ref?: React.RefObject<FilePreparerRef>,
  multiple?: boolean,
  ChipProps?: ChipProps,
  disabled?: boolean,
  fileInputProps?: React.HTMLProps<HTMLInputElement>,
  valuePlaceHolder?: string,
  concat?: boolean,
  initialFiles?: any[]
}

declare function FilePreparer(props: FilePreparerProps): JSX.Element

export default FilePreparer;