export interface HalfGaugeProps {
  /**
   * Id do elemento
   */
  id?: string,
  /**
   * Porcentagem 
   */
  percentage?: number,
  /**
   * Tamanho do componente
   */
  size?: number,
  /**
   * Tamanho da fonte
   */
  fontSize?: string,
  /**
   * Cor da fonte do texto
   */
  color?: string,
  /**
   * Cor de fundo
   */ 
  backgroundColor?: string,
  /**
   * Cor de fundo da barra
   */
  barBackgroundColor?: string,
  /**
   * Tamanho responsivo
   */
  responsive?: boolean,
  /**
   * Texto utilizado no medidor
   */
  label?: string,
  /**
   * Ordenação do medidor
   */
  order?: string,
  /**
   * Texto utilizado como mínimo
   */
  min?: string,
  /**
   * Texto utilizado como máximo
   */
  max?: string,
  /**
   * Cor do ponteiro indicador do medidor
   */
  handColor?: string,
  /**
   * Largura das áreas laterais onde ficará o min e max
   */
  minMaxWidth?: string,
  /**
   * Cor utilizada no meio do medidor
   */
  middleColor?: string,
  /**
   * Cor utilizada entre o meio e a direita do medidor
   */
  middleRightColor?: string,
  /**
   * Cor utilizada na direita do medidor
   */
  rightColor?: string,
  /**
   * Cor utilizada na esquerda do medidor
   */
  leftColor?: string,
  /**
   * Cor utilizada entre o meio e a esquerda do medidor
   */
  middleLeftColor?: string,
}
  
declare function HalfGauge(props: HalfGaugeProps): JSX.Element
  
export default HalfGauge;