"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var clsx_1 = __importDefault(require("clsx"));
var lodash_1 = require("lodash");
var react_1 = __importStar(require("react"));
var ELLIPSIS_TEXT_STYLE = {
    overflow: 'hidden',
    whiteSpace: 'nowrap',
    textOverflow: 'ellipsis'
};
var useStyles = core_1.makeStyles({
    container: {
        display: 'flex',
        height: function (_a) {
            var size = _a.size;
            return size / 2 + "px";
        },
        transition: 'all .3s',
        opacity: function (_a) {
            var responsive = _a.responsive;
            return responsive ? 0 : 1;
        }
    },
    gauge: {
        height: function (_a) {
            var size = _a.size;
            return size;
        },
        width: function (_a) {
            var size = _a.size;
            return size;
        },
        backgroundColor: function (_a) {
            var barBackgroundColor = _a.barBackgroundColor;
            return barBackgroundColor;
        },
        borderRadius: '50%',
        display: 'grid',
        placeItems: 'center',
        webkitClipPath: 'polygon(0 0, 100% 0, 100% 51%, 0 51%)',
        clipPath: 'polygon(0 0, 100% 0, 100% 51%, 0 51%)',
        '&::before': {
            content: '""',
            position: 'absolute',
            height: function (_a) {
                var gaugeBarWidth = _a.gaugeBarWidth;
                return gaugeBarWidth;
            },
            width: function (_a) {
                var gaugeBarWidth = _a.gaugeBarWidth;
                return gaugeBarWidth;
            },
            borderRadius: '50%',
            backgroundColor: function (_a) {
                var backgroundColor = _a.backgroundColor;
                return backgroundColor;
            }
        }
    },
    valueDiv: {
        position: 'absolute',
        color: function (_a) {
            var color = _a.color;
            return color;
        },
        fontSize: function (_a) {
            var fontSize = _a.fontSize;
            return fontSize;
        },
        maxWidth: function (_a) {
            var size = _a.size;
            return size / 2 + "px";
        },
        minWidth: function (_a) {
            var size = _a.size;
            return size / 2 + "px";
        },
        maxHeight: function (_a) {
            var size = _a.size;
            return size / 4 + "px";
        },
        minHeight: function (_a) {
            var size = _a.size;
            return size / 4 + "px";
        },
        transform: function (_a) {
            var size = _a.size;
            return "translateY(-" + (size / 4) / 2 + "px)";
        },
        display: 'flex',
        flexDirection: 'column',
        alignItems: 'center',
        justifyContent: 'end',
        overflow: 'hidden',
        whiteSpace: 'nowrap',
        padding: 4,
        '&>p': __assign(__assign({}, ELLIPSIS_TEXT_STYLE), { margin: 0, width: '100%', textAlign: 'center', '&:first-child': {
                fontWeight: 'bold'
            } })
    },
    minMax: {
        display: 'flex',
        alignItems: 'end',
        padding: '0 1rem',
        width: function (_a) {
            var minMaxWidth = _a.minMaxWidth;
            return minMaxWidth;
        },
        color: function (_a) {
            var color = _a.color;
            return color;
        },
        fontSize: function (_a) {
            var fontSize = _a.fontSize;
            return fontSize;
        },
        '&>p': {
            margin: 0
        }
    },
    min: {
        justifyContent: 'end'
    }
});
var getHand = function (percentage, handColor) {
    if (!lodash_1.isNumber(percentage))
        return '';
    var angle = 270;
    if (percentage > 50) {
        angle = 0;
        percentage -= 50;
    }
    var initialTransparentAngle = angle;
    angle = angle + (percentage * 1.8);
    var finalTransparentAngle = angle + 2;
    if (finalTransparentAngle > 90 && finalTransparentAngle < 270) {
        finalTransparentAngle = 90;
    }
    return "conic-gradient(\n    #0000 " + initialTransparentAngle + "deg " + (angle - 2) + "deg,\n    " + handColor + " " + (angle - 0.5) + "deg " + (angle + 0.5) + "deg,\n    #0000 " + finalTransparentAngle + "deg\n  )";
};
var HalfGauge = function (_a) {
    var _b = _a.responsive, responsive = _b === void 0 ? false : _b, _c = _a.id, id = _c === void 0 ? '' : _c, _d = _a.label, label = _d === void 0 ? '' : _d, _e = _a.percentage, percentage = _e === void 0 ? 0 : _e, _f = _a.order, order = _f === void 0 ? 'D' : _f, _g = _a.min, min = _g === void 0 ? '' : _g, _h = _a.max, max = _h === void 0 ? '' : _h, _j = _a.size, size = _j === void 0 ? 200 : _j, _k = _a.fontSize, fontSize = _k === void 0 ? '0.9rem' : _k, _l = _a.color, color = _l === void 0 ? '#000' : _l, _m = _a.backgroundColor, backgroundColor = _m === void 0 ? '#fff' : _m, _o = _a.barBackgroundColor, barBackgroundColor = _o === void 0 ? '#0000' : _o, _p = _a.handColor, handColor = _p === void 0 ? '#fff' : _p, _q = _a.minMaxWidth, minMaxWidth = _q === void 0 ? '6rem' : _q, _r = _a.middleColor, middleColor = _r === void 0 ? '#ffdd71' : _r, _s = _a.middleRightColor, middleRightColor = _s === void 0 ? '#fec900' : _s, _t = _a.rightColor, rightColor = _t === void 0 ? '#00995d' : _t, _u = _a.leftColor, leftColor = _u === void 0 ? '#fe6c6c' : _u, _v = _a.middleLeftColor, middleLeftColor = _v === void 0 ? '#ff9b9b' : _v;
    var gaugeBarWidth = size - (size / 2);
    var classes = useStyles({ color: color, backgroundColor: backgroundColor, barBackgroundColor: barBackgroundColor, size: size, gaugeBarWidth: gaugeBarWidth, fontSize: fontSize, minMaxWidth: minMaxWidth, responsive: responsive });
    var halfGaugeId = id + "-halfGauge";
    var halfGaugeHandId = id + "-halfGaugeHand";
    var halfGaugeContainerId = id + "-halfGaugeContainer";
    var percentageText = percentage.toString().replace('.', ',') + "%";
    var defaultColors = react_1.useMemo(function () { return ([middleColor, middleRightColor, rightColor, '#0000', leftColor, middleLeftColor]); }, [leftColor, middleColor, middleLeftColor, middleRightColor, rightColor]);
    var gaugeBackgroundColors = react_1.useMemo(function () {
        var colors = defaultColors;
        if (order === 'A') {
            var left = defaultColors[4];
            var middleLeft = defaultColors[5];
            var middleRight = defaultColors[1];
            var right = defaultColors[2];
            colors.splice(4, 1, right);
            colors.splice(5, 1, middleRight);
            colors.splice(1, 1, middleLeft);
            colors.splice(2, 1, left);
        }
        return colors;
    }, [defaultColors, order]);
    var createStage = react_1.useCallback(function () {
        var gaugeEl = document.getElementById(halfGaugeId);
        if (!gaugeEl)
            return;
        gaugeEl.style.background = "conic-gradient(\n      " + gaugeBackgroundColors[0] + " 18deg, \n      " + gaugeBackgroundColors[1] + " 18deg 54deg,\n      " + gaugeBackgroundColors[2] + " 54deg 90deg,\n      " + gaugeBackgroundColors[3] + " 90deg 270deg,\n      " + gaugeBackgroundColors[4] + " 270deg 306deg,\n      " + gaugeBackgroundColors[5] + " 306deg 342deg,\n      " + gaugeBackgroundColors[0] + " 342deg 360deg\n    )";
    }, [halfGaugeId, gaugeBackgroundColors]);
    var createHand = react_1.useCallback(function () {
        var hand = getHand(percentage, handColor);
        var gaugeHandEl = document.getElementById(halfGaugeHandId);
        if (!gaugeHandEl || !hand || (!gaugeHandEl && !hand))
            return;
        gaugeHandEl.style.background = hand;
    }, [halfGaugeHandId, percentage, handColor]);
    react_1.useEffect(function () {
        createStage();
        createHand();
    }, [percentage, createStage, createHand]);
    //__RESPONSIVE_SIZE___________________________________________________________________________________
    var makeResponsive = react_1.useCallback(function () {
        var _a;
        if (!halfGaugeContainerId)
            return;
        var containerEl = document.getElementById(halfGaugeContainerId);
        if (containerEl) {
            var parentElClientRect = (_a = containerEl === null || containerEl === void 0 ? void 0 : containerEl.parentElement) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect();
            if (parentElClientRect) {
                var parentWidth = parentElClientRect === null || parentElClientRect === void 0 ? void 0 : parentElClientRect.width;
                var parentHeight = parentElClientRect === null || parentElClientRect === void 0 ? void 0 : parentElClientRect.height;
                var scale = 1;
                if (parentWidth < 88) {
                    scale = 0.2;
                }
                else if (parentWidth < 218) {
                    scale = 0.4;
                }
                else if (parentWidth < 346 && parentHeight < 49) {
                    scale = 0.5;
                }
                else if (parentWidth < 278 && parentHeight < 143) {
                    scale = 0.7;
                }
                else if (parentWidth < 278 && parentHeight < 250) {
                    scale = 0.7;
                }
                else if (parentWidth < 346 && parentHeight < 143) {
                    scale = 0.7;
                }
                else if (parentWidth < 475 && parentHeight < 49) {
                    scale = 0.5;
                }
                else if (parentWidth < 348) {
                    scale = 0.9;
                }
                containerEl.style.transform = "scale(" + scale + ")";
            }
        }
        setTimeout(function () { return makeResponsive(); }, 500);
    }, [halfGaugeContainerId]);
    react_1.useEffect(function () { return responsive && makeResponsive(); }, [responsive, makeResponsive]);
    var displayContainer = react_1.useCallback(function () {
        var containerEl = document.getElementById(halfGaugeContainerId);
        if (containerEl)
            containerEl.style.opacity = 1;
    }, [halfGaugeContainerId]);
    react_1.useEffect(function () { return responsive && setTimeout(function () { return displayContainer(); }, 500); }, [responsive, displayContainer]);
    //____________________________________________________________________________________________________
    return react_1.default.createElement("div", { id: halfGaugeContainerId, className: classes.container },
        react_1.default.createElement("div", { className: clsx_1.default(classes.minMax, classes.min) },
            react_1.default.createElement("p", null, min)),
        react_1.default.createElement("div", { id: halfGaugeId, className: classes.gauge },
            react_1.default.createElement("div", { id: halfGaugeHandId, className: classes.gauge }),
            react_1.default.createElement("div", { className: classes.valueDiv },
                percentageText && react_1.default.createElement("p", null, percentageText),
                label && react_1.default.createElement("p", null, label))),
        react_1.default.createElement("div", { className: classes.minMax },
            react_1.default.createElement("p", null, max)));
};
exports.default = HalfGauge;
