import { DialogProps } from '@material-ui/core';

export interface ImageResizeProps extends DialogProps {
  /**
   * Imagem a ser Redimensionada
   */
  imagem: File,
  /**
   * Funcao chamada quando a imagem termina de ser redimensionada
   * 
   * @param {string} urlImagem - Base64 da imagem redimensionada
   * 
   * @returns {void} Sem Retorno 
   */
  onImage?: (urlImagem: string) => void, 
  /**
   * Propriedades da imagem final
   * 
   * @param {number | string} width - Largura da imagem final
   * @param {number | string} height - Altura da imagem final
   * @param {number | string} borderRadius - Raio da imagem final
   */
  finalImageProperties?: { width:number | string, height: number | string, borderRadius: number | string }
}

declare function ImageResize(props: ImageResizeProps): JSX.Element

export default ImageResize;