import { ImageResizeProps } from '../ImageResize/ImageResize';
import { ButtonClassKey, ExtendButtonBase } from '@material-ui/core';
import React from 'react';
export interface ImageResizeButtonTypeMap<P = {}, D extends React.ElementType = 'button'>{
  props: P & {
    /**
     * Props repassados ao componente de resize
     */
    ImageResizeProps?: ImageResizeProps, 
    /**
    * Função chamada quando a imagem fica pronta
    * 
    * @param image - Arquivo da imagem
    * @param b64 - Imagem em Base64
    * 
    * @returns {void} Sem Retorno
    */
    onImage?: (image: File, b64: string) => void,
  };
  defaultComponent: D;
  classKey: ButtonClassKey;
}

declare const ImageResizeButton: ExtendButtonBase<ImageResizeButtonTypeMap>;

export default ImageResizeButton;