"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("../");
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
var ImageResizeButton = react_1.forwardRef(function (_a, ref) {
    var children = _a.children, ImageResizeProps = _a.ImageResizeProps, onImage = _a.onImage, _b = _a.Component, Component = _b === void 0 ? core_1.Button : _b, props = __rest(_a, ["children", "ImageResizeProps", "onImage", "Component"]);
    var _c = react_1.useState(undefined), enviandoFoto = _c[0], setEnviandoFoto = _c[1];
    var inputRef = react_1.useRef();
    var handleClick = function () { return inputRef.current && inputRef.current.click(); };
    var handleChange = function (e) { return setEnviandoFoto(e.target.files[0]); };
    var handleImage = function (image) {
        onImage(dataURLtoFile(image, enviandoFoto.name), image);
        handleClose();
    };
    var handleClose = function () {
        setEnviandoFoto(undefined);
        clearInputFile(inputRef.current);
    };
    react_1.useImperativeHandle(ref, function () { return ({
        handleChange: handleChange
    }); }, []);
    return react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Component, __assign({ onClick: handleClick }, props), children),
        react_1.default.createElement("input", { ref: inputRef, type: 'file', style: { display: 'none' }, onChange: handleChange, accept: 'image/*' }),
        react_1.default.createElement(__1.ImageResize, __assign({ imagem: enviandoFoto, open: !!enviandoFoto, onImage: handleImage, onClose: handleClose }, ImageResizeProps)));
});
exports.default = ImageResizeButton;
function clearInputFile(f) {
    if (f === null || f === void 0 ? void 0 : f.value) {
        try {
            f.value = '';
        }
        catch (e) {
            var form = document.createElement('form'), parentNode = f.parentNode, ref = f.nextSibling;
            form.appendChild(f);
            form.reset();
            parentNode.insertBefore(f, ref);
        }
    }
}
function dataURLtoFile(dataurl, filename) {
    var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1], bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
    while (n--) {
        u8arr[n] = bstr.charCodeAt(n);
    }
    return new File([u8arr], filename, { type: mime });
}
