"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var Button_1 = __importDefault(require("@material-ui/core/Button"));
var clsx_1 = __importDefault(require("clsx"));
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importDefault(require("react"));
var useStyles = core_1.makeStyles(function (theme) { return ({
    containedInfo: {
        color: theme.palette.info.contrastText,
        backgroundColor: theme.palette.info.main,
        '&:hover': {
            backgroundColor: theme.palette.info.dark,
            '@media (hover: none)': {
                backgroundColor: theme.palette.info.main,
            },
        }
    },
    outlinedInfo: {
        color: theme.palette.info.main,
        border: "1px solid " + core_1.alpha(theme.palette.info.main, 0.5),
        '&:hover': {
            border: "1px solid " + theme.palette.info.main,
            backgroundColor: core_1.alpha(theme.palette.info.main, theme.palette.action.hoverOpacity),
            '@media (hover: none)': {
                backgroundColor: 'transparent',
            },
        }
    },
    textInfo: {
        color: theme.palette.info.main,
        '&:hover': {
            backgroundColor: core_1.alpha(theme.palette.info.main, theme.palette.action.hoverOpacity),
            '@media (hover: none)': {
                backgroundColor: 'transparent',
            },
        }
    },
    containedSuccess: {
        color: theme.palette.success.contrastText,
        backgroundColor: theme.palette.success.main,
        '&:hover': {
            backgroundColor: theme.palette.success.dark,
            '@media (hover: none)': {
                backgroundColor: theme.palette.success.main,
            },
        }
    },
    outlinedSuccess: {
        color: theme.palette.success.main,
        border: "1px solid " + core_1.alpha(theme.palette.success.main, 0.5),
        '&:hover': {
            border: "1px solid " + theme.palette.success.main,
            backgroundColor: core_1.alpha(theme.palette.success.main, theme.palette.action.hoverOpacity),
            '@media (hover: none)': {
                backgroundColor: 'transparent',
            },
        }
    },
    textSuccess: {
        color: theme.palette.success.main,
        '&:hover': {
            backgroundColor: core_1.alpha(theme.palette.success.main, theme.palette.action.hoverOpacity),
            '@media (hover: none)': {
                backgroundColor: 'transparent',
            },
        }
    },
    containedWarning: {
        color: theme.palette.warning.contrastText,
        backgroundColor: theme.palette.warning.main,
        '&:hover': {
            backgroundColor: theme.palette.warning.dark,
            '@media (hover: none)': {
                backgroundColor: theme.palette.warning.main,
            },
        }
    },
    outlinedWarning: {
        color: theme.palette.warning.main,
        border: "1px solid " + core_1.alpha(theme.palette.warning.main, 0.5),
        '&:hover': {
            border: "1px solid " + theme.palette.warning.main,
            backgroundColor: core_1.alpha(theme.palette.warning.main, theme.palette.action.hoverOpacity),
            '@media (hover: none)': {
                backgroundColor: 'transparent',
            },
        }
    },
    textWarning: {
        color: theme.palette.warning.main,
        '&:hover': {
            backgroundColor: core_1.alpha(theme.palette.warning.main, theme.palette.action.hoverOpacity),
            '@media (hover: none)': {
                backgroundColor: 'transparent',
            },
        }
    },
    containedDanger: {
        color: theme.palette.error.contrastText,
        backgroundColor: theme.palette.error.main,
        '&:hover': {
            backgroundColor: theme.palette.error.dark,
            '@media (hover: none)': {
                backgroundColor: theme.palette.error.main,
            },
        }
    },
    outlinedDanger: {
        color: theme.palette.error.main,
        border: "1px solid " + core_1.alpha(theme.palette.error.main, 0.5),
        '&:hover': {
            border: "1px solid " + theme.palette.error.main,
            backgroundColor: core_1.alpha(theme.palette.error.main, theme.palette.action.hoverOpacity),
            '@media (hover: none)': {
                backgroundColor: 'transparent',
            },
        }
    },
    textDanger: {
        color: theme.palette.error.main,
        '&:hover': {
            backgroundColor: core_1.alpha(theme.palette.error.main, theme.palette.action.hoverOpacity),
            '@media (hover: none)': {
                backgroundColor: 'transparent',
            },
        }
    },
}); });
function Button(_a) {
    var _b;
    var _c = _a.color, color = _c === void 0 ? 'default' : _c, _d = _a.variant, variant = _d === void 0 ? 'text' : _d, className = _a.className, props = __rest(_a, ["color", "variant", "className"]);
    var classes = useStyles();
    function checarCor() {
        switch (color) {
            case 'primary':
                return 'primary';
            case 'secondary':
                return 'secondary';
            case 'inherit':
                return 'inherit';
            default:
                return 'default';
        }
    }
    return (react_1.default.createElement(Button_1.default, __assign({ variant: variant, color: checarCor(), className: clsx_1.default(classes[variant], (_b = {}, _b[classes["" + variant + core_1.capitalize(color)]] = color !== 'default' && color !== 'inherit' && color !== 'primary' && color !== 'secondary', _b), className) }, props), props.children));
}
exports.default = Button;
Button.propTypes = {
    children: prop_types_1.default.node.isRequired,
    classes: prop_types_1.default.object,
    className: prop_types_1.default.string,
    color: prop_types_1.default.oneOf(['default', 'inherit', 'primary', 'secondary', 'info', 'success', 'warning', 'danger']),
    component: prop_types_1.default.elementType,
    disabled: prop_types_1.default.bool,
    disableElevation: prop_types_1.default.bool,
    disableFocusRipple: prop_types_1.default.bool,
    disableRipple: prop_types_1.default.bool,
    endIcon: prop_types_1.default.node,
    focusVisibleClassName: prop_types_1.default.string,
    fullWidth: prop_types_1.default.bool,
    href: prop_types_1.default.string,
    size: prop_types_1.default.oneOf(['small', 'medium', 'large']),
    startIcon: prop_types_1.default.node,
    type: prop_types_1.default.string,
    variant: prop_types_1.default.oneOf(['text', 'outlined', 'contained']),
};
