"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
// keyCode constants
var BACKSPACE = 8;
var LEFT_ARROW = 37;
var RIGHT_ARROW = 39;
var DELETE = 46;
var SPACEBAR = 32;
var ENTER = 13;
var useStyles = core_1.makeStyles(function (theme) {
    var _a;
    return ({
        field: (_a = {
                '& [class*="MuiInputBase-root"]': {
                    height: '100%',
                    fontSize: 'inherit'
                }
            },
            _a[theme.breakpoints.up('xs')] = {
                margin: theme.spacing(0),
                width: '1em',
                height: '1em',
                fontSize: '.6em'
            },
            _a[theme.breakpoints.up('sm')] = {
                margin: theme.spacing(1),
                width: '1em',
                height: '1em',
                fontSize: '.6em'
            },
            _a[theme.breakpoints.up('md')] = {
                margin: theme.spacing(1),
                width: '1.2em',
                height: '1.2em',
                fontSize: '.8em'
            },
            _a[theme.breakpoints.up('lg')] = {
                margin: theme.spacing(2),
                width: '1.5em',
                height: '1.5em',
            },
            _a[theme.breakpoints.up('xl')] = {
                margin: theme.spacing(2),
                width: '1.6em',
                height: '1.6em',
            },
            _a),
        input: {
            textAlign: 'center',
            textTransform: 'uppercase',
            padding: 0
        }
    });
});
var SingleOtpInput = function (_a) {
    var separator = _a.separator, isLastChild = _a.isLastChild, focus = _a.focus, autoFocus = _a.autoFocus, index = _a.index, value = _a.value, placeholder = _a.placeholder, props = __rest(_a, ["separator", "isLastChild", "focus", "autoFocus", "index", "value", "placeholder"]);
    var classes = useStyles();
    var inputRef = react_1.useRef();
    // Focus on first render
    // Only when autoFocus is true
    react_1.useEffect(function () {
        if ((inputRef === null || inputRef === void 0 ? void 0 : inputRef.current) && focus && autoFocus)
            inputRef.current.focus();
    }, [focus, autoFocus]);
    utils_1.useUpdateEffect(function () {
        // Check if focusedInput changed
        // Prevent calling function if input already in focus
        if ((inputRef === null || inputRef === void 0 ? void 0 : inputRef.current) && focus) {
            inputRef.current.focus();
            inputRef.current.select();
        }
    }, [focus]);
    return react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(core_1.TextField, __assign({ className: classes.field, variant: 'outlined', inputProps: __assign(__assign({}, props.inputProps), { className: classes.input, autoComplete: 'off', maxLength: '1', ref: inputRef }), value: value || '', placeholder: placeholder && placeholder[index] }, props)),
        !isLastChild && separator);
};
var OtpInput = function (_a) {
    var _b = _a.numInputs, numInputs = _b === void 0 ? 6 : _b, _c = _a.onChange, onChange = _c === void 0 ? function (otp) { return void (otp); } : _c, _d = _a.value, value = _d === void 0 ? '' : _d, _e = _a.onConfirm, onConfirm = _e === void 0 ? function (otp) { return void (otp); } : _e, props = __rest(_a, ["numInputs", "onChange", "value", "onConfirm"]);
    var _f = react_1.useState(0), activeInput = _f[0], setActiveInput = _f[1];
    var _g = react_1.useState((value === null || value === void 0 ? void 0 : value.toString().split('')) || []), localValue = _g[0], setLocalValue = _g[1];
    var otpValue = (value === null || value === void 0 ? void 0 : value.toString().split('')) || localValue;
    // Helper to return OTP from input
    var handleOtpChange = function (otp) {
        var _a;
        setLocalValue(otp);
        onChange((_a = otp.join('')) === null || _a === void 0 ? void 0 : _a.toUpperCase());
    };
    // Focus on input by index
    var focusInput = function (input) { return setActiveInput(Math.max(Math.min(numInputs - 1, input), 0)); };
    // Focus on next input
    var focusNextInput = function () { return focusInput(activeInput + 1); };
    // Focus on previous input
    var focusPrevInput = function () { return focusInput(activeInput - 1); };
    // Change OTP value at focused input
    var changeCodeAtFocus = function (value) {
        var otp = otpValue;
        otp[activeInput] = value[0];
        handleOtpChange(otp);
    };
    // Handle pasted OTP
    var handleOnPaste = function (e) {
        e.preventDefault();
        var disabled = props.disabled;
        if (disabled)
            return;
        var otp = otpValue;
        var nextActiveInput = activeInput;
        // Get pastedData in an array of max size (num of inputs - current position)
        var pastedData = e.clipboardData
            .getData('text/plain')
            .slice(0, numInputs - activeInput)
            .split('');
        // Paste data from focused input onwards
        for (var pos = 0; pos < numInputs; ++pos) {
            if (pos >= activeInput && pastedData.length > 0) {
                otp[pos] = pastedData.shift() || '';
                nextActiveInput++;
            }
        }
        setActiveInput(nextActiveInput);
        setTimeout(function () {
            focusInput(nextActiveInput);
            handleOtpChange(otp);
        }, 0);
    };
    var handleOnChange = function (e) { return changeCodeAtFocus(e.target.value); };
    // Handle cases of backspace, delete, left arrow, right arrow, space
    var handleOnKeyDown = function (e) {
        var _a;
        if (e.keyCode === BACKSPACE || e.key === 'Backspace') {
            e.preventDefault();
            changeCodeAtFocus('');
            focusPrevInput();
        }
        else if (e.keyCode === DELETE || e.key === 'Delete') {
            e.preventDefault();
            changeCodeAtFocus('');
        }
        else if (e.keyCode === LEFT_ARROW || e.key === 'ArrowLeft') {
            e.preventDefault();
            focusPrevInput();
        }
        else if (e.keyCode === RIGHT_ARROW || e.key === 'ArrowRight') {
            e.preventDefault();
            focusNextInput();
        }
        else if (e.keyCode === SPACEBAR || e.key === ' ' || e.key === 'Spacebar' || e.key === 'Space') {
            e.preventDefault();
        }
        else if (e.keyCode === ENTER || e.key === 'Enter') {
            onConfirm((_a = otpValue.join('')) === null || _a === void 0 ? void 0 : _a.toUpperCase());
        }
    };
    // The content may not have changed, but some input took place hence change the focus
    var handleOnInput = function () { return focusNextInput(); };
    var handleFocus = function (i) { return function (e) {
        setActiveInput(i);
        e.target.select();
    }; };
    var handleBlur = function () { return setActiveInput(-1); };
    return (react_1.default.createElement(core_1.Box, { display: 'flex', alignItems: 'center', justifyContent: 'center', fontSize: '8em' }, Array(numInputs).fill(0).map(function (_, i) { return (react_1.default.createElement(SingleOtpInput, __assign({}, props, { key: i, index: i, focus: activeInput === i, value: otpValue[i], onChange: handleOnChange, onKeyDown: handleOnKeyDown, onInput: handleOnInput, onPaste: handleOnPaste, onFocus: handleFocus(i), onBlur: handleBlur, isLastChild: i === numInputs - 1 }))); })));
};
exports.default = OtpInput;
