"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var useStyles = core_1.makeStyles(function (theme) { return ({
    container: {
        display: 'flex',
        overflow: 'hidden',
        borderRadius: 4,
        color: theme.palette.type === 'light' ? '#fff' : '#000',
        background: "linear-gradient(90deg, rgba(0,0,0,0) 0%, rgba(" + (theme.palette.type === 'light' ? '66,66,66' : '255,255,255') + ",1) 3%)"
    },
    messageDiv: {
        padding: '.5rem 1rem'
    },
    gradientStripe: {
        width: '1rem',
        background: 'linear-gradient(180deg, rgba(131,58,180,1) 0%, rgba(253,29,29,1) 50%, rgba(252,176,69,1) 100%)'
    }
}); });
var SnackbarTransition = function (props) { return react_1.default.createElement(core_1.Slide, __assign({}, props, { direction: 'up' })); };
var PageCodeEasterEgg = function (_a) {
    var code = _a.code, usuarioLogado = _a.usuarioLogado;
    var classes = useStyles();
    var _b = react_1.useState(false), open = _b[0], setOpen = _b[1];
    function easterEggListener(e) {
        var teamMember = (usuarioLogado === null || usuarioLogado === void 0 ? void 0 : usuarioLogado.idFornecedorInterno) === 1; // Membro da TI
        if (teamMember && code && !open && e.ctrlKey && e.shiftKey && e.key === 'Z')
            setOpen(true);
    }
    react_1.useEffect(function () {
        document.addEventListener('keydown', easterEggListener, false);
        return function () { return document.removeEventListener('keydown', easterEggListener, false); };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    var handleClose = function (_) { return setOpen(false); };
    return react_1.default.createElement(core_1.Snackbar, { open: open, onClose: handleClose, autoHideDuration: 5000, TransitionComponent: SnackbarTransition, anchorOrigin: { vertical: 'bottom', horizontal: 'left' } },
        react_1.default.createElement("div", { className: classes.container },
            react_1.default.createElement("div", { className: classes.gradientStripe }),
            react_1.default.createElement("div", { className: classes.messageDiv },
                react_1.default.createElement(core_1.Typography, { variant: 'subtitle1' }, "Hi, dev!"),
                react_1.default.createElement(core_1.Typography, { variant: 'body1' }, "The page code is " + code + "."))));
};
var mapStateToProps = function (state) { return ({
    usuarioLogado: state.argous.usuarioLogado
}); };
exports.default = react_redux_1.connect(mapStateToProps)(PageCodeEasterEgg);
