"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var clsx_1 = __importDefault(require("clsx"));
var react_1 = __importStar(require("react"));
var lib_1 = require("react-icons/lib");
var md_1 = require("react-icons/md");
var ColorlibConnector = core_1.withStyles(function (theme) { return ({
    alternativeLabel: function (_a) {
        var orientation = _a.orientation;
        return orientation === 'vertical' ? {
            top: -28,
            transform: 'rotate(90deg)',
            left: 'calc(-50% + 40px)',
            right: 'calc(50% + 10px)',
            '&>span': {
                minHeight: 3
            }
        } : {
            top: 22,
        };
    },
    active: {
        '& $line': {
            backgroundPosition: 'left bottom'
        },
    },
    completed: {
        '& $line': {
            backgroundPosition: 'left bottom',
            backgroundImage: "linear-gradient( to right, " + theme.palette.secondary.main + " 0%," + theme.palette.secondary.main + " 50%,#eaeaf0 51%, #eaeaf0 100%)",
        },
    },
    line: {
        height: 3,
        border: 0,
        backgroundImage: "linear-gradient( to right, " + theme.palette.secondary.main + " 0%," + theme.palette.primary.main + " 50%,#eaeaf0 51%, #eaeaf0 100%)",
        backgroundSize: '200% 100%',
        backgroundPosition: 'right bottom',
        transition: 'background-position 500ms ease',
        borderRadius: 1,
    }
}); })(core_1.StepConnector);
var ColorlibStepIcon = core_1.withStyles(function (theme) { return ({
    root: {
        zIndex: 1,
        color: '#fff',
        width: 50,
        height: 50,
        display: 'flex',
        borderRadius: '50%',
        justifyContent: 'center',
        alignItems: 'center',
        fontSize: 24,
        backgroundColor: theme.palette.type === 'light' ? '#ccc' : '#838383',
        transition: 'all 400ms ease 100ms'
    },
    initial: theme.palette.type === 'light' ? {
        backgroundColor: function (_a) {
            var ambienteTeste = _a.ambienteTeste;
            return ambienteTeste ? '#ffc7a2' : '#9acbb8';
        }
    } : {
        backgroundColor: function (_a) {
            var ambienteTeste = _a.ambienteTeste;
            return ambienteTeste ? '#8b6751' : '#507265';
        }
    },
    active: {
        backgroundColor: function (_a) {
            var ambienteTeste = _a.ambienteTeste;
            return ambienteTeste ? '#f5781e !important' : '#00995D !important';
        },
        boxShadow: theme.shadows[5],
    },
    completed: {
        backgroundColor: '#2979ff !important',
    },
    error: {
        backgroundColor: '#f44336 !important',
    },
    icon: {
        '& path': {
            stroke: '#FFF'
        }
    }
}); })(function (_a) {
    var _b;
    var initial = _a.initial, active = _a.active, completed = _a.completed, icon = _a.icon, classes = _a.classes, error = _a.error;
    return (react_1.default.createElement("div", { className: clsx_1.default(classes.root, (_b = {},
            _b[classes.initial] = initial,
            _b[classes.active] = active,
            _b[classes.completed] = completed,
            _b[classes.error] = error,
            _b)) },
        react_1.default.createElement(lib_1.IconContext.Provider, { value: { className: classes.icon } }, icon)));
});
var stepperStyles = function (theme) {
    var _a;
    return ({
        root: {
            '&>div': {
                minHeight: 'calc(100vh - 50px)'
            }
        },
        header: {
            background: theme.palette.background.default,
            marginTop: -10,
        },
        caption: {
            display: 'block',
            textAlign: 'center',
            color: theme.palette.text.hint
        },
        selectedCaption: {
            color: theme.palette.text.secondary
        },
        stepper: (_a = {
                padding: function (_a) {
                    var orientation = _a.orientation;
                    return orientation === 'vertical' ? '0 0 0 136px' : '';
                }
            },
            _a[theme.breakpoints.down('sm')] = {
                padding: 0
            },
            _a['&>div'] = {
                display: 'flex',
                padding: function (_a) {
                    var orientation = _a.orientation;
                    return orientation === 'vertical' ? '0 0 30px' : '';
                },
                '&>button': {
                    '&>span:nth-child(1)': {
                        flexDirection: function (_a) {
                            var orientation = _a.orientation;
                            return orientation === 'vertical' ? 'row' : 'column';
                        }
                    }
                }
            },
            _a),
        subDescription: {
            minWidth: 140,
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'end',
            position: 'absolute',
            top: 17,
            left: -148,
        },
        icon: {
            fontSize: theme.typography.fontSize * 2,
            '& path': {
                stroke: theme.palette.text.primary
            }
        },
        mobileDivider: {
            marginBottom: theme.spacing(2)
        },
        stepLabel: {
            '&>span:nth-child(2)': {
                margin: function (_a) {
                    var orientation = _a.orientation;
                    return orientation === 'vertical' ? '0 0 0 8px' : '';
                },
                '&>span:nth-child(1)': {
                    margin: function (_a) {
                        var orientation = _a.orientation;
                        return orientation === 'vertical' ? 0 : '';
                    }
                }
            },
        }
    });
};
var Stepper = function (_a) {
    var children = _a.children, _b = _a.classes, classes = _b === void 0 ? {} : _b, _c = _a.steps, steps = _c === void 0 ? [] : _c, _d = _a.onClick, onClick = _d === void 0 ? function (index) { return function (event) { return void (index, event); }; } : _d, _e = _a.onNext, onNext = _e === void 0 ? function (event) { return void (event); } : _e, _f = _a.onPrevious, onPrevious = _f === void 0 ? function (event) { return void (event); } : _f, _g = _a.onFinish, onFinish = _g === void 0 ? function (event) { return void (event); } : _g, maxStepProps = _a.maxStep, _h = _a.activeStep, activeStep = _h === void 0 ? 0 : _h, _j = _a.errors, errors = _j === void 0 ? [] : _j, _k = _a.component, Component = _k === void 0 ? 'div' : _k, _l = _a.backLabel, backLabel = _l === void 0 ? 'Voltar' : _l, _m = _a.nextLabel, nextLabel = _m === void 0 ? 'Avançar' : _m, _o = _a.finishLabel, finishLabel = _o === void 0 ? 'Finalizar' : _o, _p = _a.disableFinish, disableFinish = _p === void 0 ? false : _p, _q = _a.disableNext, disableNext = _q === void 0 ? false : _q, _r = _a.disablePrevious, disablePrevious = _r === void 0 ? false : _r, _s = _a.showProgress, showProgress = _s === void 0 ? false : _s, _t = _a.disableActions, disableActions = _t === void 0 ? false : _t, _u = _a.orientation, orientation = _u === void 0 ? 'horizontal' : _u, props = __rest(_a, ["children", "classes", "steps", "onClick", "onNext", "onPrevious", "onFinish", "maxStep", "activeStep", "errors", "component", "backLabel", "nextLabel", "finishLabel", "disableFinish", "disableNext", "disablePrevious", "showProgress", "disableActions", "orientation"]);
    var theme = core_1.useTheme();
    var maxSteps = steps.length;
    var maxStep = maxStepProps || steps.length - 1;
    var mobile = core_1.useMediaQuery(theme.breakpoints.down(Math.max(maxSteps * 100, theme.breakpoints.values.sm)));
    var ambienteTeste = JSON.parse(window.localStorage.getItem('ambienteTeste'));
    var _v = react_1.useState(-1), initialStep = _v[0], setInitialStep = _v[1];
    react_1.useEffect(function () { return (activeStep > initialStep && showProgress) && setInitialStep(activeStep); }, [activeStep, initialStep, showProgress]);
    return react_1.default.createElement(Component, __assign({}, props),
        mobile && orientation !== 'vertical' ? (react_1.default.createElement(core_1.Paper, { square: true, elevation: 0 },
            react_1.default.createElement(core_1.ListItem, { dense: true, className: classes.header },
                react_1.default.createElement(core_1.ListItemIcon, { className: classes.icon }, steps[activeStep][0]),
                react_1.default.createElement(core_1.ListItemText, { primary: steps[activeStep][1], secondary: steps[activeStep][2] })),
            react_1.default.createElement(core_1.Divider, { className: classes.mobileDivider }))) : (react_1.default.createElement(core_1.Stepper, { className: classes.stepper, alternativeLabel: true, activeStep: activeStep, orientation: orientation, connector: react_1.default.createElement(ColorlibConnector, null) }, steps.map(function (_a, i) {
            var _b, _c, _d;
            var icon = _a[0], label = _a[1], description = _a[2], subDescription = _a[3];
            return (react_1.default.createElement(core_1.Step, { key: label },
                orientation === 'vertical' && subDescription &&
                    react_1.default.createElement("div", { className: classes.subDescription },
                        react_1.default.createElement(core_1.Typography, { variant: 'caption', className: clsx_1.default(classes.caption, (_b = {}, _b[classes.selectedCaption] = activeStep >= i, _b)) }, subDescription)),
                react_1.default.createElement(core_1.StepButton, { onClick: onClick(i), disabled: i > maxStep, optional: react_1.default.createElement(react_1.default.Fragment, null,
                        react_1.default.createElement(core_1.Typography, { variant: 'caption', className: clsx_1.default(classes.caption, (_c = {}, _c[classes.selectedCaption] = activeStep >= i, _c)) }, description),
                        orientation !== 'vertical' && subDescription &&
                            react_1.default.createElement(core_1.Typography, { variant: 'caption', className: clsx_1.default(classes.caption, (_d = {}, _d[classes.selectedCaption] = activeStep >= i, _d)) }, subDescription)) },
                    react_1.default.createElement(core_1.StepLabel, { className: classes.stepLabel, disabled: i > maxStep, error: errors[i], StepIconComponent: ColorlibStepIcon, StepIconProps: { icon: icon, error: errors[i], initial: initialStep >= i, ambienteTeste: ambienteTeste } }, label))));
        }))),
        children &&
            react_1.default.createElement(core_1.Box, { padding: mobile ? 0 : 4, pt: 1, pb: 0 }, children),
        mobile && orientation !== 'vertical' ? (react_1.default.createElement(core_1.MobileStepper, { steps: maxSteps, position: 'bottom', variant: 'dots', activeStep: activeStep, backButton: react_1.default.createElement(core_1.Button, { startIcon: react_1.default.createElement(md_1.MdChevronLeft, null), onClick: onPrevious, disabled: activeStep === 0 }, backLabel), nextButton: react_1.default.createElement(core_1.Button, { variant: 'contained', color: 'primary', endIcon: activeStep === maxSteps - 1 ? react_1.default.createElement(md_1.MdCheck, null) : react_1.default.createElement(md_1.MdChevronRight, null), onClick: activeStep === steps.length - 1 ? onFinish : onNext }, activeStep === steps.length - 1 ? finishLabel : nextLabel) })) : !disableActions ? (react_1.default.createElement(core_1.DialogActions, null,
            react_1.default.createElement(core_1.Box, { padding: mobile ? 0 : 4, paddingTop: 1, paddingBottom: 1 },
                react_1.default.createElement(core_1.Button, { disabled: activeStep === 0 || disablePrevious, onClick: onPrevious }, backLabel),
                react_1.default.createElement(core_1.Button, { variant: 'contained', color: 'primary', onClick: activeStep === steps.length - 1 ? onFinish : onNext, disabled: activeStep === steps.length - 1 ? disableFinish : disableNext }, activeStep === steps.length - 1 ? finishLabel : nextLabel)))) : null);
};
exports.default = core_1.withStyles(stepperStyles, { name: 'ArgousStepper' })(Stepper);
