"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fieldsRedux_1 = require("../../fieldsRedux");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
/**
 * @deprecated
 */
var TextArea = /** @class */ (function (_super) {
    __extends(TextArea, _super);
    function TextArea() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onChange = function (event) {
            var onChange = _this.props.onChange;
            var value = event.target.value;
            if (onChange) {
                onChange(value);
            }
            _this.props.handleUpdates(value);
            _this.stopWritingHandler(value);
        };
        _this.stopWritingHandler = function (value) {
            var _a = _this.props, stopWriting = _a.stopWriting, _b = _a.stopWritingTime, stopWritingTime = _b === void 0 ? 2000 : _b;
            if (stopWriting) {
                clearTimeout(_this.stopWritingTimeout);
                _this.stopWritingTimeout = setTimeout(function () {
                    stopWriting(value);
                }, stopWritingTime);
            }
        };
        _this.checkTextAreaProps = function () {
            var _a = _this.props, field = _a.field, autoComplete = _a.autoComplete, autoFocus = _a.autoFocus, cols = _a.cols, rows = _a.rows, disabled = _a.disabled, form = _a.form, maxLength = _a.maxLength, minLength = _a.minLength, name = _a.name, placeholder = _a.placeholder, spellCheck = _a.spellCheck, wrap = _a.wrap, style = _a.style;
            var className = "" + (_this.props.className ? _this.props.className : 'form-control');
            var onChange = _this.onChange;
            var value = fieldsRedux_1.getField(field, 'value');
            return {
                className: className,
                onChange: onChange,
                value: value,
                autoComplete: autoComplete,
                autoFocus: autoFocus,
                cols: cols,
                rows: rows,
                disabled: disabled,
                form: form,
                maxLength: maxLength,
                minLength: minLength,
                name: name,
                placeholder: placeholder,
                spellCheck: spellCheck,
                wrap: wrap,
                style: style
            };
        };
        return _this;
    }
    TextArea.prototype.componentWillUnmount = function () {
        if (this.props.stopWriting) {
            clearTimeout(this.stopWritingTimeout);
        }
    };
    TextArea.prototype.render = function () {
        var checkTextAreaProps = this.checkTextAreaProps;
        var textAreaProps = checkTextAreaProps();
        return (react_1.default.createElement("textarea", __assign({}, textAreaProps)));
    };
    return TextArea;
}(react_1.Component));
TextArea.propTypes = {
    field: prop_types_1.default.string.isRequired,
    defaultValue: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string, prop_types_1.default.object, prop_types_1.default.array]),
    ajax: prop_types_1.default.bool,
    action: prop_types_1.default.string,
    dados: prop_types_1.default.object,
    sendUpdates: prop_types_1.default.array,
    receiveUpdates: prop_types_1.default.array,
    onChange: prop_types_1.default.func,
    onFieldSuccess: prop_types_1.default.func,
    onActionSuccess: prop_types_1.default.func,
    onAllUpdated: prop_types_1.default.func,
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool,
    autoComplete: prop_types_1.default.oneOf(['on', 'off']),
    autoFocus: prop_types_1.default.bool,
    cols: prop_types_1.default.string,
    rows: prop_types_1.default.string,
    disabled: prop_types_1.default.bool,
    form: prop_types_1.default.string,
    maxLength: prop_types_1.default.string,
    minLength: prop_types_1.default.string,
    className: prop_types_1.default.string,
    style: prop_types_1.default.object,
    name: prop_types_1.default.string,
    placeholder: prop_types_1.default.string,
    spellCheck: prop_types_1.default.oneOf(['default', 'true', 'false']),
    wrap: prop_types_1.default.oneOf(['hard', 'soft', 'off']),
    stopWriting: prop_types_1.default.func,
    stopWritingTime: prop_types_1.default.number
};
exports.default = fieldsRedux_1.createField(TextArea);
