"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
var react_colorful_1 = require("react-colorful");
var ri_1 = require("react-icons/ri");
var ICON_SIZE = '2.5rem';
var BOX_SHADOW = 'rgba(0, 0, 0, 0.3) 0px 1px 12px -2px';
var useStyles = core_1.makeStyles(function (theme) { return ({
    container: {
        zIndex: 1,
        position: 'absolute',
        top: 0,
        right: 0,
        display: 'flex',
        alignItems: 'flex-start',
        justifyContent: 'flex-end',
        gap: function (_a) {
            var defaultSpacing = _a.defaultSpacing;
            return (defaultSpacing) ? defaultSpacing : '';
        }
    },
    button: {
        padding: function (_a) {
            var defaultSpacing = _a.defaultSpacing;
            return (defaultSpacing) ? (defaultSpacing / 2) : '';
        },
        color: "rgba(" + ((theme.palette.type === 'light') ? '0, 0, 0' : '255, 255, 255') + ", .7)",
        backgroundColor: "rgba(" + ((theme.palette.type === 'light') ? '255, 255, 255' : '0, 0, 0') + ", .5)",
        '&:hover': {
            backgroundColor: "rgba(" + ((theme.palette.type === 'light') ? '255, 255, 255' : '0, 0, 0') + ", .7)"
        }
    },
    colorPickerContainer: {
        zIndex: 2,
        position: 'absolute',
        padding: '2rem'
    },
    colorPickerBoxShadow: {
        borderRadius: 8,
        webKitBoxShadow: BOX_SHADOW,
        mozBoxShadow: BOX_SHADOW,
        boxShadow: BOX_SHADOW
    }
}); });
var initialStateOpen = {
    colorPicker: undefined
};
var initialState = {
    open: initialStateOpen
};
var TextStyles = function (_a) {
    var color = _a.color, setColor = _a.setColor, defaultSpacing = _a.defaultSpacing, toggleClickAway = _a.toggleClickAway, handleFontSizeChange = _a.handleFontSizeChange, textAlign = _a.textAlign, handleTextAlignChange = _a.handleTextAlignChange;
    var classes = useStyles({ defaultSpacing: defaultSpacing });
    var _b = react_1.useState(initialState), state = _b[0], setState = _b[1];
    var open = state.open;
    var logicSetState = function (type, field, value) { return setState(function (values) {
        var _a, _b;
        return (__assign(__assign({}, values), (_a = {}, _a[type] = (type && field) ? __assign(__assign({}, values[type]), (_b = {}, _b[field] = value, _b)) : value, _a)));
    }); };
    var handleColorPickerOpen = function (e) {
        toggleClickAway();
        var elRect = e.target.parentElement.getBoundingClientRect();
        logicSetState('open', 'colorPicker', elRect);
    };
    var handleColorPickerClose = function (e) {
        toggleClickAway();
        logicSetState('open', 'colorPicker', undefined);
    };
    return react_1.default.createElement("div", { className: classes.container },
        react_1.default.createElement(core_1.IconButton, { onClick: handleTextAlignChange, onTouchStart: handleTextAlignChange, className: classes.button }, (function () {
            switch (textAlign) {
                case 'start':
                    return react_1.default.createElement(ri_1.RiAlignLeft, { size: ICON_SIZE });
                case 'end':
                    return react_1.default.createElement(ri_1.RiAlignRight, { size: ICON_SIZE });
                case 'center':
                    return react_1.default.createElement(ri_1.RiAlignCenter, { size: ICON_SIZE });
                case 'justify':
                    return react_1.default.createElement(ri_1.RiAlignJustify, { size: ICON_SIZE });
                default:
                    return null;
            }
        })()),
        react_1.default.createElement(core_1.IconButton, { onClick: handleColorPickerOpen, onTouchStart: handleColorPickerOpen, className: classes.button },
            react_1.default.createElement(ri_1.RiFontColor, { size: ICON_SIZE })),
        react_1.default.createElement(core_1.IconButton, { onClick: handleFontSizeChange, onTouchStart: handleFontSizeChange, className: classes.button },
            react_1.default.createElement(ri_1.RiFontSize, { size: ICON_SIZE })),
        (!!open.colorPicker) && (react_1.default.createElement(core_1.ClickAwayListener, { disableReactTree: true, onClickAway: handleColorPickerClose },
            react_1.default.createElement("div", { className: classes.colorPickerContainer },
                react_1.default.createElement("div", { className: classes.colorPickerBoxShadow },
                    react_1.default.createElement(react_colorful_1.RgbaColorPicker, { color: color, onChange: setColor }))))));
};
exports.default = TextStyles;
