export interface TextToHtmlInitialValue { 
  text?: string, 
  cssText?: string 
}

export interface TextToHtmlProps {
  /**
   * Object containing properties to use as initial value
   */
  initialValue?: TextToHtmlInitialValue, 
  /**
   * Function called on change
   * @param htmlString 
   * @returns 
   */
  onChange?: (htmlString: string) => void, 
  /**
   * Function called on delete
   * @param event 
   * @param deleted 
   * @param newCharacters 
   * @returns 
   */
  onDelete?: (event: Event, deleted: object, newCharacters: Array<object>) => void, 
  /**
   * Number to represent the default spacing in pixels
   */
  defaultSpacing?: number, 
  /**
   * Function called to set external values
   */
  setExternalValues?: (state: object) => void
}


declare function TextToHtml(props: TextToHtmlProps) : JSX.Element

export default TextToHtml;