"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.translateKey = exports.getCharacterElement = exports.createCharactersWithMark = exports.SEARCH_PEOPLE_SYMBOL = exports.DEAD_KEY = void 0;
var TextToHtml_1 = require("./TextToHtml");
exports.DEAD_KEY = 'Dead';
exports.SEARCH_PEOPLE_SYMBOL = '@';
var space = {
    'key': ' ',
    'keyCode': 32,
    'code': 'Space',
    'string': ' ',
    'dead': false,
    'shift': false
};
var createCharactersWithMark = function (string, mark) {
    var characters = [];
    for (var i = 0; i < (string === null || string === void 0 ? void 0 : string.length); i++) {
        characters.push(__assign(__assign({}, TextToHtml_1.initialStateCharacter), { string: string[i], mark: mark }));
    }
    characters.push(space);
    return { markedCharacters: characters };
};
exports.createCharactersWithMark = createCharactersWithMark;
var getCharacterElement = function (_a) {
    var index = _a.index;
    var response = {
        nodeElement: undefined,
        rect: undefined
    };
    var parentElement = document.getElementById(TextToHtml_1.TEXT_TO_HTML_ID);
    if (parentElement) {
        var childNodes = parentElement.childNodes[0].childNodes;
        var targetElement = childNodes[index];
        var targetElementRect = targetElement.getBoundingClientRect();
        response = __assign(__assign({}, response), { nodeElement: targetElement, rect: targetElementRect });
    }
    return response;
};
exports.getCharacterElement = getCharacterElement;
var translateKey = function (_a) {
    var _b, _c, _d;
    var key = _a.key, keyCode = _a.keyCode, code = _a.code, shift = _a.shift, altGraph = _a.altGraph, capsLock = _a.capsLock, before = _a.before;
    var response = {
        string: '',
        dead: false,
        before: {
            dead: false,
            delete: false
        }
    };
    if (key === exports.DEAD_KEY) {
        if (code === 'BracketLeft') {
            response.string = (shift) ? '`' : '´';
        }
        else if (code === 'Quote') {
            response.string = (shift) ? '^' : '~';
        }
        else if (code === 'Digit6') {
            response.string = (shift) ? '¨' : '';
        }
        response.before.dead = true;
    }
    else if (before === null || before === void 0 ? void 0 : before.dead) {
        var targetKey = (_b = KEYS(shift, before === null || before === void 0 ? void 0 : before.shift, altGraph, capsLock).filter(function (keyItem) { return (((keyItem.key === key) || (keyItem.keyCode === keyCode)) && (keyItem.code === code)); })) === null || _b === void 0 ? void 0 : _b[0];
        var specialKey = (_c = targetKey === null || targetKey === void 0 ? void 0 : targetKey.special.filter(function (special) { return special.string === (before === null || before === void 0 ? void 0 : before.string); })) === null || _c === void 0 ? void 0 : _c[0];
        var special = specialKey === null || specialKey === void 0 ? void 0 : specialKey.value;
        response.string = special ? special : targetKey === null || targetKey === void 0 ? void 0 : targetKey.key;
        response.before.delete = special ? true : false;
        response.before.dead = false;
    }
    else {
        var targetKey = (_d = KEYS(shift, before === null || before === void 0 ? void 0 : before.shift, altGraph, capsLock).filter(function (keyItem) { return (((keyItem.key === key) || (keyItem.keyCode === keyCode)) && (keyItem.code === code)); })) === null || _d === void 0 ? void 0 : _d[0];
        response.string = targetKey === null || targetKey === void 0 ? void 0 : targetKey.key;
    }
    return response;
};
exports.translateKey = translateKey;
var KEYS = function (shift, beforeShift, altGraph, capsLock) { return [
    {
        key: (shift || capsLock) ? 'W' : 'w',
        keyCode: 87,
        code: 'KeyW',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: (beforeShift) ? '`' : '´',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ẁ' : 'ẁ') : ((shift || capsLock) ? 'Ẃ' : 'ẃ')
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ŵ' : 'ŵ') : ((shift || capsLock) ? '' : '')
            },
            {
                code: 'Digit6',
                key: 'Dead',
                keyCode: 54,
                string: (beforeShift) ? '¨' : '',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ẅ' : 'ẅ') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'E' : 'e',
        keyCode: 69,
        code: 'KeyE',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: (beforeShift) ? '`' : '´',
                value: (beforeShift) ? ((shift || capsLock) ? 'È' : 'è') : ((shift || capsLock) ? 'É' : 'é')
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ê' : 'ê') : ((shift || capsLock) ? 'Ẽ' : 'ẽ')
            },
            {
                code: 'Digit6',
                key: 'Dead',
                keyCode: 54,
                string: (beforeShift) ? '¨' : '',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ë' : 'ë') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'R' : 'r',
        keyCode: 82,
        code: 'KeyR',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: '´',
                value: (shift || capsLock) ? 'Ŕ' : 'ŕ'
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'Y' : 'y',
        keyCode: 89,
        code: 'KeyY',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: (beforeShift) ? '`' : '´',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ỳ' : 'ỳ') : ((shift || capsLock) ? 'Ý' : 'ý')
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ŷ' : 'ŷ') : ((shift || capsLock) ? 'Ỹ' : 'ỹ')
            },
            {
                code: 'Digit6',
                key: 'Dead',
                keyCode: 54,
                string: (beforeShift) ? '¨' : '',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ÿ' : 'ÿ') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'U' : 'u',
        keyCode: 85,
        code: 'KeyU',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: (beforeShift) ? '`' : '´',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ù' : 'ù') : ((shift || capsLock) ? 'Ú' : 'ú')
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Û' : 'û') : ((shift || capsLock) ? 'Ũ' : 'ũ')
            },
            {
                code: 'Digit6',
                key: 'Dead',
                keyCode: 54,
                string: (beforeShift) ? '¨' : '',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ü' : 'ü') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'I' : 'i',
        keyCode: 73,
        code: 'KeyI',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: (beforeShift) ? '`' : '´',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ì' : 'ì') : ((shift || capsLock) ? 'Í' : 'í')
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Î' : 'î') : ((shift || capsLock) ? 'Ĩ' : 'ĩ')
            },
            {
                code: 'Digit6',
                key: 'Dead',
                keyCode: 54,
                string: (beforeShift) ? '¨' : '',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ï' : 'ï') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'O' : 'o',
        keyCode: 79,
        code: 'KeyO',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: (beforeShift) ? '`' : '´',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ò' : 'ò') : ((shift || capsLock) ? 'Ó' : 'ó')
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ô' : 'ô') : ((shift || capsLock) ? 'Õ' : 'õ')
            },
            {
                code: 'Digit6',
                key: 'Dead',
                keyCode: 54,
                string: (beforeShift) ? '¨' : '',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ö' : 'ö') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'P' : 'p',
        keyCode: 80,
        code: 'KeyP',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: '´',
                value: (shift || capsLock) ? 'Ṕ' : 'ṕ'
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'A' : 'a',
        keyCode: 65,
        code: 'KeyA',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: (beforeShift) ? '`' : '´',
                value: (beforeShift) ? ((shift || capsLock) ? 'À' : 'à') : ((shift || capsLock) ? 'Á' : 'á')
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Â' : 'â') : ((shift || capsLock) ? 'Ã' : 'ã')
            },
            {
                code: 'Digit6',
                key: 'Dead',
                keyCode: 54,
                string: (beforeShift) ? '¨' : '',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ä' : 'ä') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'S' : 's',
        keyCode: 83,
        code: 'KeyS',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: '´',
                value: (shift || capsLock) ? 'Ś' : 'ś'
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ŝ' : 'ŝ') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'G' : 'g',
        keyCode: 71,
        code: 'KeyG',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: '´',
                value: (shift || capsLock) ? 'Ǵ' : 'ǵ'
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ĝ' : 'ĝ') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'J' : 'j',
        keyCode: 74,
        code: 'KeyJ',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: '´',
                value: (shift || capsLock) ? 'J́' : 'j́'
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ĵ' : 'ĵ') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'K' : 'k',
        keyCode: 75,
        code: 'KeyK',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: '´',
                value: (shift || capsLock) ? 'Ḱ' : 'ḱ'
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'L' : 'l',
        keyCode: 76,
        code: 'KeyL',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: '´',
                value: (shift || capsLock) ? 'Ĺ' : 'ĺ'
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'Ç' : 'ç',
        keyCode: 186,
        code: 'Semicolon',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: '´',
                value: (shift || capsLock) ? 'Ḉ' : 'ḉ'
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'Z' : 'z',
        keyCode: 90,
        code: 'KeyZ',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: '´',
                value: (shift || capsLock) ? 'Ź' : 'ź'
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ẑ' : 'ẑ') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'C' : 'c',
        keyCode: 67,
        code: 'KeyC',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: '´',
                value: (shift || capsLock) ? 'Ć' : 'ć'
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ĉ' : 'ĉ') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'V' : 'v',
        keyCode: 86,
        code: 'KeyV',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: (beforeShift) ? '`' : '´',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ǜ' : 'ǜ') : ((shift || capsLock) ? 'Ǘ' : 'ǘ')
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? '' : '') : ((shift || capsLock) ? 'Ṽ' : 'ṽ')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'N' : 'n',
        keyCode: 78,
        code: 'KeyN',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: (beforeShift) ? '`' : '´',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ǹ' : 'ǹ') : ((shift || capsLock) ? 'Ń' : 'ń')
            },
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? '' : '') : ((shift || capsLock) ? 'Ñ' : 'ñ')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'M' : 'm',
        keyCode: 77,
        code: 'KeyM',
        special: [
            {
                code: 'BracketLeft',
                key: 'Dead',
                keyCode: 219,
                string: (beforeShift) ? '`' : '´',
                value: (beforeShift) ? ((shift || capsLock) ? 'M̀' : 'm̀') : ((shift || capsLock) ? 'Ḿ' : 'ḿ')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'Q' : 'q',
        keyCode: 81,
        code: 'KeyQ',
        special: []
    },
    {
        key: (shift || capsLock) ? 'T' : 't',
        keyCode: 84,
        code: 'KeyT',
        special: []
    },
    {
        key: (shift || capsLock) ? 'D' : 'd',
        keyCode: 68,
        code: 'KeyD',
        special: []
    },
    {
        key: (shift || capsLock) ? 'F' : 'f',
        keyCode: 70,
        code: 'KeyF',
        special: []
    },
    {
        key: (shift || capsLock) ? 'H' : 'h',
        keyCode: 72,
        code: 'KeyH',
        special: [
            {
                code: 'Quote',
                key: 'Dead',
                keyCode: 222,
                string: (beforeShift) ? '^' : '~',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ĥ' : 'ĥ') : ((shift || capsLock) ? '' : '')
            },
            {
                code: 'Digit6',
                key: 'Dead',
                keyCode: 54,
                string: (beforeShift) ? '¨' : '',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ḧ' : 'ḧ') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'X' : 'x',
        keyCode: 88,
        code: 'KeyX',
        special: [
            {
                code: 'Digit6',
                key: 'Dead',
                keyCode: 54,
                string: (beforeShift) ? '¨' : '',
                value: (beforeShift) ? ((shift || capsLock) ? 'Ẍ' : 'ẍ') : ((shift || capsLock) ? '' : '')
            }
        ]
    },
    {
        key: (shift || capsLock) ? 'B' : 'b',
        keyCode: 66,
        code: 'KeyB',
        special: []
    },
    {
        key: ' ',
        keyCode: 32,
        code: 'Space',
        special: []
    },
    {
        key: '1',
        keyCode: 97,
        code: 'Numpad1',
        special: []
    },
    {
        key: '2',
        keyCode: 98,
        code: 'Numpad2',
        special: []
    },
    {
        key: '3',
        keyCode: 99,
        code: 'Numpad3',
        special: []
    },
    {
        key: '4',
        keyCode: 100,
        code: 'Numpad4',
        special: []
    },
    {
        key: '5',
        keyCode: 101,
        code: 'Numpad5',
        special: []
    },
    {
        key: '6',
        keyCode: 102,
        code: 'Numpad6',
        special: []
    },
    {
        key: '7',
        keyCode: 103,
        code: 'Numpad7',
        special: []
    },
    {
        key: '8',
        keyCode: 104,
        code: 'Numpad8',
        special: []
    },
    {
        key: '9',
        keyCode: 105,
        code: 'Numpad9',
        special: []
    },
    {
        key: '0',
        keyCode: 96,
        code: 'Numpad0',
        special: []
    },
    {
        key: '/',
        keyCode: 111,
        code: 'NumpadDivide',
        special: []
    },
    {
        key: '*',
        keyCode: 106,
        code: 'NumpadMultiply',
        special: []
    },
    {
        key: '-',
        keyCode: 109,
        code: 'NumpadSubtract',
        special: []
    },
    {
        key: '+',
        keyCode: 107,
        code: 'NumpadAdd',
        special: []
    },
    {
        key: '.',
        keyCode: 110,
        code: 'NumpadComma',
        special: []
    },
    {
        key: ',',
        keyCode: 108,
        code: 'NumpadDecimal',
        special: []
    },
    {
        key: (shift) ? '"' : "'",
        keyCode: 192,
        code: 'Backquote',
        special: []
    },
    {
        key: (shift) ? '!' : '1',
        keyCode: 49,
        code: 'Digit1',
        special: []
    },
    {
        key: (shift) ? '@' : '2',
        keyCode: 50,
        code: 'Digit2',
        special: []
    },
    {
        key: (shift) ? '#' : '3',
        keyCode: 51,
        code: 'Digit3',
        special: []
    },
    {
        key: (shift) ? '$' : '4',
        keyCode: 52,
        code: 'Digit4',
        special: []
    },
    {
        key: (shift) ? '%' : '5',
        keyCode: 53,
        code: 'Digit5',
        special: []
    },
    {
        key: '6',
        keyCode: 54,
        code: 'Digit6',
        special: []
    },
    {
        key: (shift) ? '&' : '7',
        keyCode: 55,
        code: 'Digit7',
        special: []
    },
    {
        key: (shift) ? '*' : '8',
        keyCode: 56,
        code: 'Digit8',
        special: []
    },
    {
        key: (shift) ? '(' : '9',
        keyCode: 57,
        code: 'Digit9',
        special: []
    },
    {
        key: (shift) ? ')' : '0',
        keyCode: 48,
        code: 'Digit0',
        special: []
    },
    {
        key: (shift) ? '_' : '-',
        keyCode: 189,
        code: 'Minus',
        special: []
    },
    {
        key: (altGraph) ? '§' : ((shift) ? '+' : '='),
        keyCode: 187,
        code: 'Equal',
        special: []
    },
    {
        key: (shift) ? '<' : ',',
        keyCode: 188,
        code: 'Comma',
        special: []
    },
    {
        key: (shift) ? '>' : '.',
        keyCode: 190,
        code: 'Period',
        special: []
    },
    {
        key: (shift) ? ':' : ';',
        keyCode: 191,
        code: 'Slash',
        special: []
    },
    {
        key: (altGraph) ? '°' : ((shift) ? '?' : '/'),
        keyCode: 191,
        code: 'IntlRo',
        special: []
    },
    {
        key: (altGraph) ? 'º' : ((shift) ? '}' : ']'),
        keyCode: 220,
        code: 'Backslash',
        special: []
    },
    {
        key: (altGraph) ? 'ª' : ((shift) ? '{' : '['),
        keyCode: 221,
        code: 'BracketRight',
        special: []
    }
]; };
