"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var clsx_1 = __importDefault(require("clsx"));
var react_1 = __importStar(require("react"));
require("./style.css");
var Zoom = function (_a) {
    var id = _a.id, style = _a.style, children = _a.children;
    var figureId = (id) ? id + "-zoom-figure" : 'zoom-figure';
    var _b = react_1.useState(false), active = _b[0], setActive = _b[1];
    var copyMediaUrl = react_1.useCallback(function () {
        var _a;
        var figureElement = document.getElementById(figureId);
        var mediaElement = (_a = figureElement.children) === null || _a === void 0 ? void 0 : _a[0];
        if (mediaElement)
            figureElement.style.backgroundImage = "url('" + mediaElement.src + "')";
    }, [figureId]);
    react_1.useEffect(function () { return setTimeout(function () { return copyMediaUrl(); }, 500); }, [copyMediaUrl]);
    function zoom(e, activeParameter) {
        var _a, _b, _c, _d;
        if (active || activeParameter) {
            var offsetX = void 0, offsetY = void 0, x = void 0, y = void 0;
            var figureElement = document.getElementById(figureId);
            if (figureElement) {
                if ((_a = e === null || e === void 0 ? void 0 : e.nativeEvent) === null || _a === void 0 ? void 0 : _a.offsetX)
                    offsetX = e.nativeEvent.offsetX;
                else
                    offsetX = (_b = e === null || e === void 0 ? void 0 : e.touches) === null || _b === void 0 ? void 0 : _b[0].pageX;
                if ((_c = e === null || e === void 0 ? void 0 : e.nativeEvent) === null || _c === void 0 ? void 0 : _c.offsetY)
                    offsetY = e.nativeEvent.offsetY;
                else
                    offsetX = (_d = e === null || e === void 0 ? void 0 : e.touches) === null || _d === void 0 ? void 0 : _d[0].pageX;
                x = ((offsetX / figureElement.offsetWidth) * 100);
                y = ((offsetY / figureElement.offsetHeight) * 100);
                figureElement.style.backgroundPosition = x + "% " + y + "%";
            }
        }
    }
    var handleActive = function (e) {
        var state = !active;
        setActive(state);
        (state) && zoom(e, state);
    };
    return react_1.default.createElement("figure", __assign({}, { style: style }, { id: figureId, onMouseMove: zoom, onTouchMove: zoom, onClick: handleActive, className: clsx_1.default('zoom-figure', { 'zoom-figure-active': active }) }), children);
};
exports.default = Zoom;
