"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixInvalidDate = exports.sqlDateToReadableDate = exports.convertMinutesToHour = exports.getDayName = exports.getMonthName = void 0;
var _1 = require(".");
var getMonthName = function (nr) {
    switch (nr) {
        case 0: return 'Janeiro';
        case 1: return 'Fevereiro';
        case 2: return 'Março';
        case 3: return 'Abril';
        case 4: return 'Maio';
        case 5: return 'Junho';
        case 6: return 'Julho';
        case 7: return 'Agosto';
        case 8: return 'Setembro';
        case 9: return 'Outubro';
        case 10: return 'Novembro';
        case 11: return 'Dezembro';
        default: return '';
    }
};
exports.getMonthName = getMonthName;
var getDayName = function (day) {
    switch (day) {
        case 1: return 'Segunda';
        case 2: return 'Terça';
        case 3: return 'Quarta';
        case 4: return 'Quinta';
        case 5: return 'Sexta';
        case 6: return 'Sábado';
        default: return 'Domingo';
    }
};
exports.getDayName = getDayName;
var convertMinutesToHour = function (minutes) {
    var dtAux = new Date(0, 0, 0, 0, 0, 0, 0);
    dtAux.setMinutes(minutes);
    return _1.addExtraZero(dtAux.getHours()) + ":" + _1.addExtraZero(dtAux.getMinutes());
};
exports.convertMinutesToHour = convertMinutesToHour;
var sqlDateToReadableDate = function (sqlDate) {
    var readableDate = { date: '', hour: '' };
    if (sqlDate.length > 10) {
        var date = sqlDate.slice(0, 10).split('-');
        readableDate.date = date[2] + "/" + date[1] + "/" + date[0];
        if (sqlDate.indexOf(' ') > -1) {
            var hour = sqlDate.split(' ')[1].split(':');
            readableDate.hour = hour[0] + ":" + hour[1];
        }
    }
    return readableDate;
};
exports.sqlDateToReadableDate = sqlDateToReadableDate;
var fixInvalidDate = function (date) {
    if (!date || typeof date !== 'string')
        return date;
    var splitDate = date.split(' ');
    return splitDate[0] + " " + splitDate[1].split(':').map(function (t) { return _1.addExtraZero(t); }).join(':');
};
exports.fixInvalidDate = fixInvalidDate;
