import Button from '../Button';
import PropTypes from 'prop-types';
import React, { Component } from 'react';

/**
 * @deprecated 
 */
class ArgousAction extends Component {
  render() {
    const {
      glyphicon,
      type = 'default',
      className = '',
      onClick,
      item,
      action,
      dados,
      sendUpdates,
      receiveUpdates,
      onSuccess,
      onAllUpdated,
      children,
      style,
      title,
    } = this.props;

    return (
      <Button
        onClick={(allFields, event) => onClick && onClick(item, event)}
        sendUpdates={sendUpdates}
        receiveUpdates={receiveUpdates}
        onSuccess={onSuccess}
        onAllUpdated={onAllUpdated}
        action={action}
        dados={{
          dados,
          item,
        }}
        className={`${
          glyphicon
            ? `btn btn-xs btn-round btn-action-min-size btn-${type}`
            : ''
        } ${className}`}
        style={style}
        title={title}
      >
        {glyphicon && <i className={glyphicon} />}
        {children && <span>{children}</span>}
      </Button>
    );
  }
}

ArgousAction.propTypes = {
  glyphicon: PropTypes.string,
  children: PropTypes.node,
  onClick: PropTypes.func,
  sendUpdates: PropTypes.array,
  receiveUpdates: PropTypes.array,
  onSuccess: PropTypes.func,
  onAllUpdated: PropTypes.func,
  action: PropTypes.string,
  dados: PropTypes.object,
  type: PropTypes.oneOf([
    'default',
    'primary',
    'success',
    'info',
    'warning',
    'danger',
  ]),
  className: PropTypes.string,
  style: PropTypes.object,
  title: PropTypes.string,
  item: PropTypes.oneOfType([PropTypes.array, PropTypes.object]),
};

export default ArgousAction;