import { createField, getField } from '../../fieldsRedux';
import PropTypes from 'prop-types';
import React, { Component } from 'react';
import MaskedInput from 'react-maskedinput';

/**
 * @deprecated 
 */
class ArgousInput extends Component {
  confs = '';

  styleDiv1 = {
    borderBottomColor: 'rgba(0, 0, 0, 0.87)',
    borderBottomStyle: 'none',
    borderBottomWidth: '0px',
    borderImageOutset: '0px',
    borderImageTepeat: 'stretch',
    borderImageSlice: '100%',
    borderImageSource: 'none',
    borderImageWidth: 1,
    borderLeftColor: 'rgba(0, 0, 0, 0.87)',
    borderLeftStyle: 'none',
    borderLeftWidth: '0px',
    borderRightColor: 'rgba(0, 0, 0, 0.87)',
    borderRightStyle: 'none',
    borderRightWidth: '0px',
    borderTopColor: 'rgba(0, 0, 0, 0.87)',
    borderTopStyle: 'none',
    borderTopWidth: '0px',
    boxSizing: 'borderBox',
    color: 'rgba(0, 0, 0, 0.87)',
    display: 'inlineFlex',
    flexDirection: 'column',
    fontFamily: 'Roboto, Helvetica, Arial, sansSerif',
    fontSize: '14px',
    fontWeight: 400,
    height: '56px',
    letterSpacing: '0.14994px',
    lineHeight: '20.02px',
    marginBottom: '8px',
    marginLeft: '0px',
    marginRight: '0px',
    marginTop: '8px',
    minWidth: '0px',
    paddingBottom: '0px',
    paddingLeft: '0px',
    paddingTight: '0px',
    paddingTop: '0px',
    position: 'relative',
    verticalAlign: 'top',
    width: '100%',
    zIndex: 0,
    webkitFontSmoothing: 'antialiased'
  }

  styleDiv2 = {
    alignItems: 'center',
    borderBottomLeftRadius: '4px',
    borderBottomRightRadius: '4px',
    borderTopleftRadius: '4px',
    borderToprightradius: '4px',
    boxSizing: 'borderBox',
    color: 'rgba(0, 0, 0, 0.87)',
    cursor: 'text',
    display: 'flex',
    fontFamily: 'Roboto, Helvetica, Arial, sansSerif',
    fontSize: '16px',
    fontWeight: 400,
    height: '56px',
    letterSpacing: '0.15008px',
    lineHeight: '19px',
    position: 'relative',
    width: '100%',
    webkitFontSmoothing: 'antialiased',
  }

  styleLabel = {
    boxSizing: 'borderBox',
    color: 'rgba(0, 0, 0, 0.54)',
    cursor: 'default',
    display: 'block',
    fontFamily: 'Roboto, Helvetica, Arial, sansSerif',
    fontSize: '11px',
    fontWeight: 400,
    height: '20px',
    left: '6px',
    letterSpacing: '0.15008px',
    lineHeight: '16px',
    paddingBottom: '0px',
    paddingLeft: '0px',
    paddingRight: '0px',
    paddingTop: '0px',
    pointerEvents: 'none',
    position: 'absolute',
    top: '3px',
    transform: 'matrix(0.75, 0, 0, 0.75, 14, D6)',
    transformOrigin: '0px 0px',
    transitionDelay: '0s, 0s',
    transitionDuration: '0.2s, 0.2s',
    transitionProperty: 'color, transform',
    transitionTimingFunction: 'cubicBezier(0, 0, 0.2, 1), cubicBezier(0, 0, 0.2, 1)',
    width: '200px',
    zIndex: 1,
    webkitFontSmoothing: 'antialiased',
  }

  styleInput = {
    backgroundAttachment: 'scroll',
    backgroundClip: 'borderBox',
    backgroundColor: 'rgba(0, 0, 0, 0)',
    backgroundImage: 'none',
    backgroundOrigin: 'paddingBox',
    backgroundPositionX: '0%',
    backgroundPositionY: '0%',
    backgroundSize: 'auto',
    borderBottomColor: 'rgba(0, 0, 0, 0.87)',
    borderBottomStyle: 'none',
    borderBottomWidth: '0px',
    borderImageOutset: '0px',
    borderImageRepeat: 'stretch',
    borderImageSlice: '100%',
    borderImageSource: 'none',
    borderImageWidth: 1,
    borderLeftColor: 'rgba(0, 0, 0, 0.87)',
    borderLeftStyle: 'none',
    borderLeftWidth: '0px',
    borderRightColor: 'rgba(0, 0, 0, 0.87)',
    borderRightStyle: 'none',
    borderRightWidth: '0px',
    borderTopColor: 'rgba(0, 0, 0, 0.87)',
    borderTopStyle: 'none',
    borderTopWidth: '0px',
    boxSizing: 'contentBox',
    color: 'rgba(0, 0, 0, 0.87)',
    cursor: 'text',
    display: 'block',
    fontFamily: 'Roboto, Helvetica, Arial, sansSerif',
    fontSize: '16px',
    fontStretch: '100%',
    fontStyle: 'normal',
    fontVariantCaps: 'normal',
    fontVariantEastAsian: 'normal',
    fontVariantLigatures: 'normal',
    fontVariantNumeric: 'normal',
    fontWeight: 400,
    height: '56px',
    letterSpacing: 'normal',
    lineHeight: '19px',
    marginBottom: '0px',
    marginLeft: '0px',
    marginRight: '0px',
    marginTop: '0px',
    minWidth: '0px',
    paddingBottom: '1.5px',
    paddingLeft: '14px',
    paddingRight: '14px',
    paddingTop: '18.5px',
    textAlign: 'start',
    textIndent: '0px',
    textRendering: 'auto',
    textShadow: 'none',
    textTransform: 'none',
    width: '100%',
    wordSpacing: '0px',
    writingMode: 'horizontalTb',
    webkitAppearance: 'none',
    webkitFontSmoothing: 'antialiased',
    webkitRtlOrdering: 'logical',
    webkitTapHighlightColor: 'rgba(0, 0, 0, 0)',
    webkitBorderImage: 'none',
  }

  stylefieldset = {
    borderBottomColor: 'rgba(0, 0, 0, 0.23)',
    borderBottomLeftRadius: '4px',
    borderBottomRightRadius: '4px',
    borderBottomStyle: 'solid',
    borderBottomWidth: '1px',
    borderImageOutset: '0px',
    borderImageRepeat: 'stretch',
    borderImageSlice: '100%',
    borderImageSource: 'none',
    borderImageWidth: 1,
    borderLeftColor: 'rgba(0, 0, 0, 0.23)',
    borderLeftStyle: 'solid',
    borderLeftWidth: '1px',
    borderRightColor: 'rgba(0, 0, 0, 0.23)',
    borderRightStyle: 'solid',
    borderRightWidth: '1px',
    borderTopColor: 'rgba(0, 0, 0, 0.23)',
    borderTopLeftRadius: '4px',
    borderTopRightRadius: '4px',
    borderTopStyle: 'solid',
    borderTopWidth: '1px',
    bottom: '0px',
    boxSizing: 'borderBox',
    color: 'rgba(0, 0, 0, 0.87)',
    cursor: 'text',
    display: 'block',
    fontFamily: 'Roboto, Helvetica, Arial, sansSerif',
    fontSize: '16px',
    fontWeight: 400,
    height: '61px',
    left: '0px',
    letterSpacing: '0.15008px',
    lineHeight: '19px',
    marginBottom: '0px',
    marginInlineEnd: '0px',
    marginInlineStart: '0px',
    marginLeft: '0px',
    marginRight: '0px',
    marginTop: '0px',
    minInlineSize: 'minDcontent',
    paddingBlockEnd: '0px',
    paddingBlockStart: '0px',
    paddingBottom: '0px',
    paddingInlineEnd: '0px',
    paddingInlineStart: '8px',
    paddingLeft: '8px',
    paddingTight: '0px',
    paddingTop: '0px',
    pointerEvents: 'none',
    position: 'absolute',
    right: '0px',
    top: 'D5px',
    width: '100%',
    webkitGontSmoothing: 'antialiased',
    webkitBorderImage: 'none',
  }

  styleLegend = {
    borderBottomColor: 'rgba(0, 0, 0, 0.87)',
    borderBottomStyle: 'none',
    borderBottomWidth: '0px',
    borderImageOutset: '0px',
    borderImageRepeat: 'stretch',
    borderImageSlice: '100%',
    borderImageSource: 'none',
    borderImageWidth: 1,
    borderLeftDcolor: 'rgba(0, 0, 0, 0.87)',
    borderLeftStyle: 'none',
    borderLeftWidth: '0px',
    borderRightColor: 'rgba(0, 0, 0, 0.87)',
    borderRightStyle: 'none',
    borderRightWidth: '0px',
    borderTopColor: 'rgba(0, 0, 0, 0.87)',
    borderTopStyle: 'none',
    borderTopWidth: '0px',
    boxSizing: 'borderBox',
    color: 'rgba(0, 0, 0, 0.87)',
    cursor: 'text',
    display: 'block',
    fontFamily: 'Roboto, Helvetica, Arial, sansSerif',
    fontSize: '12px',
    fontWeight: 400,
    height: '11px',
    letterSpacing: '0.15008px',
    lineHeight: '19px',
    maxWidth: '1000px',
    paddingBottom: '0px',
    paddingInlineEnd: '0px',
    paddingInlineStart: '0px',
    paddingLeft: '0px',
    paddingRight: '0px',
    paddingTop: '0px',
    pointerEvents: 'none',
    textAlign: 'left',
    transitionDdelay: '0.05s',
    transitionDduration: '0.1s',
    transitionDproperty: 'maxWidth',
    transitionTimingFunction: 'cubicBezier(0, 0, 0.2, 1)',
    visibility: 'hidden',
    width: '0px',
    WebkitFontSmoothing: 'antialiased',
    WebkitBorderImage: 'none',

  }

  styleSpan = {
    boxSizing: 'border-box',
    color: 'rgba(0, 0, 0, 0.87)',
    cursor: 'text',
    display: 'inline',
    fontFamily: 'Roboto, Helvetica, Arial, sans-serif',
    fontSize: '12px',
    fontWeight: 400,
    height: 'auto',
    letterSpacing: '0.15008px',
    lineHeight: '19px',
    paddingLeft: '5px',
    paddingRight: '5px',
    pointerEvents: 'none',
    textAlign: 'left',
    visibility: 'hidden',
    width: 'auto',
    WebkitFontSmoothing: 'antialiased',
  }

  componentWillUnmount() {
    if (this.props.stopWriting) {
      clearTimeout(this.stopWritingTimeout);
    }
  }

  onChange = event => {
    const { onChange } = this.props;

    let value = this.handleValue(event.target);

    value = this.handleWithTypeValues(value);

    if (onChange) {
      onChange(value);
    }

    this.props.handleUpdates(value);
    this.stopWritingHandler(value);
  }

  stopWritingHandler = value => {
    const { stopWriting, stopWritingTime = 2000 } = this.props;

    if (stopWriting) {
      clearTimeout(this.stopWritingTimeout);
      this.stopWritingTimeout = setTimeout(() => {
        stopWriting(value);
      }, stopWritingTime);
    }
  }

  handleWithTypeValues = value => {
    const { field, type, optionValue } = this.props;

    if (type === 'checkbox') {
      const fieldValue = getField(field, 'value') || [];
      const index = fieldValue.indexOf(optionValue);

      if (index < 0) {
        fieldValue.push(optionValue);
      } else {
        fieldValue.splice(index, 1);
      }

      value = fieldValue;
    }

    if (type === 'radio') {
      value = optionValue;
    }

    return value;
  }

  handleValue = target => {
    const confs = this.stateOptions();

    return confs.alias === 'check'
      ? target.checked
      : target.value;
  }

  handleClassName = () => {
    const { className = '' } = this.props;
    const confs = this.stateOptions();

    let cn = '';

    if (confs.alias === 'text' && !className) cn += ' form-control ';

    cn += className;

    return cn;
  }

  checkInputProps = () => {
    const {
      field,
      id,
      type = 'text',
      placeholder,
      min,
      max,
      step,
      maxLength,
      minLength,
      autoFocus,
      disabled,
      readOnly,
      required,
    } = this.props;

    let value = getField(field, 'value');

    let inputProps = {};

    inputProps['min'] = min;
    inputProps['max'] = max;
    inputProps['step'] = step;
    inputProps['maxLength'] = maxLength;
    inputProps['minLength'] = minLength;
    inputProps['value'] = value;
    inputProps['placeholder'] = placeholder;
    inputProps['readOnly'] = readOnly;
    inputProps['required'] = required;
    inputProps['disabled'] = disabled;
    inputProps['autoFocus'] = autoFocus;
    inputProps['id'] = id;
    inputProps['type'] = type;

    inputProps = {
      ...inputProps,
      ...this.events()
    };

    return inputProps;
  }

  render() {
    const { checkInputProps } = this;
    const { mask, label } = this.props;

    const inputProps = checkInputProps();

    if (!mask) {
      return (
        <div style={this.styleDiv1}>
          <label style={this.styleLabel}
          >{label}</label>
          <div style={this.styleDiv2}>
            <input style={this.styleInput} {...inputProps} />
            <fieldset style={this.stylefieldset}>
              <legend style={this.styleLegend}>
                <span style={this.styleSpan}></span>
              </legend>
            </fieldset>
          </div>
        </div>
      );
    }
    return (
      <div style={this.styleDiv1}>
        <label style={this.styleLabel}
        >{label}</label>
        <div style={this.styleDiv2}>
          <MaskedInput mask={mask} style={this.styleInput} {...this.props} />
          <fieldset style={this.stylefieldset}>
            <legend style={this.styleLegend}>
              <span style={this.styleSpan}></span>
            </legend>
          </fieldset>
        </div>
      </div>
    );

  }

  stateOptions = () => {
    const { confs } = this;
    const { type } = this.props;

    if (confs) return confs;

    const confsAux = {};

    switch (type) {
      case 'time':
        confsAux['alias'] = 'text';
        break;
      case 'date':
        confsAux['alias'] = 'text';
        break;
      case 'datetime-local':
        confsAux['alias'] = 'text';
        break;
      case 'email':
        confsAux['alias'] = 'text';
        break;
      case 'url':
        confsAux['alias'] = 'text';
        break;
      case 'month':
        confsAux['alias'] = 'text';
        break;
      case 'week':
        confsAux['alias'] = 'text';
        break;
      case 'number':
        confsAux['alias'] = 'text';
        break;
      case 'password':
        confsAux['alias'] = 'text';
        break;
      case 'search':
        confsAux['alias'] = 'text';
        break;
      case 'button':
        confsAux['alias'] = 'button';
        break;
      case 'submit':
        confsAux['alias'] = 'button';
        break;
      case 'file':
        confsAux['alias'] = 'button';
        break;
      case 'checkbox':
        confsAux['alias'] = 'check';
        break;
      case 'radio':
        confsAux['alias'] = 'check';
        break;
      case 'color':
        confsAux['alias'] = 'color';
        break;
      case 'hidden':
        confsAux['alias'] = 'hidden';
        break;
      case 'range':
        confsAux['alias'] = 'range';
        break;
      default:
        confsAux['alias'] = 'text';
    }

    this.confs = confsAux;

    return confsAux;
  }

  events = () => {
    const {
      onFocus,
      onBlur,
      onKeyDown,
      onKeyPress,
      onKeyUp,
      onMouseEnter,
      onMouseOver,
      onMouseMove,
      onMouseDown,
      onMouseUp,
      onClick,
      onDoubleClick,
      onMouseLeave,
      onMouseOut
    } = this.props;

    const onChange = this.onChange;

    return {
      onChange,
      onFocus,
      onBlur,
      onKeyDown,
      onKeyPress,
      onKeyUp,
      onMouseEnter,
      onMouseOver,
      onMouseMove,
      onMouseDown,
      onMouseUp,
      onClick,
      onDoubleClick,
      onMouseLeave,
      onMouseOut
    };
  }
}

ArgousInput.propTypes = {
  field: PropTypes.string.isRequired,
  defaultValue: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.object, PropTypes.array]),
  ajax: PropTypes.bool,
  onChange: PropTypes.func,
  action: PropTypes.string,
  dados: PropTypes.object,
  receiveUpdates: PropTypes.array,
  sendUpdates: PropTypes.array,
  onFieldSuccess: PropTypes.func,
  onActionSuccess: PropTypes.func,
  onAllUpdated: PropTypes.func,
  fieldListener: PropTypes.func,
  destroyOnUnmount: PropTypes.bool,
  mask: PropTypes.string,
  placeholder: PropTypes.string,
  className: PropTypes.string,
  style: PropTypes.object,
  id: PropTypes.string,
  name: PropTypes.string,
  min: PropTypes.string,
  max: PropTypes.string,
  step: PropTypes.string,
  maxLength: PropTypes.string,
  minLength: PropTypes.string,
  autoFocus: PropTypes.bool,
  disabled: PropTypes.bool,
  readOnly: PropTypes.bool,
  required: PropTypes.bool,
  onFocus: PropTypes.func,
  onBlur: PropTypes.func,
  onKeyDown: PropTypes.func,
  onKeyPress: PropTypes.func,
  onKeyUp: PropTypes.func,
  onMouseEnter: PropTypes.func,
  onMouseOver: PropTypes.func,
  onMouseMove: PropTypes.func,
  onMouseDown: PropTypes.func,
  onMouseUp: PropTypes.func,
  onClick: PropTypes.func,
  onDoubleClick: PropTypes.func,
  onMouseLeave: PropTypes.func,
  onMouseOut: PropTypes.func,
  stopWriting: PropTypes.func,
  stopWritingTime: PropTypes.number
};

export default createField(ArgousInput);
