import { Select, MenuItem, InputBase, Box, Toolbar, Typography, IconButton } from '@material-ui/core';
import React from 'react';
import { MdKeyboardArrowLeft, MdKeyboardArrowRight } from 'react-icons/md';

/**
 * @deprecated 
 */
const ArgousPagination = (props) => {

  const value = props.ctrlPgnReturn.qtRegs;

  return (
    <Toolbar style={{ minHeight: 52, paddingRight: 2 }}>
      <div style={{ flex: '1 1 100%' }}/>
      <Typography color='inherit' variant='body2' style={{ flexShrink: 0 }}>Linhas</Typography>
      {value && (
        <Select
          input={<InputBase style={{ marginRight: 32, marginLeft: 8, color: 'inherit', fontSize: 'inherit', flexShrink: 0, }} />}
          onChange={(e) => props.onChangeRowsPerPage(e.target.value)} value={value} style={{ marginLeft: 15 }}>
          {props.linhasPorPagina.map((coluna, index) => {
            return (<MenuItem key={index} value={coluna}>{coluna}</MenuItem>);
          })}
        </Select>
      )}
      <Typography color='inherit' variant='body2' component='div' style={{ flexShrink: 0 }}>
        <Box padding='1px 0px' display='inline'>
          <InputBase style={{ width: 40 }} inputProps={{ value: props.ctrlPgnReturn.pgAtl }} onBlur={e => props.onChangePageNumber(e.target.value) }/>
          {` / ${props.ctrlPgnReturn.qtPaginas}`}
        </Box>
      </Typography>
      <Box style={{ flexShrink: 0, marginLeft: '20px' }} >
        <IconButton onClick={() => props.onChangePage('P')} disabled={props.ctrlPgnReturn.pgAtl === 1} title='Página Anterior'>
          <MdKeyboardArrowLeft />
        </IconButton>
        <IconButton onClick={() => props.onChangePage('N')} disabled={props.ctrlPgnReturn.pgAtl === props.ctrlPgnReturn.qtPaginas} title='Página Seguinte'>
          <MdKeyboardArrowRight />
        </IconButton>
      </Box>
    </Toolbar>
  );
};

export default ArgousPagination;