import AgPagination from '../ArgousPagination';
import Paper from '@material-ui/core/Paper';
import { makeStyles } from '@material-ui/core/styles';
import Table from '@material-ui/core/Table';
import TableBody from '@material-ui/core/TableBody';
import TableCell from '@material-ui/core/TableCell';
import TableContainer from '@material-ui/core/TableContainer';
import TableHead from '@material-ui/core/TableHead';
import TableRow from '@material-ui/core/TableRow';
import React, { useState, useEffect } from 'react';

/**
 * @deprecated 
 */
const ArgousSimpleTable = (props) => {

  const useStyles = makeStyles({
    table: {
      minWidth: 650,
    },
  });

  const [ctrlPgn, setCtrlPgn] = useState({ acao: '', pgAtl: 1, qtRegs: 0 });
  const [iniciado, setIniciado] = useState(false);
  const [tpOrdenacao, setTpOrdenacao] = useState({ tpOrdem: 'D' });
  const [listaChildrens, setListaChildrens] = useState([]);

  const classes = useStyles();

  function getCellContent(vlr, line) {

    if (props.columnOptions) {

      for (const element of props.columnOptions) {

        if (element.alias === line) {
          return element.customJsx({ value: vlr });
        }
      }
    }

    return vlr;
  }

  function clickNaLinha(row) {
    if (props.onClick) {
      props.onClick(props.rows[row]);
    }
  }

  function onChangePage(prm) {
    var pgAtual = props.ctrlPgnReturn.pgAtl;
    if (prm === 'P') {
      if (pgAtual > 1) {
        setCtrlPgn({ ...ctrlPgn, acao: prm, qtPaginas: props.ctrlPgnReturn.qtPaginas, pgAtl: pgAtual, qtRegs: props.ctrlPgnReturn.qtRegs });
      }
    } else if (pgAtual < props.ctrlPgnReturn.qtPaginas) {
      setCtrlPgn({ ...ctrlPgn, acao: prm, qtPaginas: props.ctrlPgnReturn.qtPaginas, pgAtl: pgAtual, qtRegs: props.ctrlPgnReturn.qtRegs });
    }
  }

  function onChangeRowsPerPage(prm) {
    setCtrlPgn({ ...ctrlPgn, qtRegs: prm });
  }

  function onChangePageNumber(prm) {
    setCtrlPgn({ ...ctrlPgn, acao: `S=${parseInt(prm)}`, pgAtl: parseInt(prm), qtRegs: props.ctrlPgnReturn.qtRegs, qtPaginas: props.ctrlPgnReturn.qtPaginas });
  }

  function selecionaOrdenacao(prm) {
    if (tpOrdenacao.indOrdem) {
      if (tpOrdenacao.indOrdem === prm) {
        let tpOrdem = 'D';
        if (tpOrdenacao.tpOrdem === 'D') {
          tpOrdem = 'A';
        }
        setTpOrdenacao({ indOrdem: prm, tpOrdem: tpOrdem });
        setCtrlPgn({ ...ctrlPgn, acao: undefined, indOrdem: prm, tpOrdem: tpOrdem, pgAtl: parseInt(props.ctrlPgnReturn.pgAtl), qtRegs: props.ctrlPgnReturn.qtRegs, qtPaginas: props.ctrlPgnReturn.qtPaginas });

      } else {
        setTpOrdenacao({ indOrdem: prm, tpOrdem: 'D' });
        setCtrlPgn({ ...ctrlPgn, acao: undefined, indOrdem: prm, tpOrdem: 'D', pgAtl: parseInt(props.ctrlPgnReturn.pgAtl), qtRegs: props.ctrlPgnReturn.qtRegs, qtPaginas: props.ctrlPgnReturn.qtPaginas });
      }
    } else {
      let tpOrdem = 'D';
      if (tpOrdenacao.tpOrdem) {
        if (tpOrdenacao.tpOrdem === 'D') {
          tpOrdem = 'A';
        }
      }
      setTpOrdenacao({ indOrdem: prm, tpOrdem: tpOrdem });
      setCtrlPgn({ ...ctrlPgn, acao: undefined, indOrdem: prm, tpOrdem: tpOrdem, pgAtl: parseInt(props.ctrlPgnReturn.pgAtl), qtRegs: props.ctrlPgnReturn.qtRegs, qtPaginas: props.ctrlPgnReturn.qtPaginas });

    }
  }

  function listaFilhos() {
    const { children } = props;

    if (children) {
      if (!children.length) {
        return [children];
      }
      return children;
    }

    return [];
  }

  useEffect(() => {
    if (iniciado) {
      props.ctrlPgn({ ctrlPgn });
    } else {
      setListaChildrens(listaFilhos());
      setIniciado(true);
    }
  }, [ctrlPgn]);

  return (
    <div>
      <TableContainer component={Paper}>

        <Table className={classes.table} size='small' style={{ tableLayout: 'fixed', width: '100%' }}>
          <TableHead>
            <TableRow>
              {props.head.map((coluna, index) => {

                let width = 'auto';

                if (props.columnWidths && props.columnWidths[index]) {
                  width = props.columnWidths[index];
                }
                var ordena = false;
                if (props.ctrlPgnReturn && props.ctrlPgnReturn.ordCols) {
                  ordena = props.ctrlPgnReturn.ordCols[index];
                }

                if (ordena) {
                  return (
                    <TableCell
                      onClick={() => selecionaOrdenacao(index)}
                      style={{ width: `${width}`, whiteSpace: 'nowrap', cursor: 'pointer', fontSize: 14 }}
                      key={index}>
                      {coluna}
                      {(tpOrdenacao.indOrdem !== undefined) && (tpOrdenacao.indOrdem !== index) &&
                        <i style={{ right: '-10px', position: 'relative', color: '#999' }} className='glyph-icon tooltip-button demo-icon icon-sort' ></i>
                      }
                      {(tpOrdenacao.indOrdem === undefined) && (tpOrdenacao.indOrdem !== index) &&
                        <i style={{ right: '-10px', position: 'relative' }} className='glyph-icon tooltip-button demo-icon icon-sort' ></i>
                      }
                      {(tpOrdenacao.indOrdem !== undefined) && (tpOrdenacao.indOrdem === index) && (tpOrdenacao.tpOrdem === 'A') &&
                        <i style={{ right: '-10px', position: 'relative' }} className='glyph-icon tooltip-button demo-icon icon-sort-amount-asc' ></i>
                      }
                      {(tpOrdenacao.indOrdem !== undefined) && (tpOrdenacao.indOrdem === index) && (tpOrdenacao.tpOrdem === 'D') &&
                        <i style={{ right: '-10px', position: 'relative' }} className='glyph-icon tooltip-button demo-icon icon-sort-amount-desc' ></i>
                      }
                    </TableCell>);
                }
                return (<TableCell style={{ width: `${width}`, fontSize: 14 }} key={index}>{coluna}</TableCell>);

              })}
              {listaChildrens.map((item, index) => (
                <TableCell style={{ width: '30px', fontSize: 14 }} key={`act${index}`}> </TableCell>
              ))}
            </TableRow>
          </TableHead>
          <TableBody>


            {props.rows && props.rows.map((linha, index) => {

              if (props.maxRows) {
                if (index >= props.maxRows) {
                  return null;
                }
              }

              var estilo = {
                cursor: 'pointer'
              };

              if (props.onClick === undefined) {
                estilo = { cursor: 'text' };
              }

              if (props.indexes) {

                return (
                  <TableRow key={index} style={estilo} onClick={() => clickNaLinha(index)}>

                    {props.indexes.map((ind, keyInd) => {

                      let oEstilo = {};
                      if (props.columnStyles && props.columnStyles[keyInd]) {
                        oEstilo = props.columnStyles[keyInd];
                      }

                      let aClasse = '';

                      if (props.columnClasses && props.columnClasses[keyInd]) {
                        aClasse = props.columnClasses[keyInd];
                      }

                      return (<TableCell className={aClasse} style={oEstilo} key={keyInd}>{getCellContent(linha[ind], keyInd)}</TableCell>);
                    })}
                    {listaChildrens.map((act, index3) => (
                      <TableCell style={{ width: '30px' }} key={`act_${index3}`}>
                        {React.cloneElement(act, { item: linha })}
                      </TableCell>
                    ))}
                  </TableRow>
                );
              }

              return (
                <TableRow key={index} style={estilo} onClick={() => clickNaLinha(index)}>
                  {linha.map((ln, keyInd) => {
                    return (<TableCell style={{ whiteSpace: 'nowrap', textOverflow: 'ellipsis', overflow: 'hidden' }} key={keyInd}>{getCellContent(ln, keyInd)}</TableCell>);
                  })}
                </TableRow>
              );

            })}
          </TableBody>
        </Table>
      </TableContainer>
      {(props.ctrlLinhasPorPagina) && (props.ctrlPgnReturn) &&
        <AgPagination
          linhasPorPagina={props.ctrlLinhasPorPagina}
          paginas={props.ctrlPgnReturn.qtPaginas}
          ctrlPgnReturn={props.ctrlPgnReturn}
          onChangePage={onChangePage}
          onChangeRowsPerPage={onChangeRowsPerPage}
          onChangePageNumber={onChangePageNumber}
        />
      }
    </div>
  );
};

export default ArgousSimpleTable;