import Chart from 'chart.js';
import PropTypes from 'prop-types';
import React, { Component } from 'react';

/**
 * @deprecated 
 */
class BarChart extends Component {
  componentDidMount = () => {

    const { labels = [], datasets = [], horizontal, percentage, maxTicksLimit, stepSize, scaleLabel = {},
      title = { display: false }, legend = false, tooltip = false, stacked, onClick } = this.props;

    const chart = new Chart(this.canv, {
      type: horizontal ? 'horizontalBar' : 'bar',
      data: {
        labels,
        datasets
      },
      options: {
        maintainAspectRatio: false,
        events: ['click'],
        onClick: !onClick ? undefined : function(event, context) {
          const activeElement = chart.getElementAtEvent(event);

          if (activeElement.length > 0) {
            const datasetIndex = activeElement[0]._datasetIndex;
            const index = activeElement[0]._index;
            const value = chart.data.datasets[activeElement[0]._datasetIndex].data[activeElement[0]._index];
            const label = labels[activeElement[0]._index];

            onClick(datasetIndex, index, value, label);
          }
        },
        scales: {
          xAxes: [{
            stacked
          }],
          yAxes: [{
            ticks: {
              suggestedMax: percentage ? 100 : undefined,
              maxTicksLimit,
              stepSize,
              beginAtZero: true,
            },
            scaleLabel,
            stacked
          }]
        },
        title,
        legend: {
          display: legend
        },
        tooltips: {
          enabled: tooltip
        }
      }
    });
  }

  render() {
    const { height } = this.props;

    return (
      <div style={{ position: 'relative', height }}>
        <canvas ref={canv => {
          this.canv = canv;
        }} />
      </div>
    );
  }
}

BarChart.propTypes = {
  height: PropTypes.number,
  labels: PropTypes.array,
  datasets: PropTypes.array,
  horizontal: PropTypes.bool,
  percentage: PropTypes.bool,
  maxTicksLimit: PropTypes.number,
  stepSize: PropTypes.number,
  scaleLabel: PropTypes.object,
  title: PropTypes.object,
  legend: PropTypes.bool,
  tooltip: PropTypes.bool,
  stacked: PropTypes.bool,
  prefix: PropTypes.string,
  suffix: PropTypes.string,
  onClick: PropTypes.func
};

export default BarChart;
