import { getAllFields, fieldUpdatesActionHandler } from '../../fieldsRedux';
import PropTypes from 'prop-types';
import React, { Component } from 'react';

/**
 * @deprecated 
 */
class Button extends Component {
  onClick = event => {
    const { onClick } = this.props;
    const allProgramFields = getAllFields();

    if (onClick) {
      onClick(allProgramFields, event);
    }

    this.handleUpdates(allProgramFields);
  }

  handleUpdates = (allProgramFields, res) => {
    const {
      action,
      dados,
      receiveUpdates = [],
      sendUpdates = [],
      onAllUpdated,
      onSuccess,
    } = this.props;

    fieldUpdatesActionHandler(
      sendUpdates,
      receiveUpdates,
      action,
      dados,
      onSuccess,
      onAllUpdated,
      allProgramFields
    );
  }

  resolveFieldValues = fields => {
    if (fields) {
      const fieldsValues = {};

      Object.keys(fields).map(key => {
        fieldsValues[key] = fields[key].value;
        return null;
      });

      return fieldsValues;
    }

    return {};
  }

  checkButtonProps = () => {
    const {
      value,
      type = 'button',
      name,
      autoFocus,
      disabled,
      formNoValidate,
      formTarget,
      formMethod,
      formEncType,
      formAction,
      form,
      style,
      title,
    } = this.props;

    const className = `${this.props.className ? this.props.className : 'btn'}`;

    const onClick = this.onClick;

    return {
      className,
      onClick,
      value,
      type,
      name,
      autoFocus,
      disabled,
      formNoValidate,
      formTarget,
      formMethod,
      formEncType,
      formAction,
      form,
      style,
      title,
    };
  }

  render() {
    const { checkButtonProps } = this;
    const { children } = this.props;

    const buttonProps = checkButtonProps();

    return <button {...buttonProps}>{children}</button>;
  }
}

Button.propTypes = {
  receiveUpdates: PropTypes.array,
  sendUpdates: PropTypes.array,
  onAllUpdated: PropTypes.func,
  onSuccess: PropTypes.func,
  className: PropTypes.string,
  action: PropTypes.string,
  dados: PropTypes.object,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.element]),
  type: PropTypes.oneOf(['submit', 'reset', 'button']),
  value: PropTypes.string,
  style: PropTypes.object,
  onClick: PropTypes.func,
  name: PropTypes.string,
  autoFocus: PropTypes.bool,
  disabled: PropTypes.bool,
  formNoValidate: PropTypes.bool,
  formTarget: PropTypes.oneOf(['_self', '_blank', '_parent', '_top']),
  formMethod: PropTypes.oneOf(['post', 'get']),
  formEncType: PropTypes.oneOf([
    'application/x-www-form-urlencoded',
    'multipart/form-data',
    'text/plain',
  ]),
  formAction: PropTypes.string,
  form: PropTypes.string,
  title: PropTypes.string,
};

export default Button;
