import Input from './../Input';
import { createField, setField, getField } from '../../fieldsRedux';
import { serverAction } from '../../utils/api';
import PropTypes from 'prop-types';
import React, { Component } from 'react';
import { GoTriangleLeft, GoTriangleRight } from 'react-icons/go';

/**
 * @deprecated 
 */
class Cabecalho extends Component {
  state = {
    ready: false,
    focus: false,
    isNew: true
  }

  componentDidUpdate() {
    const { focus, isNew } = this.state;

    if (!focus && !isNew) {
      const { field, receiveUpdates } = this.props;
      const { value, state = [] } = getField(field);

      this.saveReceivedUpdatesValuesInState(field, value, state, receiveUpdates);
    }
  }

  saveReceivedUpdatesValuesInState = (field, value, state, receiveUpdates) => {

    if (value) {

      for (let ru of receiveUpdates) {

        const receivedValue = getField(ru, 'value');

        let exist = false;

        for (let s of state) {

          if (s[0] === value) {
            exist = true;

            if (s[1][ru] !== receivedValue) {

              s[1][ru] = receivedValue;
              setField(field, 'state', state);
            }

            break;
          }
        }

        if (!exist) {
          state.push([value, { [ru]: receivedValue }]);
          setField(field, 'state', state);
        }
      }
    }
  }

  listener = (obj) => {

    const { ready } = this.state;

    if (ready) {
      this.saveState(obj);

    } else if (typeof obj.value === 'object') {

      const { field } = this.props;

      if (obj.value.length > 0) {
        const cabecalho = obj.value[0][0];

        setField(field, 'state', obj.value);
        this.setStates(obj.value, cabecalho);
        this.setState({ isNew: false });
      } else {
        setField(field, 'value', 'Escreva um título para salvar...');
        setField(field, 'active', undefined);
        this.setState({ isNew: true });
      }

    } else if (typeof obj.value !== 'undefined' && typeof obj.defaultValue !== 'undefined') {
      this.setState({ ready: true });
    }
  }

  setStates = (state, cabecalho) => {
    const { field, receiveUpdates } = this.props;

    let activeState = {};

    for (let s of state) {
      if (s[0] === cabecalho) {
        activeState = s[1];
        break;
      }
    }

    this.sendAction(activeState);

    for (let ru of receiveUpdates) {
      setField(ru, 'value', activeState[ru]);
    }

    setField(field, 'value', cabecalho);
    setField(field, 'active', cabecalho);
  }

  sendAction = (activeState) => {
    const { action } = this.props;

    serverAction(action, { state: activeState });
  }

  saveState = (obj) => {

    clearTimeout(this.saveTimeout);

    this.saveTimeout = setTimeout(() => {
      const { field, updateAction } = this.props;

      let state = getField(field, 'state') || {};

      serverAction(updateAction, { states: state });
    }, 350);
  }

  changeActiveState = (nr) => {
    const { field, receiveUpdates } = this.props;
    const { value, state = [], active } = getField(field);

    let index = -1;
    for (let s of state) {
      index++;
      if (s[0] === value) {
        break;
      }
    }

    const newIndex = active ? index + nr : nr > 0 ? 0 : state.length - 1;

    if (newIndex < 0 || newIndex >= state.length) {
      setField(field, 'value', 'Escreva um título para salvar...');
      setField(field, 'active', undefined);

      const activeState = {};
      for (let ru of receiveUpdates) {
        setField(ru, 'value', undefined);
        activeState[ru] = null;
      }

      this.sendAction(activeState);

      this.setState({ isNew: true });
    } else {
      this.setStates(state, state[newIndex][0]);
      this.setState({ isNew: false });
    }

  }

  blur = () => {
    const { isNew } = this.state;

    const { field } = this.props;
    const { value, state = [], active } = getField(field);

    if (!isNew) {
      this.editKeyValue(field, state, value, active);
    } else if (value !== 'Escreva um título para salvar...') {

      state.push([value, {}]);

      setField(field, 'state', state);
      setField(field, 'active', value);

      this.setState({ isNew: false });
    }

    this.setState({ focus: false });
  }

  editKeyValue = (field, state, value, active) => {

    if (value !== active) {

      let index = -1;
      for (let s of state) {
        index++;
        if (s[0] === active) {
          s[0] = value;

          break;
        }
      }

      if (value === '') {
        state.splice(index, 1);
      }

      setField(field, 'state', state);
      setField(field, 'active', value);
    }
  }

  render() {
    const { field, className = '' } = this.props;

    return (
      <div className={`ag-component-cabecalho transition-cubic ${className}`}>
        <div className='ag-arrow-cc' onClick={() => this.changeActiveState(-1)}>
          <GoTriangleLeft size={25} />
        </div>
        <div className='ag-painel-cc'>
          <Input
            field={field}
            fieldListener={this.listener}
            onFocus={() => this.setState({ focus: true })}
            onBlur={this.blur}
            className='ag-input-cabecalho'
          />
        </div>
        <div className='ag-arrow-cc' onClick={() => this.changeActiveState(1)}>
          <GoTriangleRight size={25} />
        </div>
      </div>
    );
  }
}

Cabecalho.propTypes = {
  field: PropTypes.string.isRequired,
  defaultValue: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.object, PropTypes.array]),
  fieldListener: PropTypes.func,
  destroyOnUnmount: PropTypes.bool,
  receiveUpdates: PropTypes.array,
  action: PropTypes.string,
  updateAction: PropTypes.string,
  className: PropTypes.string
};

export default createField(Cabecalho);
