import Visualizacao from './Visualizacao';
import { downloadBase64, downloadFromUrl, geraLog, printUrl, stopPrntScr } from '../../utils/index';
import { Typography, IconButton, Dialog, Toolbar, AppBar, Box } from '@material-ui/core';
import React, { useState } from 'react';
import { MdClose, MdFileDownload, MdPrint } from 'react-icons/md';

const ModalVisualizacaoDocumentos = ({ open, proceed, tokenSistema, ...props }) => {
  const [visualizando, setVisualizando] = useState(props);
  return (
    <Dialog
      fullScreen
      open={open}
      onClose={() => proceed(undefined)}
      onKeyDown={stopPrntScr}
      onContextMenu={(e) => e.preventDefault()}
    >
      <AppBar style={{ position: 'relative' }}>
        <Toolbar>
          <IconButton edge='start' color='inherit' onClick={() => proceed(undefined)}>
            <MdClose />
          </IconButton>
          <Typography variant='h6' style={{ flexGrow: '1' }}>
            {visualizando?.nome}
          </Typography>
          {!visualizando?.sensible && (
            <>
              <IconButton
                onClick={(_) => {
                  if (!visualizando?.linkPronto?.length) {
                    geraLog(visualizando.idDocumento, 'Impressão do documento', '3', tokenSistema);
                  }
                  printUrl(visualizando.URL ? visualizando.URL : visualizando.linkPronto);
                }}
                color='inherit'
                title='Imprimir arquivo'
              >
                <MdPrint />
              </IconButton>
              <IconButton
                onClick={() => {
                  if (!visualizando?.linkPronto?.length) {
                    geraLog(visualizando.idDocumento, 'Download do documento', '3', tokenSistema);
                    downloadFromUrl(visualizando?.URL, visualizando?.nome);
                  } else {
                    downloadBase64(visualizando?.linkPronto, visualizando?.nome);
                  }
                }}
                color='inherit'
                title='Baixar arquivo'
              >
                <MdFileDownload />
              </IconButton>
            </>
          )}
        </Toolbar>
      </AppBar>
      <Box display='flex' justifyContent='center' alignItems='center' width='100%' height='100%'>
        <Visualizacao {...{ setVisualizando, ...visualizando, tokenSistema, proceed }} />
      </Box>
    </Dialog>
  );
};

export default ModalVisualizacaoDocumentos;
