import highlight from 'highlight.js';
import PropTypes from 'prop-types';
import React, { Component } from 'react';
import { findDOMNode } from 'react-dom';

class HighLight extends Component {

  componentDidMount () {
    highlight.highlightBlock(findDOMNode(this.refs.code));
  }

  shouldComponentUpdate(nextProps) {
    if (this.props.language !== nextProps.language || this.props.className !== nextProps.className || this.props.children !== nextProps.children) {
      return true;
    }

    return false;
  }

  componentDidUpdate () {
    highlight.initHighlighting.called = false;
    highlight.highlightBlock(findDOMNode(this.refs.code));
  }

  render () {
    const { children, className, language, style } = this.props;

    return (
      <pre
        className={className}
        style={style}
      >
        <code
          className={language}
          ref='code'
        >
          {children}
        </code>
      </pre>
    );
  }
}

HighLight.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  language: PropTypes.string,
  style: PropTypes.object
};

export default HighLight;
