import { createField, initField, getField, clearField } from '../../fieldsRedux';
import PropTypes from 'prop-types';
import React, { Component } from 'react';

/**
 * @deprecated 
 */
class ListSelect extends Component {

  componentDidMount() {
    const { optionsField, optionsDefaultValue } = this.props;
    initField(optionsField, optionsDefaultValue);
  }

  componentWillUnmount() {
    const { optionsField, destroyOnUnmount } = this.props;

    if (destroyOnUnmount) {
      clearField(optionsField);
    }
  }

  onChange = (val) => {
    const { onChange } = this.props;

    const value = val.toString();

    if (onChange) {
      onChange(value);
    }

    this.props.handleUpdates(value);
  }

  checkListSelectProps = () => {
    const {
      className,
      disabled,
      multiple,
      style,
    } = this.props;

    return {
      className,
      disabled,
      multiple,
      style,
    };
  }

  render() {
    const { checkListSelectProps, onChange } = this;
    const { field, optionsField, optionsValue, optionsLabel, classActive, onMouseDown, liClassName = '' } = this.props;

    const selectProps = checkListSelectProps();
    const value = getField(field, 'value');
    const options = getField(optionsField, 'value');

    return (
      <ul {...selectProps}>
        {options && options.map((item, index) => (<li
          // eslint-disable-next-line
          className={`${value == item[optionsValue] ? classActive : ''} ${liClassName}`} onMouseDown={onMouseDown} key={index} onClick={() => onChange(item[optionsValue])}>{item[optionsLabel]}</li>))}
      </ul>
    );
  }
}

ListSelect.propTypes = {
  field: PropTypes.string.isRequired,
  defaultValue: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.object, PropTypes.array]),
  ajax: PropTypes.bool,
  action: PropTypes.string,
  dados: PropTypes.object,
  sendUpdates: PropTypes.array,
  receiveUpdates: PropTypes.array,
  onChange: PropTypes.func,
  onFieldSuccess: PropTypes.func,
  onActionSuccess: PropTypes.func,
  onAllUpdated: PropTypes.func,
  optionsField: PropTypes.string.isRequired,
  optionsDefaultValue: PropTypes.oneOfType([PropTypes.object, PropTypes.array]),
  optionsValue: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  optionsLabel: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  fieldListener: PropTypes.func,
  destroyOnUnmount: PropTypes.bool,
  className: PropTypes.string,
  style: PropTypes.object,
  classActive: PropTypes.string,
  onMouseDown: PropTypes.func,
  trClassName: PropTypes.string
};

export default createField(ListSelect);
