import { createField, setField, getField, fieldChangeListener } from '../../fieldsRedux';
import PropTypes from 'prop-types';
import React, { Component } from 'react';
import MaskedInput from 'react-maskedinput';

/**
 * @deprecated 
 */
class MonthPicker extends Component {
  mobj = [
    [{
      mes: '01',
      nome: 'Janeiro'
    }, {
      mes: '02',
      nome: 'Fevereiro'
    }, {
      mes: '03',
      nome: 'Março'
    }], [{
      mes: '04',
      nome: 'Abril'
    }, {
      mes: '05',
      nome: 'Maio'
    }, {
      mes: '06',
      nome: 'Junho'
    }], [{
      mes: '07',
      nome: 'Julho'
    }, {
      mes: '08',
      nome: 'Agosto'
    }, {
      mes: '09',
      nome: 'Setembro'
    }], [{
      mes: '10',
      nome: 'Outubro'
    }, {
      mes: '11',
      nome: 'Novembro'
    }, {
      mes: '12',
      nome: 'Dezembro'
    }]
  ];
  state = {
    initialized: false,
    year: 0,
    stageMonths: [],
    selectOpen: false,
    selectOpenClicks: 0
  }

  componentDidMount() {
    this.restYear();
  }

  componentWillUnmount() {
    window.removeEventListener('click', this.closeSelect);
  }

  componentDidUpdate(prevProps) {
    const { field } = this.props;
    fieldChangeListener(field, this.fieldListener, prevProps);
  }

  fieldListener = (fieldObject, prevFieldObject) => {
    const { initialized } = this.state;
    const { fieldListener } = this.props;

    if (!initialized && typeof fieldObject.defaultValue !== 'undefined') {
      if (fieldObject.defaultValue.length > 0) {

        if (typeof fieldObject.value[0] !== 'string') {
          const stringifyedValues = fieldObject.value.map(v => v.toString());
          setField(this.props.field, 'value', stringifyedValues);
        }

        const last = fieldObject.defaultValue[fieldObject.defaultValue.length - 1].toString();
        this.setState({ year: parseInt(last.slice(0, 4), 10) });
      }
      this.handleinputValue(fieldObject.defaultValue);
      this.setState({ initialized: true });
    }

    if (fieldObject.value !== prevFieldObject.value) {
      this.handleinputValue(fieldObject.value ? fieldObject.value : []);
    }

    if (fieldListener) {
      fieldListener(fieldObject);
    }
  }

  onClick = (values, month) => {
    const { year } = this.state;
    const { type = 'single' } = this.props;

    const formatedValue = `${year}${month}`;

    let newValue;
    if (values && values.length > 0) {
      newValue = this.handleExistentValue(values, formatedValue, month);

      if (type === 'stage' || type === 'multiple') {
        newValue = newValue.sort((a, b) => a > b ? 1 : 0);
      }

    } else {
      newValue = [formatedValue];
    }

    this.handleinputValue(newValue);
    this.props.handleUpdates(newValue);

    if (type === 'single' && newValue.length > 0) {
      this.closeSelect();
    }
  }

  handleExistentValue = (value, formatedValue, month) => {
    const { field, type = 'single' } = this.props;
    const indexValue = value.indexOf(formatedValue);

    if (indexValue > -1) {
      value.splice(indexValue, 1);
      return [...value];
    }

    switch (type) {
      case 'single':
        return [formatedValue];
      case 'stage': {

        const fieldValueLgt2 = getField(field, 'value').length === 2;

        const newValue = fieldValueLgt2 ? [formatedValue] : [value[0], formatedValue];

        if (!fieldValueLgt2) {
          this.closeSelect();
        }

        return newValue;
      } case 'multiple':
        return [...value, formatedValue];
      default:
        return [formatedValue];
    }
  }

  handleinputValue = (value) => {
    const { field, type = 'single' } = this.props;
    value = [...value];
    const sortedValues = value.sort((a, b) => a > b ? 1 : 0);
    const inputValues = sortedValues.map(v => `${v.toString().slice(4)}${v.toString().slice(0, 4)}`);

    switch (type) {
      case 'single':
        setField(field, 'inputValue', inputValues[0]);
        break;
      case 'stage':
        setField(field, 'inputValue', `${inputValues[0]}${inputValues[1] ? inputValues[1] : ''}`);
        break;
      case 'multiple': {

        let multipleValue = '';

        for (let v of inputValues) {
          multipleValue += `${v.slice(0, 2)}/${v.slice(2)} `;
        }

        setField(field, 'inputValue', multipleValue);
        break;
      } default:
        setField(field, 'inputValue', inputValues[0]);
    }
  }

  isActive = (values, month) => {
    const { year, stageMonths } = this.state;
    const formatedValue = `${year}${month}`;

    return `${values.indexOf(formatedValue) < 0 ? '' : 'active'} ${stageMonths.indexOf(formatedValue) < 0 ? '' : 'hovered'}`;
  }

  restYear = () => {
    const date = new Date();
    this.setState({ year: date.getFullYear() });
  }

  onValueCapture = (v) => {
    const { field } = this.props;
    let value = v.target.value;
    setField(field, 'inputValue', value);
    value = value.replace(/\D+/g, '');

    const valueLength = value.length;

    let resolvedValues = [];
    if (valueLength >= 6) {
      const resto = valueLength % 6;
      const valueAux = value.slice(0, valueLength - resto);

      const length = valueAux.length / 6;

      for (let i = 0; i < length; i++) {
        const aux = i * 6;
        const mes = valueAux.slice(aux, aux + 2);
        const ano = valueAux.slice(aux + 2, aux + 6);

        if (parseInt(mes, 10) <= 12 && parseInt(mes, 10) >= 1) {
          resolvedValues.push(`${ano}${mes}`);
        }
      }
    }

    this.props.handleUpdates(resolvedValues);
  }

  openSelect = () => {

    const { selectOpen } = this.state;

    if (!selectOpen) {
      this.setState({ selectOpen: true, selectOpenClicks: 0 });
      window.addEventListener('click', this.closeSelect);
    }
  }

  closeSelect = () => {
    const { selectOpenClicks } = this.state;

    if (selectOpenClicks > 0) {

      this.setState({ selectOpen: false });
      window.removeEventListener('click', this.closeSelect);
    }
    this.setState({ selectOpenClicks: selectOpenClicks + 1 });
  }

  render() {
    const { field, type = 'single' } = this.props;
    const { year, selectOpen } = this.state;
    const values = getField(field, 'value');
    const inputValue = getField(field, 'inputValue');

    const mask = type === 'single' ? '11/1111' : '11/1111 à 11/1111';

    return (
      <div className='monthPickermaxwidth'>
        {(type === 'single' || type === 'stage') && (
          <MaskedInput value={inputValue} onClick={this.openSelect} onChange={this.onValueCapture} mask={mask} className='pg-monthpicker-input' />
        )}
        {type === 'multiple' && (
          <input value={inputValue} onClick={this.openSelect} onChange={this.onValueCapture} className='pg-monthpicker-input' />
        )}
        {selectOpen && (
          <div onClick={e => e.stopPropagation()} className='monthPickerSelect'>
            <div className='pg-monthpicker-year' onClick={this.restYear}>
              {year}
            </div>
            <div className='system-btn-group pull-left' style={{ width: '100%' }}>
              <span onClick={() => this.setState({ year: year - 1 })} className='btn system-btn-white' style={{ width: '50%', borderRadius: 0 }}>
                <i className='glyphicon glyphicon-chevron-left'></i>
              </span>
              <span onClick={() => this.setState({ year: year + 1 })} className='btn system-btn-white' style={{ width: '50%', borderRadius: 0 }}>
                <i className='glyphicon glyphicon-chevron-right'></i>
              </span>
            </div>
            <table className='table table-bordered table-monthpicker'>
              <tbody>
                {this.mobj.map((item, index) => (
                  <tr key={index}>
                    {item.map((month, index) => (
                      <td
                        key={index}
                        className={this.isActive(values, month.mes)}
                        onClick={() => this.onClick(values, month.mes)}
                      >
                        {month.nome}
                      </td>
                    ))}
                  </tr>
                ))}
              </tbody>
            </table>
          </div>
        )}
      </div>
    );
  }
}

MonthPicker.propTypes = {
  field: PropTypes.string.isRequired,
  defaultValue: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.object, PropTypes.array]),
  ajax: PropTypes.bool,
  action: PropTypes.string,
  dados: PropTypes.object,
  receiveUpdates: PropTypes.array,
  sendUpdates: PropTypes.array,
  onFieldSuccess: PropTypes.func,
  onActionSuccess: PropTypes.func,
  onAllUpdated: PropTypes.func,
  fieldListener: PropTypes.func,
  destroyOnUnmount: PropTypes.bool,
  type: PropTypes.oneOf(['single', 'stage', 'multiple'])
};

export default createField(MonthPicker, { disableFieldChangeListener: true });
