import { createField, getField } from '../../fieldsRedux';
import PropTypes from 'prop-types';
import React, { Component } from 'react';

/**
 * @deprecated 
 */
class OutputText extends Component {

  handleDecimalValues = (value) => {
    const { decimalSeparator, decimalScale } = this.props;

    if (typeof decimalScale !== 'undefined') {
      try {
        if (!isNaN(value))
          value = parseFloat(value, 10).toFixed(decimalScale);
      } catch (e) { }
    }

    if (decimalSeparator) {
      value = value.replace('.', decimalSeparator);
    }

    return value;
  }

  render() {
    const { field, renderize = 'span', className, style, prefixo = '', sufixo = '' } = this.props;

    let value = getField(field, 'value');
    value = typeof value !== 'object' ? value : JSON.stringify(value);
    value = this.handleDecimalValues(value);
    value = `${prefixo}${value}${sufixo}`;

    return React.createElement(
      renderize,
      { className, style },
      value
    );
  }
}

OutputText.propTypes = {
  field: PropTypes.string.isRequired,
  defaultValue: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.object, PropTypes.array]),
  className: PropTypes.string,
  style: PropTypes.object,
  renderize: PropTypes.string,
  fieldListener: PropTypes.func,
  destroyOnUnmount: PropTypes.bool,
  prefixo: PropTypes.string,
  sufixo: PropTypes.string,
  decimalSeparator: PropTypes.string,
  decimalScale: PropTypes.number,
};

export default createField(OutputText);
