import PropTypes from 'prop-types';
import React, { Component } from 'react';

/**
 * @deprecated 
 */
class ProgressBar extends Component {

  getProgressType = () => {
    const { type } = this.props;

    switch (type) {
      case 'success':
        return 'bg-success';
      case 'warning':
        return 'bg-warning';
      case 'purple':
        return 'bg-purple';
      case 'yellow':
        return 'bg-yellow';
      case 'danger':
        return 'bg-danger';
      default:
        return 'bg-blue-alt';
    }
  }

  render() {
    const { getProgressType } = this;
    const {
      padding = '2px',
      fontSize = '13px',
      showValue = true,
      value = 0,
      trailClass = '',
      progressClass = ''
    } = this.props;

    const stylesValue = {
      width: `${ value }%`,
      paddingTop: padding,
      paddingBottom: padding,
      fontSize: fontSize
    };

    return (
      <div title={`${ value }%`} className={`argous-progress-bar ${ trailClass }`}>
        <div className={`${ progressClass } ${ getProgressType() }`} style={stylesValue}>{showValue && `${ value }%`}</div>
      </div>
    );
  }
}

ProgressBar.propTypes = {
  value: PropTypes.number,
  fontSize: PropTypes.string,
  padding: PropTypes.string,
  showValue: PropTypes.bool,
  type: PropTypes.oneOf([
    'blue',
    'success',
    'warning',
    'purple',
    'yellow',
    'danger'
  ]),
  trailClass: PropTypes.string,
  progressClass: PropTypes.string
};

export default ProgressBar;
