import { createField, initField, getField, clearField } from '../../fieldsRedux';
import PropTypes from 'prop-types';
import React, { Component } from 'react';

/**
 * @deprecated 
 */
class Select extends Component {

  componentDidMount() {
    const { optionsField, optionsDefaultValue } = this.props;
    initField(optionsField, optionsDefaultValue);
  }

  componentWillUnmount() {
    const { optionsField, destroyOnUnmount, keepOptions } = this.props;

    if (destroyOnUnmount && !keepOptions) {
      clearField(optionsField);
    }
  }

  onChange = (event) => {
    const { onChange } = this.props;

    const value = event.target.value;

    if (onChange) {
      onChange(value);
    }

    this.props.handleUpdates(value);
  }

  checkSelectProps = () => {
    const {
      field,
      autoFocus,
      disabled,
      form,
      multiple,
      name,
      required,
      size,
      style,
    } = this.props;

    const value = getField(field, 'value');

    const className = `${this.props.className
      ? this.props.className
      : 'form-control'}`;

    const onChange = this.onChange;

    return {
      value,
      onChange,
      className,
      autoFocus,
      disabled,
      form,
      multiple,
      name,
      required,
      size,
      style,
    };
  }

  render() {
    const { checkSelectProps } = this;
    const { optionsField, optionsValue, optionsLabel, children } = this.props;

    const selectProps = checkSelectProps();
    const options = getField(optionsField, 'value');

    return (
      <select {...selectProps}>
        {children}
        {options.length > 0 && options.map((item, index) => (<option key={index} value={item[optionsValue]} label={item[optionsLabel]}>{item[optionsLabel]}</option>))}
      </select>
    );
  }
}

Select.propTypes = {
  field: PropTypes.string.isRequired,
  defaultValue: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.object, PropTypes.array]),
  ajax: PropTypes.bool,
  action: PropTypes.string,
  dados: PropTypes.object,
  sendUpdates: PropTypes.array,
  receiveUpdates: PropTypes.array,
  onChange: PropTypes.func,
  onFieldSuccess: PropTypes.func,
  onActionSuccess: PropTypes.func,
  onAllUpdated: PropTypes.func,
  optionsField: PropTypes.string.isRequired,
  optionsDefaultValue: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.object, PropTypes.array]),
  optionsValue: PropTypes.string,
  optionsLabel: PropTypes.string,
  fieldListener: PropTypes.func,
  destroyOnUnmount: PropTypes.bool,
  children: PropTypes.node,
  className: PropTypes.string,
  style: PropTypes.object,
  autoFocus: PropTypes.bool,
  disabled: PropTypes.bool,
  form: PropTypes.string,
  multiple: PropTypes.bool,
  name: PropTypes.string,
  required: PropTypes.bool,
  size: PropTypes.string
};

export default createField(Select);
