import { createField, getField } from '../../fieldsRedux';
import PropTypes from 'prop-types';
import React, { Component } from 'react';

/**
 * @deprecated 
 */
class TextArea extends Component {

  componentWillUnmount() {
    if (this.props.stopWriting) {
      clearTimeout(this.stopWritingTimeout);
    }
  }

  onChange = (event) => {
    const { onChange } = this.props;

    const value = event.target.value;

    if (onChange) {
      onChange(value);
    }

    this.props.handleUpdates(value);
    this.stopWritingHandler(value);
  }

  stopWritingHandler = (value) => {
    const { stopWriting, stopWritingTime = 2000 } = this.props;

    if (stopWriting) {
      clearTimeout(this.stopWritingTimeout);
      this.stopWritingTimeout = setTimeout(() => {
        stopWriting(value);
      }, stopWritingTime);
    }
  }

  checkTextAreaProps = () => {
    const {
      field,
      autoComplete,
      autoFocus,
      cols,
      rows,
      disabled,
      form,
      maxLength,
      minLength,
      name,
      placeholder,
      spellCheck,
      wrap,
      style,
    } = this.props;

    const className = `${this.props.className ? this.props.className : 'form-control'}`;
    const onChange = this.onChange;
    const value = getField(field, 'value');

    return {
      className,
      onChange,
      value,
      autoComplete,
      autoFocus,
      cols,
      rows,
      disabled,
      form,
      maxLength,
      minLength,
      name,
      placeholder,
      spellCheck,
      wrap,
      style
    };
  }

  render() {
    const { checkTextAreaProps } = this;

    const textAreaProps = checkTextAreaProps();

    return (<textarea {...textAreaProps} />);
  }
}

TextArea.propTypes = {
  field: PropTypes.string.isRequired,
  defaultValue: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.object, PropTypes.array]),
  ajax: PropTypes.bool,
  action: PropTypes.string,
  dados: PropTypes.object,
  sendUpdates: PropTypes.array,
  receiveUpdates: PropTypes.array,
  onChange: PropTypes.func,
  onFieldSuccess: PropTypes.func,
  onActionSuccess: PropTypes.func,
  onAllUpdated: PropTypes.func,
  fieldListener: PropTypes.func,
  destroyOnUnmount: PropTypes.bool,
  autoComplete: PropTypes.oneOf(['on', 'off']),
  autoFocus: PropTypes.bool,
  cols: PropTypes.string,
  rows: PropTypes.string,
  disabled: PropTypes.bool,
  form: PropTypes.string,
  maxLength: PropTypes.string,
  minLength: PropTypes.string,
  className: PropTypes.string,
  style: PropTypes.object,
  name: PropTypes.string,
  placeholder: PropTypes.string,
  spellCheck: PropTypes.oneOf(['default', 'true', 'false']),
  wrap: PropTypes.oneOf(['hard', 'soft', 'off']),
  stopWriting: PropTypes.func,
  stopWritingTime: PropTypes.number
};

export default createField(TextArea);
