import React, { useEffect, useRef } from 'react';


const Cursor = ({ id, speed = 500, className }) => {

  const cursorId = `${id}-cursor-component`;
  const intervalIdRef = useRef(null);


  useEffect(() => {
    const cursorElement = document.getElementById(cursorId);
    if (cursorElement) cursorElement.style.opacity = '1';
    intervalIdRef.current = setInterval(() => {
      if (cursorElement) cursorElement.style.opacity = (cursorElement.style.opacity === '0') ? '1' : '0';
    }, speed);
    return () => clearInterval(intervalIdRef.current);
  });


  return <span id={cursorId} className={`${className}`}>|</span>;
};


export default Cursor;