import { clearField, setField, getField, waitFieldsData, setServerValueToField, setFieldValueToServer, getPreviousField, setFieldsByObject, getFieldsByPrefix } from './fieldsRedux';
import React, { Component } from 'react';
import { connect } from 'react-redux';

/**
 * @deprecated
 * @param {*} WrappedComponent - 
 * @returns {*} -
 */
const passFields = (WrappedComponent) => {

  class HOCComponent extends Component {

    getField = (field, key) => {
      return getField(field, key);
    }

    getPreviousField = (p1, p2, p3) => {
      return getPreviousField(p1, p2, p3);
    }

    setField = (p1, p2, p3) => {
      if (typeof p2 === 'object') {
        return setField(p1, p2);
      } 
      return setField(p1, p2, p3);
      
    }

    setFieldsByObject = (object, prefix) => {
      setFieldsByObject(object, prefix);
    }

    getFieldsByPrefix = (prefix, letPrefix) => {
      return getFieldsByPrefix(prefix, letPrefix);
    }

    waitFieldsData = (wFields = [], wDatas = [], rejectMilliseconds = 5000, milliseconds = 100) => {
      return waitFieldsData(wFields, wDatas, rejectMilliseconds, milliseconds);
    }

    setServerValueToField = (field) => {
      return setServerValueToField(field);
    }

    setFieldValueToServer = (field) => {
      return setFieldValueToServer(field);
    }

    clearField = (field) => {
      clearField(field);
    }

    render() {
      return <WrappedComponent
        getField={this.getField}
        getPreviousField={this.getPreviousField}
        setField={this.setField}
        waitFieldsData={this.waitFieldsData}
        setServerValueToField={this.setServerValueToField}
        setFieldValueToServer={this.setFieldValueToServer}
        clearField={this.clearField}
        setFieldsByObject={this.setFieldsByObject}
        getFieldsByPrefix={this.getFieldsByPrefix}
        {...this.props} />;
    }
  }

  const mapStateToProps = (state) => {
    return { fields: state.argous.fields };
  };

  return connect(mapStateToProps)(HOCComponent);
};

export default passFields;
