import { ActionType } from '../types';

const argous = (state = {
  usuarioLogado: {},
  loading: true,
  processos: [],
  favorites: [],
  initialPage: '/',
  fields: {},
  block: false,
  vldPsw: false,
  sidebar: true,
  rightSidebar: false,
  addProgramWidget: undefined,
  programAnnotation: {}
}, action: ActionType) => {
  switch (action.type) {
    case 'setUsuarioLogado':
      return {
        ...state,
        usuarioLogado: action.usuarioLogado
      };
    case 'setLoading':
      return {
        ...state,
        loading: action.loading
      };
    case 'setProcesso':
      return {
        ...state,
        processos: action.processo
      };
    case 'setNotificacao':
      return {
        ...state,
        notificacao: action.notificacao
      };
    case 'setInitialPage':
      return {
        ...state,
        initialPage: action.initialPage
      };
    case 'setCurrentProgram':
      return {
        ...state,
        currentProgram: action.currentProgram
      };
    case 'setCurrentField':
      return {
        ...state,
        fields: state.fields[action.program]
          ? {
            ...state.fields,
            [action.program]: {
              ...state.fields[action.program],
              [action.field]: action.value
            }
          }
          : {
            ...state.fields,
            [action.program]: {
              [action.field]: action.value
            }
          }
      };
    case 'clearAllFields':
      return {
        ...state,
        fields: {}
      };
    case 'setFields':
      return {
        ...state,
        fields: action.fields
      };
    case 'setFavorites':
      return {
        ...state,
        favorites: action.favorites
      };
    case 'setBlockUser':
      return {
        ...state,
        block: action.block
      };
    case 'setVldPsw':
      return {
        ...state,
        block: action.vldPsw
      };
    case 'setSidebar':
      return {
        ...state,
        sidebar: action.sidebar
      };
    case 'setRightSidebar':
      return {
        ...state,
        rightSidebar: action.rightSidebar
      };
    case 'setAddProgramWidget':
      return {
        ...state,
        addProgramWidget: action.addProgramWidget
      };
    case 'setMensagensNaoLidas':
      return {
        ...state,
        mensagensNaoLidas: action.mensagensNaoLidas
      };
    case 'setProgramAnnotation':
      return {
        ...state,
        programAnnotation: action.programAnnotation
      };
    default:
      return state;
  }
};

export default argous;