import { addExtraZero } from '.';

export const getMonthName = (nr: number) => {
  switch (nr) {
    case 0: return 'Janeiro';
    case 1: return 'Fevereiro';
    case 2: return 'Março';
    case 3: return 'Abril';
    case 4: return 'Maio';
    case 5: return 'Junho';
    case 6: return 'Julho';
    case 7: return 'Agosto';
    case 8: return 'Setembro';
    case 9: return 'Outubro';
    case 10: return 'Novembro';
    case 11: return 'Dezembro';
    default: return '';
  }
};

export const getDayName = (day: number) => {
  switch (day) {
    case 1: return 'Segunda';
    case 2: return 'Terça';
    case 3: return 'Quarta';
    case 4: return 'Quinta';
    case 5: return 'Sexta';
    case 6: return 'Sábado';
    default: return 'Domingo';
  }
};

export const convertMinutesToHour = (minutes: number) => {
  const dtAux = new Date(0, 0, 0, 0, 0, 0, 0);
  dtAux.setMinutes(minutes);

  return `${addExtraZero(dtAux.getHours())}:${addExtraZero(dtAux.getMinutes())}`;
};

export const sqlDateToReadableDate = (sqlDate: string) => {

  const readableDate = { date: '', hour: '' };

  if (sqlDate.length > 10) {
    const date = sqlDate.slice(0, 10).split('-');

    readableDate.date = `${date[2]}/${date[1]}/${date[0]}`;

    if (sqlDate.indexOf(' ') > -1) {
      const hour = sqlDate.split(' ')[1].split(':');

      readableDate.hour = `${hour[0]}:${hour[1]}`;
    }
  }

  return readableDate;
};

export const fixInvalidDate = (date: string) => {
  if (!date || typeof date !== 'string') return date;
  const splitDate = date.split(' ');
  return `${splitDate[0]} ${splitDate[1].split(':').map(t => addExtraZero(t)).join(':')}`;
};